package gov.va.med.mhv.imaging;

import gov.va.med.mhv.imaging.transfer.FilesTO;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.StreamingOutput;

@Produces({"application/xml","application/json","application/octet-stream"})
@Consumes({"application/xml","application/json"})
public interface ImagingService {
	
	@GET
	@Path("/study/zip/{studyId}")
	@Produces("application/zip")
	public StreamingOutput getZipFile(@javax.ws.rs.PathParam("studyId") String studyId);

	@GET
	@Path("/study/filelist/{studyId}")
	@Produces("application/json")
	public FilesTO getFileList(@javax.ws.rs.PathParam("studyId") String studyId);
	
	@GET
	@Path("/study/file")
	@Produces("application/octet-stream")
	public StreamingOutput getFile(@javax.ws.rs.QueryParam("fileType") String fileType, @javax.ws.rs.QueryParam("fileId") String fileId );
	
}
