package client;

import gov.va.med.mhv.api.transfer.FacilityExtractStatusesTO;
import gov.va.med.mhv.api.transfer.GenerateReportTO;
import gov.va.med.mhv.api.util.ClientApplicationHelper;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import javax.ws.rs.core.MultivaluedHashMap;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Response;

import org.apache.commons.httpclient.util.DateUtil;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.ext.multipart.Attachment;
import org.apache.cxf.jaxrs.ext.multipart.ContentDisposition;
import org.apache.cxf.jaxrs.ext.multipart.MultipartBody;
import org.codehaus.jackson.JsonGenerationException;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;

public class TestClient {
	static String HOST="http://localhost:7001";
	//static String HOST ="http://serverserver1.domain.ext:7010";
	
	static List<Object> PROVIDERS = new ArrayList<Object>();
    static {
    	PROVIDERS.add(new org.codehaus.jackson.jaxrs.JacksonJsonProvider());
    	//HOST="http://localhost";
    	//HOST="http://serverserver1.domain.ext:7010";
    }
    
	public static void main(String[] args) {
		// SEQUENCE_TEST();
		//MHV_API_TEST();
		//TEST_PHR_REFRESH();
		//TEST_PHR_STATUS();
		//TEST_DOWNLOAD_REPORT();
		TEST_GENERATE_REPORT();
		
		
	}
	public static void MHV_API_TEST() {
		long s = System.currentTimeMillis();
		
		App app = new App(ClientApplicationHelper.findClientApplication(100l).getAppToken());

		User user = new User(2579001l); //For local Test

		ClientSession session = new ClientSession();
	
		s = System.currentTimeMillis();
//		session= testGetSession( prepareHeaders( app, user ), "application/json", "application/json");
		System.out.println("testGetSession  Took: " + (System.currentTimeMillis()-s) +" ms " + session.getExpires() + " " +session.getToken());
	
		//testBBApiService(prepareHeaders( session ), "application/json", "application/json");
		testBBApiService(prepareHeadersStandAlone("qhEH6XJucS-PO5VxDQvjK", 2579001l, 
				"O13lotAEFKA=DY/iTOLfm2A0Es3uBl0AgqEj6YMcp2XrFaFjfK59qRQ="), "application/json", "application/json");
		/*
		MultivaluedMap<String,String>headers = new MultivaluedHashMap<String, String>();
		headers.putSingle("userId", String.valueOf("2579001"));
		
		Response r = null;
		WebClient client = null;
		try {
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/bbreport", PROVIDERS);
			client.headers(headers);
			client.type("application/json").accept("application/json");
			r=client.post("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			client.close();
		}
		Boolean statue = (r==null?false:r.getStatus()==200);	
		*/
		System.out.println("testBBApiService Took: " + (System.currentTimeMillis()-s) +" ms");
		System.out.println("BB API SERVICE DONE: ");
	}
	
	public static void TEST_PHR_REFRESH() {

		long s = System.currentTimeMillis();
		
		App app = new App(ClientApplicationHelper.findClientApplication(100l).getAppToken());

		User user = new User(2579001l); //For local Test

		ClientSession session = new ClientSession();
	
		s = System.currentTimeMillis();
		session= testGetSession( prepareHeaders( app, user ), "application/json", "application/json");
		System.out.println("testGetSession  Took: " + (System.currentTimeMillis()-s) +" ms " + session.getExpires() + " " +session.getToken());
	
		testBBApiRefresh(prepareHeaders( session ), "application/json", "application/json");
	
		System.out.println("testBBApiRefresh Took: " + (System.currentTimeMillis()-s) +" ms");
		System.out.println("BB API SERVICE REFRESH DONE: ");
	}
	
	public static void TEST_PHR_STATUS() {

		long s = System.currentTimeMillis();
		
		App app = new App(ClientApplicationHelper.findClientApplication(100l).getAppToken());

		User user = new User(2579001l); //For local Test

		ClientSession session = new ClientSession();
	
		s = System.currentTimeMillis();
		session= testGetSession( prepareHeaders( app, user ), "application/json", "application/json");
		System.out.println("testGetSession  Took: " + (System.currentTimeMillis()-s) +" ms " + session.getExpires() + " " +session.getToken());
	
		testBBApiStatus(prepareHeaders( session ), "application/json", "application/json");
	
		System.out.println("testBBApiRefresh Took: " + (System.currentTimeMillis()-s) +" ms");
		System.out.println("BB API SERVICE REFRESH DONE: ");

		
	}
	
	public static void TEST_DOWNLOAD_REPORT () {
		long s = System.currentTimeMillis();
		
		App app = new App(ClientApplicationHelper.findClientApplication(100l).getAppToken());

		User user = new User(2579001l); //For local Test

		ClientSession session = new ClientSession();
	
		s = System.currentTimeMillis();
		session= testGetSession( prepareHeaders( app, user ), "application/json", "application/json");
		System.out.println("testGetSession  Took: " + (System.currentTimeMillis()-s) +" ms " + session.getExpires() + " " +session.getToken());
	
		testBBApiDownloadApi(prepareHeaders( session ), "application/json", "application/json");
	
		System.out.println("testBBApiDownloadApi Took: " + (System.currentTimeMillis()-s) +" ms");
		System.out.println("BB API SERVICE DOWNLOAD REPORT DONE: ");
	}

	public static void TEST_GENERATE_REPORT() {
		long s = System.currentTimeMillis();
		
		App app = new App(ClientApplicationHelper.findClientApplication(100l).getAppToken());

		User user = new User(2579001l); //For local Test

		ClientSession session = new ClientSession();
	
		s = System.currentTimeMillis();
		session= testGetSession( prepareHeaders( app, user ), "application/json", "application/json");
		System.out.println("testGetSession  Took: " + (System.currentTimeMillis()-s) +" ms " + session.getExpires() + " " +session.getToken());
	
		testGenerateReport(prepareHeaders( session ), "application/json", "application/json");
	
		System.out.println("testBBApiDownloadApi Took: " + (System.currentTimeMillis()-s) +" ms");
		System.out.println("BB API SERVICE GENERATE REPORT DONE: ");		
	}
	
	public static boolean testBBApiService( MultivaluedMap<String,String>headers, String contentType, String acceptType ) {
		Response r = null;
		WebClient client = null;
		try {
			//224422
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/bbreport", PROVIDERS);
	        client.headers(headers);
			client.type(contentType).accept(acceptType);
			r=client.post("");
	
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			//client.close();
		}
		return (r==null?false:r.getStatus()==200);
	}
	
	public static boolean testBBApiRefresh( MultivaluedMap<String,String>headers, String contentType, String acceptType ) {
		Response r = null;
		WebClient client = null;
		try {
			
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/refresh", PROVIDERS);
	        client.headers(headers);
			client.type(contentType).accept(acceptType);
			r=client.post("");
	
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			//client.close();
		}
		return (r==null?false:r.getStatus()==200);
	}
	
	public static boolean testBBApiStatus( MultivaluedMap<String,String>headers, String contentType, String acceptType ) {
		Response r = null;
		WebClient client = null;
		try {
			
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/extractstatus", PROVIDERS);
	        client.headers(headers);
			client.type(contentType).accept(acceptType);
			String resp = client.get(String.class);
			System.out.println("RESPONSE: " + resp);
			ObjectMapper mapper = new ObjectMapper();
			FacilityExtractStatusesTO message2 = mapper.readValue(resp, FacilityExtractStatusesTO.class);
			message2.getFacilityExtractStatusList();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			//client.close();
		}
		return (r==null?false:r.getStatus()==200);
	}
	
	public static boolean testBBApiDownloadApi( MultivaluedMap<String,String>headers, String contentType, String acceptType ) {
		Response r = null;
		WebClient client = null;
		try {
			
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/bbreport/pdf", PROVIDERS);
	        client.headers(headers);
			client.type(contentType).accept(acceptType);
			byte[] resp = client.get(byte[].class);
			FileOutputStream fos = new FileOutputStream(new File("C://temp//bbReport.pdf"));  
			fos.write(resp);
              fos.close();

			
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			//client.close();
		}
		return (r==null?false:r.getStatus()==200);
	}
	public static boolean testGenerateReport( MultivaluedMap<String,String>headers, String contentType, String acceptType ) {
		Response r = null;
		WebClient client = null;
		try {
			client = WebClient.create(HOST +"/mhv-api/patient/v1/bluebutton/2579001/generate", PROVIDERS);
	        client.headers(headers);
			client.type(contentType).accept(acceptType);
			
			String startDate = "Tue, 01 Jan 2013 00:00:00 GMT";
			String endDate = "Sun, 01 Jan 2014 00:00:00 GMT";
			List dataC = new ArrayList();
			dataC.add("allergy");
			String[] dataList = {"allergy","chem","appts", "allergy"};
			GenerateReportTO genRepTO = new GenerateReportTO(startDate, endDate, dataList);
			r=client.post( genRepTO );
		} catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			//client.close();
		}
		return (r==null?false:r.getStatus()==200);	
	}
	
	private static ClientSession testGetSession(MultivaluedMap<String, String>headers, String contentType, String acceptType ) {
		WebClient client = WebClient.create(HOST+"/mhv-api/patient/v1/session");
		Response r = null;
		try {
			client.headers(headers);
			client.type(contentType).accept(acceptType);
			r = client.get();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(r==null) {
			throw new RuntimeException("Unable to create a session");
		}
		ClientSession s=new ClientSession(r.getHeaderString("Token"),r.getHeaderString("Expires"));
		
		return s;
	}
	
	public static MultivaluedMap<String,String> prepareHeaders( App app, User user ) {
		return prepareHeaders( app, user, null);
	}
	
	public static MultivaluedMap<String,String> prepareHeaders( App app, User user, ClientSession session ) {
		MultivaluedMap<String,String>headers = new MultivaluedHashMap<String, String>();
		if( null != app ) {
			headers.putSingle("appToken", app.getToken());
		}
		if( null != session ) {
			headers.putSingle("Token", session.getToken());
		}
		else if( null != user ) {
			headers.putSingle("mhvCorrelationId", String.valueOf(user.getMhvCorrelationId()));
		}
		return headers;
	}
	public static MultivaluedMap<String,String> prepareHeaders( ClientSession session ) {
		return prepareHeaders( null, null, session);
	}
	public static MultivaluedMap<String,String> prepareHeadersStandAlone( String appToken, Long mhvCorrId, String token) {
		MultivaluedMap<String,String>headers = new MultivaluedHashMap<String, String>();
		
			headers.putSingle("appToken", appToken);
			headers.putSingle("Token", token);
			headers.putSingle("mhvCorrelationId", String.valueOf(mhvCorrId));
		
		return headers;
	}	
}
class User {
	private Long mhvCorrelationId;
	public User(Long mhvCorrelationId) {
		this.mhvCorrelationId = mhvCorrelationId;
	}
	public Long getMhvCorrelationId() {
		return mhvCorrelationId;
	}
	public void setMhvCorrelationId(Long mhvCorrelationId) {
		this.mhvCorrelationId = mhvCorrelationId;
	}
}

class App {
	private String token;
	public App(String token) {
		this.token=token;
	}
	public String getToken() {
		return token;
	}
	public void setToken(String token) {
		this.token = token;
	}
}

class ClientSession {
	private String token = "Not set";
	private String expires = "Not set";
	public ClientSession(){}
	public ClientSession(String token, String expires) {
		this.token=token;
		this.expires=expires;
	}
	public String getToken() {
		return token;
	}
	public void setToken(String token) {
		this.token = token;
	}
	public String getExpires() {
		return expires;
	}
	public void setExpires(String expires) {
		this.expires = expires;
	}
	public boolean isExpired() throws Exception {
		return isExpiring(0);
	}
	public boolean isExpiring(int seconds) throws Exception {
		Date timestamp = DateUtil.parseDate(expires);
		long currentTimeinSec = TimeUnit.MILLISECONDS.toSeconds(System.currentTimeMillis());
		long timeSeconds = TimeUnit.MILLISECONDS.toSeconds(timestamp.getTime());
		if ((currentTimeinSec - timeSeconds) <= seconds) {
			return false;
		} else {
			return true;
		}
	}
	public String toString() {
		try {
			return "ClientSession: {expires="+expires+";isExpired="+isExpired()+";isExpiring(in 60 sec)="+isExpiring(60)+";token=" + token + "}";
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "Error";
	}
}