package gov.va.med.mhv.imaging;
import gov.va.med.mhv.imaging.transfer.FileTO;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.codehaus.jackson.JsonParseException;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;


public class TestClientJszip {
	
	private HttpURLConnection httpConn;
	private static String HOST = "{HOST}";
	
	private static String CURRENTHOST = "localhost:7001";
	private static int cnt = 0;
	
	public static void main(String argv[]) {
		try {
			//List<Map> files = (List<Map>)getStudyFileList("660-19379").get("files");
			Map map = getStudyFileList("678-588");
			List<Map> files = (List<Map>)map.get("files");
			System.out.println(">"+files);
			
			System.out.println("Filename: " + map.get("zipFileName"));
			
			//List<FileTO> list = new ObjectMapper().readValue(files, new TypeReference<List<FileTO>>() { });
			//FileTO[] array = new ObjectMapper().readValue(files, FileTO[].class);
			int cnt = 1;
			for( Map f: files) {
				//getStudyFile(f.getType(),f.getFileId());
				//System.out.println("FileId:" + f.get("fileId"));
				//System.out.println("Type:" + f.get("type"));
				
				f.get("path");
				
				if(( (String)f.get("type")).equals("report") || ((String)f.get("type")).equals("image") ) {
					System.out.println("Getting file " + (cnt++) + " of " + f.size() );
					HTTPFile hf = getStudyFile((String)f.get("type"),(String)f.get("fileId"));
					
					System.out.println(">>Adding to ZIP: " + f.get("path") + hf.getName() );
				}
			}
			
		} catch (JsonParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (JsonMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//getStudyFile("report","urn:vastudy:660-19379-{ICN}");
		//getStudyFile("image","imageURN=urn:vaimage:756-19334-19333-{ICN}-CR&imageQuality=90&contentType=application/dicom,image/j2k,application/dicom,image/x-targa,*/*");
	}	
		
	public static Map getStudyFileList(String studyid) throws JsonParseException, JsonMappingException, IOException {
		String url = ("http://{HOST}/ImagingService/mhvapi/v1/phrmgr/study/filelist/"+studyid).replace(HOST, CURRENTHOST);
		String out = "";
		try {
			out = new String(new TestClientJszip().setupGetRequest(url, new HashMap<String, String>()).sendRequest());
			//System.out.println(out);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return new ObjectMapper().readValue(out, Map.class);
	}
	
	public static HTTPFile getStudyFile(String fileType, String fileId) {
		String url;
		HTTPFile res = null;
		try {
			url = ("http://{HOST}/ImagingService/mhvapi/v1/phrmgr/study/file?fileType="+fileType+"&fileId="+URLEncoder.encode(fileId,"UTF-8")).replace(HOST, CURRENTHOST);
			res = new TestClientJszip().setupGetRequest(url, new HashMap<String, String>()).sendRequestForFile();
			//System.out.println("Output length: " + out.length);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return res;
	}
	
	public TestClientJszip() {
	}
	
	private TestClientJszip setupGetRequest(String requestURL, Map<String, String> headers) throws IOException {
		System.out.println("Calling GET " + requestURL);
		URL url = new URL(requestURL);
		httpConn = (HttpURLConnection) url.openConnection();

		httpConn.setUseCaches(false);
		httpConn.setDoOutput(false); // false indicates GET method
		httpConn.setDoInput(true);
		for (String key : headers.keySet()) {
			httpConn.setRequestProperty(key, headers.get(key));
		}
		httpConn.setRequestProperty("User-Agent", "CodeJava Agent");
		return this;
	}

	private byte[] sendRequest() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream(8*1024);
		
		// checks server's status code first
		int status = httpConn.getResponseCode();
		if (status == HttpURLConnection.HTTP_OK) {
			
			String fn = httpConn.getHeaderField("Content-Disposition");
			if( fn != null ){ 
				fn = fn.substring(fn.indexOf("\"")+1, fn.lastIndexOf("\""));
				System.out.println("Filename = " + fn);
			}
			
			BufferedInputStream input = new BufferedInputStream( httpConn.getInputStream() );
			byte[] bucket = new byte[32*1024]; 
			System.out.println("Reading"); 
			int bytesRead = 0;
			cnt=0;
	        while(bytesRead != -1){
	          bytesRead = input.read(bucket);
	          if(bytesRead > 0){
	        	cnt++;
	        	log(bytesRead, bucket);
	            baos.write(bucket, 0, bytesRead);
	          }
	        }
			System.out.println("\n(Bytes: " + baos.size() + ")");
		} else {
			throw new IOException("Response: " + status + " was returned by cvix");
		}
		return baos.toByteArray();
	}

	private HTTPFile sendRequestForFile() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream(8*1024);
		HTTPFile f = new HTTPFile();
		// checks server's status code first
		int status = httpConn.getResponseCode();
		if (status == HttpURLConnection.HTTP_OK) {
			
			String fn = httpConn.getHeaderField("Content-Disposition");
			if( fn != null ){ 
				fn = fn.substring(fn.indexOf("\"")+1, fn.lastIndexOf("\""));
				//System.out.println("Filename = " + fn);
				f.setName(fn);
			}
			
			BufferedInputStream input = new BufferedInputStream( httpConn.getInputStream() );
			byte[] bucket = new byte[32*1024]; 
			System.out.println("Reading"); 
			int bytesRead = 0;
			cnt=0;
	        while(bytesRead != -1){
	          bytesRead = input.read(bucket);
	          if(bytesRead > 0){
	        	cnt++;
	        	log(bytesRead, bucket);
	            baos.write(bucket, 0, bytesRead);
	          }
	        }
	        f.setContent(baos.toByteArray());
			System.out.println("\n(Bytes: " + baos.size() + ")");
		} else {
			throw new IOException("Response: " + status + " was returned by cvix");
		}
		return f;
	}

	
	private void log(int bytesRead, byte[] bucket) {
		//SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS");
		//System.out.println(sdf.format(new Date()) + " - [" + bytesRead + "] " + new String(bucket));
		//System.out.println(sdf.format(new Date()) + " - [" + bytesRead + "]");
		//System.out.println(cnt+";"+cnt%32);
		System.out.print((cnt%32)==0?".\n":".");
		
	}
	
}

class MyFileJs {
	byte[] content;
	String name;
	public MyFileJs(String name, byte[] content) {
		this.content=content;
		this.name=name;
	}
	public byte[] getContent() {
		return content;
	}
	public void setContent(byte[] content) {
		this.content = content;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
}

class HTTPFile {
	private String name;
	private byte[] content;
	public HTTPFile() {
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public byte[] getContent() {
		return content;
	}
	public void setContent(byte[] content) {
		this.content = content;
	}
	
}