package gov.va.med.mhv.eauth.service.impl;

import java.util.Date;

import gov.va.med.mhv.eauth.bizobj.BusinessObjectFactory;
import gov.va.med.mhv.eauth.bizobj.EAuthLogBO;
import gov.va.med.mhv.eauth.service.EAuthLogService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.service.VoidServiceResponse;

/**
 * Service implementation class for the EAuthLog service
 */
public class EAuthLogServiceImpl implements EAuthLogService {

	private static Log log = LogFactory.getLog(EAuthLogServiceImpl.class);
	
	/**
	 * Execute the LogEauthEvent service
	 *
	 * @return VoidServiceResponse
	 */
	public VoidServiceResponse logEauthEvent(String hashValue, String userName, String csId, String event) {
		EAuthLogBO eabo = BusinessObjectFactory.createEAuthLogBO();
		
		eabo.setHashValue(hashValue);
		eabo.setUserName(userName);
		eabo.setCsid(csId);
		eabo.setEvent(event);
		eabo.setEventDate(new Date());
		eabo.save();

		log.debug("saving log entry for " + userName + " with hash " + hashValue);
		VoidServiceResponse response = new VoidServiceResponse();
		response.getMessages().addMessages(eabo.getAllMessages());
		log.debug("exiting logEauthEvent()");
		return response;
	}

}