package gov.va.med.mhv.rxrefill.service.impl.util;

import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import gov.va.med.mhv.rxrefill.bizobj.InstitutionBO;
import gov.va.med.mhv.rxrefill.transfer.Institution;

public class UtilityMethods {
	
	public static Institution getInstitution(String stationNumber) {
		List institutions = InstitutionBO.getInstitutionForStationNumber(
				stationNumber);
		return (!institutions.isEmpty())
			? ((InstitutionBO) institutions.get(0)).getInstitutionValues()
			: null;
	}
	
	public static Date getDateWithoutTime(Date date) {
		Date dateWithoutTime = null;
		if (date != null) {
			GregorianCalendar calendar = new GregorianCalendar();
			calendar.clear();
			calendar.setTime(date);
			int year = calendar.get(Calendar.YEAR); 
			int month = calendar.get(Calendar.MONTH); 
			int day = calendar.get(Calendar.DAY_OF_MONTH);
			
			calendar = new GregorianCalendar(year, month, day);
			dateWithoutTime = calendar.getTime(); 
		
		}
		return dateWithoutTime;
	}
	
	public static Timestamp dateToTimestamp(Date date) {
		return (date != null) ? new Timestamp(date.getTime()) : null;
	}
}
