package gov.va.med.mhv.rxrefill.util;

import gov.va.med.mhv.rxrefill.enumeration.MhvStatusEnumeration;
import gov.va.med.mhv.rxrefill.enumeration.PrescriptionStatusEnumeration;
import gov.va.med.mhv.rxrefill.transfer.Prescription;

public final class PrescriptionUtils {
	
	public static final PrescriptionStatusEnumeration SUBMITTED_STATUS =
		PrescriptionStatusEnumeration.getEnum(PrescriptionStatusEnumeration.
		SUBMITTED);


	public static final PrescriptionStatusEnumeration UNKNOWN_STATUS =
		PrescriptionStatusEnumeration.getEnum(PrescriptionStatusEnumeration.
		UNKNOWN);
	

	public static final MhvStatusEnumeration MHV_PENDING_STATUS = 
		MhvStatusEnumeration.getEnum(MhvStatusEnumeration.PENDING);

	private PrescriptionUtils() {
		// Hide for utility class
	}
	
	public static boolean isSubmitted(Prescription prescription) {
		return (prescription != null) && (prescription.getStatus() != null) 
			&& PrescriptionStatusEnumeration.SUBMITTED.equalsIgnoreCase(
				 prescription.getStatus().getName());
	}

	public static boolean isActive(Prescription prescription) {
		return (prescription != null) && (prescription.getStatus() != null) 
			&& PrescriptionStatusEnumeration.ACTIVE.equalsIgnoreCase(
				 prescription.getStatus().getName());
	}

	public static boolean isMHVPending(Prescription prescription) {
		return (prescription != null) && (prescription.getMhvStatus() != null) 
			&& MhvStatusEnumeration.PENDING.equalsIgnoreCase(
				 prescription.getMhvStatus().getName());
	}

	

}
