package gov.va.med.mhv.rxrefill.portlet.controller;

import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.sql.Timestamp;

import javax.portlet.PortletPreferences;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.scoping.ScopedServletUtils;
import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.beehive.EntityListMaintenancePageFlowController;
import org.tigris.atlas.beehive.PageFlowControllerConstants;
import org.tigris.atlas.messages.Message;
import org.tigris.atlas.messages.MessageFactory;
import org.tigris.atlas.messages.MessageUtils;
import org.tigris.atlas.messages.Messages;
import org.tigris.atlas.messages.Severity;
import org.tigris.atlas.service.ServiceResponse;
import org.tigris.atlas.service.VoidServiceResponse;
import org.tigris.atlas.transfer.PrimaryKey;
import org.tigris.atlas.transfer.TransferObject;

import com.bea.netuix.servlets.controls.portlet.backing.PortletBackingContext;
import com.bea.portlet.GenericURL;
import com.bea.portlet.PageURL;

import gov.va.med.mhv.core.portlet.util.PageFlowUrlBuilder;
import gov.va.med.mhv.core.util.Precondition;
import gov.va.med.mhv.core.util.ServiceResponseUtils;
import gov.va.med.mhv.rxrefill.web.form.RxTrackingForm;
import gov.va.med.mhv.rxrefill.service.delegate.PrescriptionServiceDelegate;
import gov.va.med.mhv.rxrefill.service.delegate.RxTrackingServiceDelegate;
import gov.va.med.mhv.rxrefill.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.rxrefill.transfer.PharmacyPatient;
import gov.va.med.mhv.rxrefill.transfer.Prescription;
import gov.va.med.mhv.rxrefill.transfer.PrescriptionPK;
import gov.va.med.mhv.rxrefill.transfer.Request;
import gov.va.med.mhv.rxrefill.transfer.RxTracking;
import gov.va.med.mhv.rxrefill.transfer.TransferObjectFactory;
import gov.va.med.mhv.rxrefill.util.ServiceResponseUtil;
import gov.va.med.mhv.rxrefill.util.TimerUtils;
import gov.va.med.mhv.rxrefill.web.form.PrescriptionForm;
import gov.va.med.mhv.rxrefill.web.form.PrescriptionViewData;
import gov.va.med.mhv.sei.portlet.controller.BaseSEIPageFlowController;
import gov.va.med.mhv.usermgmt.enumeration.AuthenticationStatus;
import gov.va.med.mhv.usermgmt.enumeration.PatientCorrelationStatus;
import gov.va.med.mhv.usermgmt.service.InPersonAuthenticationServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.PatientServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.InPersonAuthentication;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;



public abstract class PrescriptionPageFlowController
	extends BaseSEIPageFlowController
{

    private static Log LOG = LogFactory.getLog(PrescriptionPageFlowController.
    	class);


    private static final String LAST_MODIFIED_DATE_TIME = "7/11/06 5 pm";

    protected final int DEFAULT_PAGE_SIZE =  10;

    protected static final String CONTACT_US_PAGE = "contactMHV";
    protected static final String CONTACT_US_PORTLET = "contactMHV";

    // page navigation constants
    protected final String PAGE_LABEL_PHARMACY = "pharmacy";
    protected final String PAGE_LABEL_CONTACT_US = "contactMHV";
    protected final String PAGE_LABEL_PROFILES = "profiles";
    protected final String FORWARD_AGREEMENT = "agreement";
    protected final String FORWARD_WARNING = "warning";
    protected final String FORWARD_ERROR = "error";
    protected final String FORWARD_NON_PATIIENT = "nonPatient";
    protected final String KEY_TABLE_SESSION = "Prescription";
    protected final String PARAMETER_ID = "id";
    protected final String ACTION_RESET_VIEW_LIST = "resetViewListAction";
    protected final String DIR_RX_CONTENT = "/BEA Repository/rx_refill/";

    // date format constants
    public static final String LAST_UPDATED_PREFIX = "Last updated [";
    public static final String LAST_UPDATED_TRACKING_PREFIX = "Last Update of Tracking Information [";
	public static final String LAST_UPDATED_SUFFIX = "]";
	public static final String LAST_UPDATED_DATE_FORMAT = "MM/dd/yyyy 'at' HHmm";

    // notification constants
//    protected final String TEXT_CONTACT_US = "Contact Us";

    protected final String MESSAGE_CODE_ERROR = ".error";
    protected final String MESSAGE_CODE_ERROR_NOREFLL_SELECTED = "rxrefill.error.norefillselected";

    protected final String MSG_ID_UNKOWN_ERROR = "error.unknown";
    protected final String MSG_ID_NONPATIENT_ERROR = "rxrefill.error.nonpatient";

    protected Messages lookupMessages = null;
    protected PharmacyPatient pharmacyPatient;
    private UserProfile userProfile;
    private PrescriptionViewData viewData;
    private boolean agreementWarned = false;
    private Date lastUpdatedTimeForList;

    // abstract methods to be implemented in rxRefill & rxHistory controllers
    abstract protected org.tigris.atlas.service.EntityCollectionServiceResponse
    	lookupPrescriptions(PrescriptionServiceDelegate service);
    abstract protected PrescriptionViewData createPrescriptionViewData();
    abstract protected String getMessageIdPrefix();
    abstract protected String getHealthTipPage();
    abstract protected boolean warningCurrentSeletion();
    // abstract methods end

    // implement unused methods so subclasses don't have to
    public String getSeiName() {
    	return null;
    }
    protected void setupNewEntity() {
    }
    protected void populateEntity(org.tigris.atlas.web.struts.InputForm arg0) {
    }
    protected org.tigris.atlas.service.EntityServiceResponse deleteEntity() {
    	return null;
    }
    protected org.tigris.atlas.service.EntityServiceResponse saveEntity() {
    	return null;
    }

    public Forward begin() {

        userProfile = getCurrentUserProfile();
        PatientServiceResponse patientResponse = null;
        InPersonAuthenticationServiceResponse ipaResponse = null;
        InPersonAuthentication ipa = null;
        Patient patient = null;

    	if(userProfile != null){
    		patientResponse = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(userProfile);
    		patient = patientResponse.getPatient();
    	}
    	if (patient!= null){
    		ipaResponse = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate().getIPAPatientById(patient.getId());
    		ipa = ipaResponse.getInPersonAuthentication();
    		if(ipa !=null){
    			if (LOG.isDebugEnabled()) {
    				LOG.info("PrescriptionPageFlowController.begin(): IPA not null: patient id: "
    						+ patient.getId());
    			}

    			if((ipa.getStatus().equals(AuthenticationStatus.getEnum(AuthenticationStatus.AUTHENTICATED))) &&
    					ipa.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED) ||
    					((ipa.getStatus().equals(AuthenticationStatus.getEnum(AuthenticationStatus.UNAUTHENTICATED))) &&
    					ipa.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)) ||
    					(patient.getMatchedDateTime() == null && (ipa.getStatus().equals(AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGDATAMISMATCH))) &&
    	    					ipa.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)) ||
    					((patient.getMatchedDateTime() != null) &&
    					ipa.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)) ){
    				PatientServiceResponse ptResponse = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createMviIntegrationServiceDelegate().updateTreatmentFacilitiesForExistingPatients(patient);
    				if (LOG.isDebugEnabled()) {
    					LOG.debug("PrescriptionPageFlowController.begin(): inside business logic: patient id: "
    					+ patient.getId());
    				}
    		        if (ServiceResponseUtils.hasErrorMessages(ptResponse)) {
        				if (LOG.isErrorEnabled()) {
        					LOG.error("ERROR: PrescriptionPageFlowController.begin(): inside business logic: Error for patient id: "
        					+ patient.getId()+ " : " + ptResponse.getMessages().getErrorMessages());
        				}
    		            //handleMessages(ptResponse);
    		        }
    				//handleMessages(ptResponse);
    			}
    		}
    	}

        if (userProfile == null
                || userProfile.getIsPatient() == null
                || !userProfile.getIsPatient().booleanValue() || patient == null)
        {
            setNonPatientNotification();
            return new Forward(FORWARD_NON_PATIIENT);
        }

        /*
         * New code for MVI
         */



        return refreshAction();
    }

    private void refreshPharmacyPatient() {
    	if (userProfile != null) {
    		PharmacyPatient pharmacyPatient = getPharmacyPatient(userProfile);
    		if (pharmacyPatient != null) {
    			this.pharmacyPatient = pharmacyPatient;
    		} else {
    			LOG.warn("Failed to refresh pharmacyPatient for user '"
    				+ userProfile.getUserName() + "'");
    		}
    	}
    }


    public Forward refreshAction() {
        if (!BooleanUtils.isTrue(getCurrentUserProfile().getRxAgreementSigned())) {
        	// Note that !isTrue() != isFalse(), due to handling of null value
        	return new Forward(FORWARD_AGREEMENT);
        }

    	// Must refresh the pharmacy patient to incorporate any changes.
       	refreshPharmacyPatient();
    	return loadEntitiesAndPopulateView(null);
    }

    protected String getEntityName() {
        return Prescription.ENTITY;
    }

    protected String getTableSessionKey() {
        return KEY_TABLE_SESSION;
    }

    protected org.tigris.atlas.service.EntityServiceResponse lookupEntity() {
        String id = getRequest().getParameter(PARAMETER_ID);

        PrescriptionPK pk = TransferObjectFactory.createPrescriptionPK();
        pk.setPrescriptionId(Long.valueOf(id));

        return ServiceDelegateFactory.createEntityMaintenanceServiceDelegate().
        	findByPrimaryKey(pk);
    }

	protected void populateForm(org.tigris.atlas.web.struts.InputForm form) {
		String currentDetailActionName = (String)getRequest().getSession().getAttribute("currentDetailActionName");
        ((PrescriptionForm)form).copyFromEntity(getCurrentPrescription());
		if (currentDetailActionName.compareTo("viewAction") == 0) {
        	getViewData().populateDetailTableRows(form);
		} else if (currentDetailActionName.compareTo("viewTrackingAction") == 0) {
        	getViewData().populateTrackingDetailTableRows(form,getRequest());
		}
		getRequest().getSession().removeAttribute("currentDetailActionName");
    }

    public String getCurrentUserFirstName() {
        return (userProfile == null)? null : userProfile.getFirstName();
    }

    public String getCurrentUserLastName() {
        return (userProfile == null)? null : userProfile.getLastName();
    }

	public String getLastUpdatedTimeForDetail() {
		return getFormattedDate(getCurrentPrescription().getModifiedDate());
	}

	public String getLastUpdatedTimeForTrackingDetail() {
		return getTrackingFormattedDate((String)getRequest().getSession().getAttribute("lastUpdatedDate"));
	}
    public String getLastUpdatedTimeForList() {
        return getFormattedDate(lastUpdatedTimeForList);
    }

    public Forward printerFriendlyListAction() {
        return new Forward(PageFlowControllerConstants.FORWARD_SUCCESS);
    }

    public Forward printerFriendlyDetailAction(org.tigris.atlas.web.struts.
    	InputForm form)
    {
        return new Forward(PageFlowControllerConstants.FORWARD_SUCCESS);
    }

    public Forward printerFriendlyTrackingDetailAction(org.tigris.atlas.web.struts.
    	InputForm form)
    {
        return new Forward(PageFlowControllerConstants.FORWARD_SUCCESS);
    }

    public Forward returnToListAction() {
        createStatusNotifications();
        return super.returnToListAction();
    }

    public Forward viewTrackingImageAction() {
        getViewData().populateTrackingImageTableRows(getRequest());
        return new Forward(PageFlowControllerConstants.FORWARD_SUCCESS);
    }

    /**
     * get last modified data/time for debugging.
     * Before removing this, go to
     * mhv-rx-refill-portlet/gov/va/med/mhv/rxrefill/include/list.jspf
     * and remove the following comment at the bottom of the page.
     * <!-- last modified: <netui:content
     * value="{pageFlow.lastModfiedDateTime}"/> -->
     */
    public String getLastModfiedDateTime() {
        return LAST_MODIFIED_DATE_TIME;
    }

    public boolean isAgreementWarned() {
        return agreementWarned;
    }


    public PrescriptionViewData getViewData() {
        if (viewData == null) {
            loadEntitiesAndPopulateView(null);
        }
        return viewData;
    }

    public Prescription getCurrentPrescription() {
        return (Prescription) getCurrentEntity();
    }

    public String getViewDataPageNavigationBar(PageContext ctx) {
        return (getViewData() != null)
            ? getViewData().getPageNavigationBar(getActionResetViewListUrl(),
            	getPortletLabel(), ctx)
            : "";
    }

    public Forward saveAction(PrescriptionForm form) {
        return super.saveAction(form);
    }

    public String getHealthTipPagePath() {
        return DIR_RX_CONTENT + getHealthTipPage();
    }

    protected Forward acceptAgreementAction() {

        userProfile.setRxAgreementDate(new Date(System.currentTimeMillis()));
        userProfile.setRxAgreementSigned(new Boolean(true));

        UserProfileServiceResponse response = gov.va.med.mhv.usermgmt.service.
            delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().
            saveUserProfile(userProfile, userProfile.getSsn());
        handleMessages(response);
        if (response.getMessages().hasErrorMessages()) {
            LOG.error(response.getMessages());
        }
        return determineForward();
    }

    protected Forward declineAgreementAction() {

       if (agreementWarned) {
        	agreementWarned = false; // reset, so user can reattempt
            return createPortalForward(PAGE_LABEL_PHARMACY);
        }

        agreementWarned = true;
        return new Forward(FORWARD_WARNING);
    }

    protected Forward contactUsAction() {
        return createPortalForward(PAGE_LABEL_CONTACT_US);
    }

    protected Forward forwardToProfiles() {
        return createPortalForward(PAGE_LABEL_PROFILES);
    }

    protected org.tigris.atlas.service.EntityCollectionServiceResponse
    	lookupEntities()
    {
        PrescriptionServiceDelegate service = ServiceDelegateFactory.
        	createPrescriptionServiceDelegate();
        return lookupPrescriptions(service);
    }

    protected Forward submitRefillAction() {
		//System.out.println(" 30 >>>>>>>>>>>>> in side submitRefillAction of PrescriptionPageFlowController - begining");
    	// Must refresh the pharmacy patient to incorporate any changes.
    	refreshPharmacyPatient();

        List refillList = getViewData().populateRefillList(true);

        if (refillList == null || refillList.size() == 0) {
            // always recreate the facility status messages
            createStatusNotifications();

            // if the empty refillList is caused by submitting duplicates,
            // do nothing
            if (getViewData().isDuplicateRefillSubmitted()) {
                return determineForward();
            }

			addSummaryMessage(Severity.getSeverity(Severity.ERROR),
					MESSAGE_CODE_ERROR_NOREFLL_SELECTED, null);

			return new Forward(PageFlowControllerConstants.FORWARD_FAILURE);
        }
		//System.out.println(" 31 >>>>>>>>>>>>> in side submitRefillAction of PrescriptionPageFlowController - calling getRefillPrescriptions");
        Collection refillRequests = getRefillPrescriptions(refillList);

        return loadEntitiesAndPopulateView(refillRequests);
    }

    protected Collection getRefillPrescriptions(List refillList) {
		//System.out.println(" 40 >>>>>>>>>>>>> in side getRefillPrescriptions of PrescriptionPageFlowController - begining");

        PrescriptionServiceDelegate service = ServiceDelegateFactory.
        	createPrescriptionServiceDelegate();
		//System.out.println(" 41 >>>>>>>>>>>>> in side getRefillPrescriptions of PrescriptionPageFlowController - calling refillPrescriptions");

        VoidServiceResponse response = service.refillPrescriptions(
        	pharmacyPatient, refillList);

        // Get requests with statuses from response message inserts
        Collection refillRequests =  ServiceResponseUtil.
        	removeRequestStatusMessages(response);

        return refillRequests;
    }


    public Forward ViewTrackingCarrierAction(PrescriptionForm form)
    {
        return super.viewAction(form);
    }

    protected Forward viewAction(PrescriptionForm form) {
		getRequest().getSession().setAttribute("currentDetailActionName", "viewAction");
        return super.viewAction(form);
      }


    protected Forward viewTrackingAction(PrescriptionForm form) {
		getRequest().getSession().setAttribute("currentDetailActionName", "viewTrackingAction");
        return super.viewAction(form);
    }

    protected Forward resetViewListAction() {

        if (getViewData().getHasRefillable()
                && warningCurrentSeletion())
            return new Forward(PageFlowControllerConstants.FORWARD_FAILURE);

        getViewData().resetListTableRows(getRequest());
        createStatusNotifications();
        return new Forward(PageFlowControllerConstants.FORWARD_SUCCESS,
        	getViewData());
    }

    protected Forward handleException(Exception ex, String actionName,
    	String message)
    {
        if (LOG.isErrorEnabled()) {
			LOG.error("PrescriptionPageFlowController encountered an exception",
				ex);
		}
    	addSummaryMessage(Severity.getSeverity(Severity.ERROR),
    		MSG_ID_UNKOWN_ERROR, null);

        return new Forward(FORWARD_ERROR);
    }

    /**
	 * Forwards to a page within the portal. The parameter is the definition
	 * label of the desired page as defined in the property editor for the page
	 * when that page is selected when editing the portal book in Workshop.
	 */
	protected Forward createPortalForward(String targetPageDefinitionLabel) {

		PageURL pURL = PageURL.createPageURL(getRequest(), getResponse(),
                targetPageDefinitionLabel);

        try {
            return new Forward(new URI(pURL.toString()));
        } catch (URISyntaxException e) {
            return new Forward(PageFlowControllerConstants.FORWARD_FAILURE);
        }
	}

    protected Collection getEntities(Collection refillRequests) {
        org.tigris.atlas.service.EntityCollectionServiceResponse response =
        	lookupEntities();
        this.lookupMessages = ServiceResponseUtil.convertMessages(
        	refillRequests, response, getMessageIdPrefix());
        this.handleMessages(response, null);

        return response.getEntities();
    }

    protected String getHtmlLink(String href, String target, String text) {
        if (target == null) {
            return "<a href=\"" + href + "\">" + text + "</a>";
        }
		return "<a href=\"" + href + "\" target=\"" + target + "\">" + text
			+ "</a>";
    }

    private PharmacyPatient getPharmacyPatient(UserProfile up) {
        Patient patient = gov.va.med.mhv.usermgmt.service.delegate.
        	ServiceDelegateFactory. createPatientServiceDelegate().
        	getPatientForUser(up).getPatient();

        if (patient == null) return null;

        PrescriptionServiceDelegate service = ServiceDelegateFactory.
        	createPrescriptionServiceDelegate();

        return service.getPharmacyPatient(patient).getPharmacyPatient();
    }

    private String getActionResetViewListUrl() {
        return getActionPath(ACTION_RESET_VIEW_LIST);
    }

    protected abstract String getPortletLabel();

    protected abstract String getPageLabel();

	private String getActionPath(String actionName) {
		String pageLabel = getPageLabel();
		String portletLabel = getPortletLabel();
		String protocol = (isSSL(getRequest())) ? "https://" : "http://";
		StringBuffer actionOverride = new StringBuffer();
		if (!StringUtils.isBlank(actionName)) {
			String overrideName = urlEncode(portletLabel + "_actionOverride");
			String overrideValue = urlEncode("/" + getClass().getPackage().
				getName().replace('.', '/') + "/" + actionName);
			if ((overrideName != null) && (overrideValue != null)) {
				actionOverride.append("&").append(overrideName).append("=").
					append(overrideValue);
			} else {
				LOG.error("Failed to redirect controller "
					+ getClass().getName() + " to proper action '"
					+ actionName
					+ "'. Could not create _actionOverride parameter");
			}
		}

		HttpServletRequest outerRequest = ScopedServletUtils.getOuterRequest(
			getRequest());
		StringBuffer strBuf = new StringBuffer(protocol).
			append(outerRequest.getServerName()).
			append(":").append(outerRequest.getServerPort()).
			append(outerRequest.getRequestURI()).append("?").
			append(GenericURL.POSTBACK_PARAM).append("=true&").
			append(GenericURL.PAGE_LABEL_PARAM).append("=").append(pageLabel).
			append("&").append(GenericURL.WINDOW_LABEL_PARAM).append("=").
				append(portletLabel).
			append(actionOverride.toString());
		return strBuf.toString();
	}

	private static boolean isSSL(HttpServletRequest request) {
		return request.getScheme().equalsIgnoreCase("https");
	}

	private static String urlEncode(String value) {
		final String ENCODING = "UTF-8";
		try {
			return URLEncoder.encode(value, ENCODING);
		} catch (UnsupportedEncodingException e) {
			LOG.error("Failed to encode part of URL " + value, e);
			return null;
		}
	}

    private void setNonPatientNotification() {
    	addSummaryMessage(Severity.getSeverity(Severity.ERROR),
    			MSG_ID_NONPATIENT_ERROR, null);
    }

    /*
     * (non-Javadoc)
     * @see gov.va.med.mhv.beehive.EntityPagingListPageFlowController#
     * getEntityKey(java.lang.Object)
     */
    protected PrimaryKey getEntityKey(Object entity) {
        // Just the primary keys are stored in the session, so simply convert
        // the entity to the primary key
        return (PrimaryKey) entity;
    }

    /**
     * Saves the entities in the session.
     * Note that only the primary keys are stored, since the prescriptions
     * are not stored in the session to use by the JSPs.
     * However, the primary keys are needed to verify access to the details
     * of prescriptions.
     * Method {@link #getEntityKey(Object)} extracts the PrimaryKey from these
     * 'entity'.
     * @param entities The list of prescriptions.
     * @see #getEntityKey(Object)
     */
    private void saveEntities(Collection entities) {
        Collection<PrimaryKey> entityIds = new HashSet<PrimaryKey>();
        if (entities != null) {
            for (Object e: entities) {
                Prescription rx = (Prescription) e;
                entityIds.add(rx.getKey());
            }
        }
        getSession().setAttribute(getTableSessionKey(), entityIds);
    }

    protected Forward loadEntitiesAndPopulateView(Collection refillRequests) {
		TimerUtils timer = new TimerUtils();
		timer.start();

        Collection entities = getEntities(refillRequests);

        saveEntities(entities);

		/*
		// Get max date of last_modified_date of prescriptions
		// initialize the maxValue
		Timestamp maxValue = java.sql.Timestamp.valueOf("2000-01-01 09:00:10");;
		int i = 0;
        if (entities != null) {
            for (Object e: entities) {
                Prescription rx = (Prescription) e;
                if (i==0) {
                	maxValue = rx.getModifiedDate();
				}
				if (rx.getModifiedDate().after(maxValue))
					maxValue = rx.getModifiedDate();
            }
        }
		lastUpdatedTimeForList = maxValue;
		*/

        viewData = createPrescriptionViewData();
        // Removed IPA check as per CR 6671
        viewData.setEntityList(entities, getRequest());

        TransferObject request = ServiceDelegateFactory.
        	createPrescriptionServiceDelegate().
        	getLastSuccessfulExtractRequestForUser(pharmacyPatient).
        	getEntity();

        lastUpdatedTimeForList = ((request == null ) ? null : ((Request) request).getModifiedDate());

        timer.stop();
		if (LOG.isInfoEnabled()) {
			LOG.info("For::"+getCurrentUserId()+" loadEntitiesAndPopulateView:: Elapsed time in Seconds: " + timer.getElapsedTimeSecs());
		}
        return determineForward();
    }

    private void createStatusNotifications() {
    	getMessagesHandler().handleMessages(lookupMessages, getFormClass(),
    		getRequest());
    }

    /**
     * Adds a message to the request.
     * @param severity The severity of the message to add.
     * @param msgId The id of the message to add.
     * @param inserts The arguments to the messages, used to replace the
     *     parameters in the message.
     */
    protected void addSummaryMessage(Severity severity, String msgId,
    	Collection<String> inserts)
    {
    	addMessage(severity, msgId, inserts);
    }

    /**
     * Adds a message to the request.
     * @param severity The severity of the message to add.
     * @param msgId The id of the message to add.
     * @param inserts The arguments to the messages, used to replace the
     *     parameters in the message.
     * @param isSummaryMessage Denotes if the message is a summary (true) or
     *     a detail (false) message.
     */
    protected void addMessage(Severity severity, String msgId,
    	Collection<String> inserts)
    {
    	final int n = (inserts != null) ? inserts.size() : 0;
    	String[] insertsArray = new String[n];
    	if (n > 0) {
    	   inserts.toArray(insertsArray);
    	}
		Messages messages = MessageFactory.createMessages();
		messages.addMessage(MessageUtils.createMessage(msgId, severity,
			null, insertsArray));
		getMessagesHandler().handleMessages(messages, getFormClass(),
			getRequest());
    }

    private String getFormattedDate(Date date){
        if (date == null) return "";
        SimpleDateFormat df = new SimpleDateFormat(LAST_UPDATED_DATE_FORMAT);
        String formattedDate = df.format(date);
        return LAST_UPDATED_PREFIX + formattedDate + LAST_UPDATED_SUFFIX;
	}
	private String getTrackingFormattedDate(String formattedDate){
	        return LAST_UPDATED_TRACKING_PREFIX + formattedDate + LAST_UPDATED_SUFFIX;
	}


    /**
     * Operation getError() ripped from LoginPageFlowController
     * This method was modified from its orginal by looking for the
     * info messages and not the Error messages.
     */
    private static Message getInfo(Messages messages, String key) {
		Message message = null;
		if (messages != null) {
			for (Iterator i = messages.getInformationalMessages().iterator();
			     (message == null) && i.hasNext();)
			{
				message = (Message) i.next();
				if ((message != null) && !message.getKey().equals(key)) {
					message = null; // not found, keep looking
				}
			}
		}

		return message;
	}

    /**
     * Overloading the super implementation of handleMessages() from Atlas
     * parent class operation for PageControllers
     *
     */
    protected void handleMessages(ServiceResponse response, Object o) {
		Message message = getInfo(response.getMessages(), "rxrefill.error.vista.prescriptionrejected");
		Message messageRxHist = getInfo(response.getMessages(), "rxhistory.error.vista.prescriptionrejected");
		if (message != null) {
			// Add links to message
			//message.addInsert(constructUrl());
			message.addInsert(constructUrl(getRequest()));
		}if(messageRxHist != null){
			messageRxHist.addInsert(constructUrl(getRequest()));
		}
		super.handleMessages(response);
	}


    /**
     * Method should only work if being used within the context of
     * mhv_portal.
     *
     * @return
     */
    private String constructUrl(HttpServletRequest request){
    	String contextPath = request.getContextPath();
    	StringBuffer buffer = new StringBuffer();
    	buffer.append(contextPath + "/");
    	//buffer.append("mhv.portal?_nfpb=true&_windowLabel=contactUs&contactUs_actionOverride=%2Fgov%2Fva%2Fmed%2Fmhv%2Fcontactus%2Fportlet%2FcontactUs&_pageLabel=contactMHVHome");
    	buffer.append("mhv.portal?_nfpb=true&_windowLabel=contactUsPortlet_contactMHV&contactUsPortlet_contactMHV_actionOverride=%2Fgov%2Fva%2Fmed%2Fmhv%2Fcontactus%2Fportlet%2FcontactUs&_pageLabel=contactMHVHome");
    	return buffer.toString();

    }
}
