package gov.va.med.mhv.rxrefill.web.form;

import gov.va.med.mhv.rxrefill.enumeration.PrescriptionStatusEnumeration;
import gov.va.med.mhv.rxrefill.form.PrescriptionBaseForm;
import gov.va.med.mhv.rxrefill.transfer.Prescription;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

/**
 * The PrescriptionForm class is responsible for handling user input.
 */
public class PrescriptionForm extends PrescriptionBaseForm {
	
	public final String STATUS_REFILL_IN_PROCESS = "Refill in Process";
    
    Long prescriptionId;
	Boolean selectedToRefill;
    String facilityName;
    
    public void copyFromEntity(Prescription prescription) {
        copyFrom(prescription);
        setPrescriptionId(prescription.getPrescriptionId());    
        setFacilityName(prescription.getInstitution().getName());
        formatPrescriptionStatus();
        formatPrescriptionQuantity();
    }
    
    public void setPrescriptionId(Long prescriptionId) {
		this.prescriptionId = prescriptionId;
	}
	
	public Long getPrescriptionId() {
		return this.prescriptionId;
	}
    
    public void setFacilityName(String facilityName) {
		this.facilityName = facilityName;
	}
	
	public String getFacilityName() {
		return this.facilityName;
	}
    
    private void formatPrescriptionStatus() {
        
        if (getPrescriptionStatus()==null || getPrescriptionStatus().length()==0) 
            return;
        
        String formatted;
        if (PrescriptionStatusEnumeration.REFILLINPROCESS
                .equalsIgnoreCase(getPrescriptionStatus()))
            formatted = STATUS_REFILL_IN_PROCESS;
        else {
            formatted = getPrescriptionStatus().substring(0,1).toUpperCase()
                    + getPrescriptionStatus().substring(1);
        }    
        
        setPrescriptionStatus(formatted);
    }
    
    private void formatPrescriptionQuantity() {
        
        if (getPrescriptionQuantity()==null || getPrescriptionQuantity().length()==0) 
            return;
        
        String formatted;
        if (getPrescriptionQuantity().endsWith(".00")) {
            // remove any trailing ".00"
            formatted = getPrescriptionQuantity()
                    .substring(0, getPrescriptionQuantity().length()-3);
            setPrescriptionQuantity(formatted);
        }      
    }
    
    protected void doReset(ActionMapping mapping, HttpServletRequest request) {}
}