package gov.va.med.mhv.rxrefill.web.form;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import javax.servlet.http.HttpServletRequest;

import gov.va.med.mhv.rxrefill.enumeration.MailWindowEnumeration;
import gov.va.med.mhv.rxrefill.transfer.Prescription;
import gov.va.med.mhv.rxrefill.web.form.ViewData.TableCell;
import gov.va.med.mhv.rxrefill.web.form.ViewData.TableRow;

/**
 * FormData get and set methods may be overwritten by the Form Bean editor.
 */
public class TrackingPrescriptionViewData extends PrescriptionViewData {


	public final String HEADER_RX_TRACKING_SUMMARY= "View Prescription Tracking";
	public final String HEADER_RX_TRACKING_DETAIL= "View Prescription";
    public final String TYPE_RX_TRACKING_SUMMARY_HELP = "rxtracking";
    public final String TYPE_RX_TRACKING_SUMMARY_LIST = "Mailed Deliveries for";
    public final String TYPE_RX_TRACKING_SUMMARY_DETAIL = "Prescription for";
	public final String TYPE_RX_TRACKING_SUMMARY_DETAIL1 = "Prescription";
    public final String HEADER_RX_TRACKING = "View Prescription Tracking";
    public final String TYPE_RX_TRACKING_DETAIL = "Prescription Delivery";
    public final String TYPE_RX_TRACKING_HELP = "rxtrackinghistory";
    public final String WINDOW = "window";
    public final String TRACK_DELIVERY = "Track Delivery";

    public TrackingPrescriptionViewData(int pageSize) {
        super(pageSize);
    }

    public String getHeaderType() {
        return HEADER_RX_TRACKING_SUMMARY;
    }

    public String getHeader1Type() {
        return HEADER_RX_TRACKING_DETAIL;
    }

    public String getTrackingHeaderType() {
        return HEADER_RX_TRACKING;
    }

    public String getHelpType() {
        return TYPE_RX_TRACKING_SUMMARY_HELP;
    }

    public String getTrackingHelpType() {
        return TYPE_RX_TRACKING_HELP;
    }

    public String getListType() {
        return TYPE_RX_TRACKING_SUMMARY_LIST;
    }

    public String getDetailType() {
        return TYPE_RX_TRACKING_SUMMARY_DETAIL;
    }

    public String getDetail1Type() {
        return TYPE_RX_TRACKING_SUMMARY_DETAIL1;
    }
    public String getTrackingDetailType() {
        return TYPE_RX_TRACKING_DETAIL;
    }

    protected String getStatusTitle() {
        return TITLE_REFILL_STATUS;
    }

    protected String getTrackingTitle() {
        return TITLE_TRACKING1;
    }

    public String getDefaultSortColumn() {
        //return COLUMN_FILL_DATE;
        return COLUMN_DISPENSE_DATE;
    }

    public String getDefaultSortColumn2() {
        //return COLUMN_RX_Number;
        return COLUMN_DRUG_NAME;
    }

    protected void populateListTableHeaderRow() {
        listHeaderRow = new TableRow();
        listHeaderRow.addSortableHeaderCell(TITLE_DISPENSE_DATE, COLUMN_DISPENSE_DATE);
        listHeaderRow.addSortableHeaderCell(TITLE_RX, COLUMN_DRUG_NAME);
        listHeaderRow.addSortableHeaderCell(TITLE_FACILITY, COLUMN_FACILITY);
        listHeaderRow.addHeaderCellCenter(TITLE_TRACKING1, COLUMN_TRACKING);
    }

    protected boolean createPrescriptionTableRowContent(TableRow tr,
    	PrescriptionForm rxForm, String contextPath, HttpServletRequest request)
    {
		//if (checkAddTrackingRow(rxForm, contextPath, request)) { // if true
        addCellPrescriptionDispenseDate(tr, rxForm, contextPath);
        addCellMedication(tr, rxForm, contextPath);
        addCellFacility(tr, rxForm, contextPath);
        addCellTracking(tr, rxForm, contextPath, request);
        return true;
		//}else{
		//	return false;
		//}
    }

    protected boolean checkRefillable(Prescription rx) {
        return false;
    }

    protected void addCellHistoricalRxStatus(
            TableRow tr, PrescriptionForm rxForm, String contextPath) {
        // adding Status
        TableCell cell = new TableCell();
        cell.content = rxForm.getPrescriptionStatus();

        // adding warning icon?
        if (rxForm.getPrescriptionIsInvalidMhvStatus().equalsIgnoreCase(TEXT_TRUE)) {
            cell.setImg(contextPath+IMAGE_FILE_ALERT, ALT_IMAGE_INVALID_STATUS);
        }
        tr.addCell(cell);
    }

	@Override
	protected boolean checkTrackable(Prescription rx) {
		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.DAY_OF_YEAR , -46);
		Date daysAgo = cal.getTime();

		if (rx.getMailWindow().getName().equalsIgnoreCase(WINDOW) && (rx.getReleaseDateTime().after(daysAgo))|| rx.getReleaseDateTime().equals(daysAgo) ){
			//System.out.println("**** checkTrackable::true:: rx release date: " + rx.getReleaseDateTime() + " 46 daysAgo: " + daysAgo + " Mail/Window: " + rx.getMailWindow().getName());
			return true;
		}else{
			//System.out.println("**** checkTrackable::false:: rx release date: " + rx.getReleaseDateTime() + " 46 daysAgo: " + daysAgo + " Mail/Window: " + rx.getMailWindow().getName());
			return false;
		}
	}

}