package gov.va.med.mhv.usermgmt.integration.service;

import gov.va.med.mhv.integration.registry.transfer.Facility;
import gov.va.med.mhv.integration.registry.transfer.Patient;
import gov.va.med.mhv.integration.registry.transfer.PersonalInfo;
import gov.va.med.mhv.integration.registry.transfer.Status;
import gov.va.med.mhv.usermgmt.transfer.UserProfileDeactivationReason;

import java.util.ArrayList;
import java.util.Date;

import org.tigris.atlas.service.ApplicationService;

/**
 */
public interface PatientIdentityService extends ApplicationService {

	/** 
     * Name which uniquely identifies the PatientIdentity service. 
     **/
	public static final String SERVICE_NAME = 
        "gov.va.med.mhv.integration.service.PatientIdentityService";

    Patient getPatientForICN(String icn);
    
    Status finalizeCorrelation(Patient patient, Status status);
    
    Status finalizeUncorrelation(Patient patient, Status status); 

    Status updateFacilities(Patient patient,  ArrayList<Facility> facilities);

    Status updatePersonalInfo(Patient patient, PersonalInfo personalInfo); 

    Status changeIcn(Patient patient, String icn);

    Status removeCorrelation(Patient patient); 

    Status mergePatients(Patient fromPatient, Patient toPatient, 
        String referenceId);

    //JAZZ # 128617: MVI A43 Move message processing.
    Status deactivatePatient(Patient patient, String referenceId, String reason, String deactivationNote);
}