package gov.va.med.mhv.usermgmt.persist.ldap;

import netscape.ldap.LDAPConnection;
import netscape.ldap.LDAPException;

/**
 * Interface into a directory command.
 *
 * @author Jon Crater Apr 4, 2006 4:08:28 PM
 */
public interface LdapCommand {	
	/**
	 * Execute logic specific to this command.
	 * @param distinguishedName The distinguished name that uniquely identifies the 
	 * 		directory entry on which this command operates.
	 * @param conn The connection to use.
	 * @throws LDAPException
	 */
	public void execute(String distinguishedName, LDAPConnection conn) throws LDAPException; 
}
