package gov.va.med.mhv.usermgmt.service;


import gov.va.med.mhv.usermgmt.enumeration.BloodTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ContactMethodEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.CountryEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.GenderEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.MaritalStatusEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.PasswordHintQuestionEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.StateEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.SuffixEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.TitleEnumeration;
import gov.va.med.mhv.usermgmt.messages.UserManagementMessages;
import gov.va.med.mhv.usermgmt.service.delegate.EntityMaintenanceServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.UserProfileServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.EmergencyContact;
import gov.va.med.mhv.usermgmt.transfer.TransferObjectFactory;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;

import java.util.Calendar;
import java.util.Date;

import junit.framework.TestCase;

import org.tigris.atlas.messages.Message;

public class TestUserProfilePersist extends TestCase {
	
	private static UserProfile USER_PROFILE = null;

	private void setUserProfileValues(UserProfile userProfile) {
//		userProfile.setFirstName( "Joe" );
//		userProfile.setMiddleName( "Q" );
//		userProfile.setLastName( "User" );
//		userProfile.setTitle( TitleEnumeration.getEnum( TitleEnumeration.MR ) );
//		userProfile.setSuffix( SuffixEnumeration.getEnum( SuffixEnumeration.SR ) );
//		userProfile.setSsn( "111-11-1111" );
//		userProfile.setBirthDate( new Date() );
//		userProfile.setBloodType( BloodTypeEnumeration.getEnum( BloodTypeEnumeration.O_NEGATIVE ) );
//		userProfile.setIsOrganDonor( Boolean.TRUE );
//		userProfile.setGender( GenderEnumeration.getEnum( GenderEnumeration.MALE ) );
//		userProfile.setMaritalStatus( MaritalStatusEnumeration.getEnum( MaritalStatusEnumeration.DIVORCED ) );
//		userProfile.setIsVeteran( Boolean.TRUE );
//		
//		userProfile.setAddressStreet1( "1000 N Garfield Street" );
//		userProfile.setAddressStreet2( "Apt. 666" );
//		userProfile.setAddressCity( "Arlington" );
//		userProfile.setAddressState( StateEnumeration.getEnum( StateEnumeration.TN ) );
//		userProfile.setAddressPostalCode( "22201" );
//		userProfile.setAddressCountry( CountryEnumeration.getEnum( CountryEnumeration.UNITED_STATES ) );
//		
//		userProfile.setContactInfoContactMethod( ContactMethodEnumeration.getEnum( ContactMethodEnumeration.HOMEPHONE ) );
//		userProfile.setContactInfoHomePhone( "703-555-5555" );
//		userProfile.setContactInfoEmail( "joe.q.user@isp.net" );
//		
//		userProfile.setPasswordHintQuestion1( PasswordHintQuestionEnumeration.getEnum( PasswordHintQuestionEnumeration.FAVORITEFOOD ) );
//		userProfile.setPasswordHintAnswer1( "Spaghetti" );
//		userProfile.setPasswordHintQuestion2( PasswordHintQuestionEnumeration.getEnum( PasswordHintQuestionEnumeration.PETNAME ) );
//		userProfile.setPasswordHintAnswer2( "Spot" );
//		userProfile.setUserName( "joequser" );
//		
//		userProfile.setAcceptDisclaimer( Boolean.TRUE );
//		userProfile.setAcceptPrivacy( Boolean.TRUE );
//		userProfile.setAcceptTerms( Boolean.TRUE );
//		
//		EmergencyContact contact = TransferObjectFactory.createEmergencyContact();
//		contact.setFirstName( "Bubba" );
//		contact.setLastName( "Gump" );
//		contact.setContactInfoContactMethod( ContactMethodEnumeration.getEnum( ContactMethodEnumeration.HOMEPHONE ) );
//		contact.setContactInfoHomePhone( "301-555-5555" );
//		contact.setContactInfoEmail( "bubba@swamp.com" );
//		
//		userProfile.addEmergencyContact( contact );
	}
	
	public void setUp() throws Exception {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile userProfile = TransferObjectFactory.createUserProfile();
//		setUserProfileValues( userProfile );
//
//		UserProfileServiceResponse response = delegate.saveUserProfile( userProfile, "111-11-1111" );
//		USER_PROFILE = response.getUserProfile();
	}
	
	public void tearDown() throws Exception {
//		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
//		delegate.delete( USER_PROFILE.getUserProfilePK() );
//		USER_PROFILE = null;
	}
	
	public void testUpdateUserProfile() throws Exception {
//		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
//		UserProfile userProfile = delegate.findByPrimaryKey( USER_PROFILE.getUserProfilePK() ).getUserProfile();
//		
//		userProfile.setPasswordHintAnswer2( "Jones" );
//		userProfile.setBloodType( BloodTypeEnumeration.getEnum( BloodTypeEnumeration.AB_POSITIVE ) );
//		
//		EmergencyContact contact = TransferObjectFactory.createEmergencyContact();
//		contact.setFirstName( "Sargent" );
//		contact.setLastName( "Dan" );
//		contact.setContactInfoContactMethod( ContactMethodEnumeration.getEnum( ContactMethodEnumeration.WORKPHONE ) );
//		contact.setContactInfoWorkPhone( "202-555-5555" );
//		contact.setContactInfoEmail( "dan@army.mil" );
//		userProfile.addEmergencyContact( contact );
//
//		UserProfileServiceDelegate upsd = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfileServiceResponse response = upsd.saveUserProfile( userProfile, "111-11-1111" );
//		
//		boolean hasErrors = response.getMessages().hasErrorMessages() || response.getUserProfile().getMessages().hasErrorMessages();
//		assertFalse( hasErrors );
//		
//		if( ! hasErrors ) {
//			USER_PROFILE = response.getUserProfile();
//		}
	}
	
	public void testInvalidPatient() {
//		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
//		UserProfile userProfile = delegate.findByPrimaryKey( USER_PROFILE.getUserProfilePK() ).getUserProfile();
//		
//		userProfile.setIsPatient( Boolean.TRUE );
//
//		UserProfileServiceDelegate upsd = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfileServiceResponse response = upsd.saveUserProfile( userProfile, "111-11-1111" );
//		boolean hasErrors = response.getMessages().hasErrorMessages() || response.getUserProfile().getMessages().hasErrorMessages();
//		assertTrue( hasErrors );
//		
//		if( hasErrors ) {
//			Message message = (Message) response.getMessages().getErrorMessages().iterator().next();
//			assertEquals( UserManagementMessages.PATIENT_NOT_FOUND, message.getKey() );
//		}
	}

	
	public void testValidPatient() {
//		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
//		UserProfile userProfile = delegate.findByPrimaryKey( USER_PROFILE.getUserProfilePK() ).getUserProfile();
//
//		userProfile.setFirstName( "ONE" );
//		userProfile.setLastName( "RXTESTSLAVA" );
//		userProfile.setSsn( "123-99-8000" );
//		Calendar calendar = Calendar.getInstance();
//		calendar.set(1945, 0, 1, 0, 0, 0);
//		Date date = calendar.getTime(); 
//		userProfile.setBirthDate( date );
//
//		userProfile.setIsPatient( Boolean.TRUE );
//
//		UserProfileServiceDelegate upsd = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfileServiceResponse response = upsd.saveUserProfile( userProfile, "123-99-8000" );
//		boolean hasErrors = response.getMessages().hasErrorMessages() || response.getUserProfile().getMessages().hasErrorMessages();
//		assertFalse( hasErrors );
	}
	
	public void testGetUserByName() {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile profile = delegate.getProfileForUser( "joequser" ).getUserProfile();
//		
//		assertNotNull( profile );
//		assertEquals( "Spot", profile.getPasswordHintAnswer2() );
	}
	
	public void testGetPasswordHintsForForgottenUserName() {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile userProfile = delegate.getPasswordHintsForForgottenUserName( "Joe", "User", USER_PROFILE.getBirthDate(), USER_PROFILE.getGender() ).getUserProfile();
//		
//		assertNotNull( userProfile );
//		assertEquals( PasswordHintQuestionEnumeration.FAVORITEFOOD, userProfile.getPasswordHintQuestion1().getName() );
//		assertEquals( PasswordHintQuestionEnumeration.PETNAME, userProfile.getPasswordHintQuestion2().getName() );
//		assertNull( userProfile.getPasswordHintAnswer1() );
//		assertNull( userProfile.getPasswordHintAnswer2() );
//		assertNull( userProfile.getUserName() );
	}
	
	public void testGetPasswordHintsForForgottenPassword() {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile userProfile = delegate.getPasswordHintsForForgottenPassword( "joequser", "Joe", "User", USER_PROFILE.getBirthDate(), USER_PROFILE.getGender() ).getUserProfile();
//		
//		assertNotNull( userProfile );
//		assertEquals( PasswordHintQuestionEnumeration.FAVORITEFOOD, userProfile.getPasswordHintQuestion1().getName() );
//		assertEquals( PasswordHintQuestionEnumeration.PETNAME, userProfile.getPasswordHintQuestion2().getName() );
//		assertNull( userProfile.getPasswordHintAnswer1() );
//		assertNull( userProfile.getPasswordHintAnswer2() );
//		assertNull( userProfile.getUserName() );
	}
	
	public void testGetForgottenUserName() {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile userProfile = delegate.getPasswordHintsForForgottenUserName( "Joe", "User", USER_PROFILE.getBirthDate(), USER_PROFILE.getGender() ).getUserProfile();
//		
//		String userName = delegate.getForgottenUserName( userProfile, "Spaghetti", "Spot" ).getString();
//		
//		assertEquals( "joequser", userName );
	}
	
	public void testVerifyPasswordHints() {
//		UserProfileServiceDelegate delegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
//		UserProfile userProfile = delegate.getPasswordHintsForForgottenPassword( "joequser", "Joe", "User", USER_PROFILE.getBirthDate(), USER_PROFILE.getGender() ).getUserProfile();
//		
//		boolean b = delegate.verifyPasswordHints( userProfile, "Spaghetti", "Spot" ).getBoolean().booleanValue();
//		
//		assertTrue( b );
	}
	
	public void testDeleteUserProfile() throws Exception {
//		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
//		UserProfileServiceResponse response = delegate.delete( USER_PROFILE.getUserProfilePK() );
//		
//		assertFalse( response.getMessages().hasErrorMessages() || response.getUserProfile().getMessages().hasErrorMessages() );
	}
	
}
