<h2>Account Activity Logging (AAL) Summary</h2>
<p>Account Activity Logging allows My Health<span class="mhv-e">e</span>Vet registered users to monitor their account activity, such as who accessed the account or made a change, what change was made and when, what information was accessed and when, and the type of action that was performed. My Health<span class="mhv-e">e</span>Vet monitors account activity performed by the users and their delegates, My Health<span class="mhv-e">e</span>Vet authenticators and administrators, and My Health<span class="mhv-e">e</span>Vet Help Desk staff. </p>

<p>In addition, Account Activity Logging allows VHA to maintain user activity records in conformance with applicable compliance requirements of HIPAA privacy and security rules.</p>

<h3>Using this Page</h3>



<p><strong>Date/Time (CST- Central Standard Time):</strong> The My Health<span class="mhv-e">e</span>Vet servers are located in the Central Time Zone and are therefore synchronized with CST. Therefore, My Health<span class="mhv-e">e</span>Vet displays all account activity time as Central Standard Time. To convert your time from CST, use the links below.</p>
<ul>
<li><strong>Central Standard Time</strong> (CST) is the <a href="http://en.wikipedia.org/wiki/Central_Time_zone" target="_blank">Central Time Zone</a> of the United States of America (USA). Some cities in the CST are Chicago, Houston, Minneapolis, and New Orleans. The <strong>Central Time Zone</strong> observes <a href="http://en.wikipedia.org/wiki/Standard_time" target="_blank">standard time</a> by subtracting six hours from Greenwich Mean Time during standard time, and five hours during <a href="http://en.wikipedia.org/wiki/Daylight_saving" target="_blank">daylight saving</a> time. The Central Time Zone is one hour ahead of the <a href="http://en.wikipedia.org/wiki/Mountain_Time_Zone" target="_blank">Mountain Time Zone</a> and one hour behind the <a href="http://en.wikipedia.org/wiki/Eastern_Time_Zone" target="_blank">Eastern Time Zone</a> in the United States.</li>

<li><strong>Use the links below for more information on Central Standard Time and other time zones</strong><br />
  <a href="http://www.time.gov/" target="_blank">http://www.time.gov/</a> (This site displays a map with designated time zones for the United States.)
  <a href="http://www.timeanddate.com/worldclock/" target="_blank">    http://www.timeanddate.com/worldclock/</a> (This site has a time zone converter, and more information on time zones around the world.)</li>

</ul>

<p><strong>Performed By:</strong> This column displays the person who accessed the account.</p>

<ul>
<li>Everyone</li>
<li>Everyone but Self</li>
<li>Self</li>
<li>Help Desk Administrator</li>
<li>MHV Authenticator</li>
<li>Unknown</li>
</ul>
<p><strong>Activity: </strong>This column displays the activity that was performed when the account was accessed.</p>
<p><strong>Action:</strong> The action that is listed is dependent upon the activity displayed in the Activity column.</p>


<table width="80%">
  <tr>
    <td valign="top"><strong>Activity</strong></td>
    <td valign="top"><strong>Action</strong></td>
  </tr>
  <tr>
    <td valign="top">Change Password</td>
    <td valign="top">Password Changed</td>
  </tr>
  <tr>
    <td valign="top">In-Person Authentication</td>
    <td valign="top">Authenticated<br />
Authentication Revoked	<br />
In Process</td>
  </tr>
  <tr>
    <td valign="top">Login/Logout</td>
    <td valign="top">Concurrent Logon <br />
Last Successful Login<br />
Login<br />
Logout<br />
Unsuccessful logon Attempt</td>
  </tr>
  <tr>
    <td valign="top">Profile	</td>
    <td valign="top">Update</td>
  </tr>
  <tr>
    <td valign="top">Registration</td>
    <td valign="top">Account Created</td>
  </tr>
  <tr>
    <td valign="top">Reset Password</td>
    <td valign="top">Password Reset</td>
  </tr>  
</table>

<p><strong>Result: </strong>The result of the action is either Successful, or Unsuccessful (for example, an invalid password or invalid data was entered). <strong>NOTE: </strong>The user is allowed five (5) unsuccessful attempts before being locked out of the session.
<p><strong>Return to Summary:</strong> Click this button to return to the Account Activity History.</p>


<h3>Printer Friendly Screen</h3> 
<p>The Printer Friendly screen provides a printer-friendly format for the information, designed to print neatly on an 8- by 11 inch sheet of paper. The information on this page consists of the entries displayed on the previous screen. (To print different information, return to the previous screen, make your selection and then click the Printer Friendly link to return to this page.) A border, indicated by the phrase "The printable information appears within this border", outlines the main content area. The only information that will print is inside the border although other information may be outside of the border.</p>




	
	
	
		

	
	









