<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean"%>
<%@ taglib uri="/WEB-INF/displaytag-12.tld" prefix="display"%>
<%@taglib uri="http://www.bea.com/workshop/netui-tags-html-1.0" prefix="netui-compat"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<!-- Begin Portlet Titlebar -->
<table border="0" cellpadding="0" cellspacing="0" class="bea-portal-layout">
  <tr>
    <td class="mhv-portlet-title-td">Manage VA Staff</td>
    <td class="mhv-username-date-td">&nbsp;</td>
  </tr>
</table>

<!--Begin 7.0 Toolbar -->
<div class="mhv-portlet-toolbar"> 
	<a href="<%=request.getContextPath()%>/resources/jsp/help.jsp?helpDirectRequest=mur_manage-roles.html" target="_mhvHelp">Help <img src="<%=request.getContextPath()%>/resources/images/icon_help.gif" alt="View Help File" border="0" /></a>
</div>

<!-- Begin Messages -->
<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>

<!-- Begin Demographic Info-->
<%@ include file="employeeDetailHeader.jspf" %>

<br />

<!-- Begin Portlet Section Tabs-->
<div class="mhv-portlet-section-tabs">
	<span>Assign Roles</span>&nbsp;
	<netui:anchor action="gotoRoleHistoryTab">Role History</netui:anchor>&nbsp;
	<netui:anchor action="gotoDefaultStateManageCommentsTab">Comments</netui:anchor>
</div>

<!-- Begin Portlet Section Heading-->
<h3>Assign New Role</h3>

<!--Begin Instructional Content -->
<p>To assign a new role: Select the appropriate Organization Level, then click the “Next” button to retrieve the list of organizations. Select the Organization, then click the “Next” button to retrieve possible roles. Finally, select the Role and click the “Save” button.</p>

<!-- Begin Form -->
<p><span class="mhv-required">*</span>Indicates Required Information</p>
<netui:form action="assignRoleWizardStep3ChooseRole">	
	<table border="0" cellpadding="0" cellspacing="0" class="mhv-detail-listing" summary="Assign New Role">	
    		<c:choose>
    			<c:when test="${actionForm.organizationId != null && actionForm.organizationType != null}">
					<tr>
				        <th scope="row"><label for="orgLevel">Organization Level<span class="mhv-required">*</span>:</label></th>
						<td><netui:select dataSource="actionForm.organizationType" tagId="orgLevel" optionsDataSource="${actionForm.orgTypesSelectOptions}" disabled="true"></netui:select>
							&nbsp;<netui:hidden dataSource="actionForm.organizationType"></netui:hidden></td>
					</tr>
					<tr>
				        <th scope="row"><label for="organization">Organization<span class="mhv-required">*</span>:</label></th>
						<td><netui:select tagId="organization" dataSource="actionForm.organizationId" optionsDataSource="${actionForm.orgsOfTypeSelectOptions}" disabled="true"></netui:select>
							&nbsp;<netui:hidden dataSource="actionForm.organizationId"></netui:hidden></td>
					</tr>
					<tr>
				        <th scope="row"><label for="role">Role<span class="mhv-required">*</span>:</label></th>
						<td><netui:select tagId="role" dataSource="actionForm.roleId" optionsDataSource="${actionForm.roleSelectOptions}"></netui:select></td>
					</tr>
				</c:when>
				<c:when test="${actionForm.organizationType != null}">
					<tr>
				        <th scope="row"><label for="orgLevel">Organization Level<span class="mhv-required">*</span>:</label></th>
						<td><netui:select dataSource="actionForm.organizationType" tagId="orgLevel" optionsDataSource="${actionForm.orgTypesSelectOptions}" disabled="true"></netui:select>
							<netui:hidden dataSource="actionForm.organizationType"></netui:hidden>
						</td>      
					</tr>
					<tr>
				        <th scope="row"><label for="organization">Organization<span class="mhv-required">*</span>:</label></th>
						<td><netui:select tagId="organization" dataSource="actionForm.organizationId" optionsDataSource="${actionForm.orgsOfTypeSelectOptions}"></netui:select>
							&nbsp;&nbsp;&nbsp;<netui:button action="assignRoleWizardStep2ChooseOrg" value="Next >" styleClass="mhv-input-button"  />
						</td>
					</tr>
					<tr>
				        <th scope="row"><label for="role" >Role<span class="mhv-required">*</span>:</label></th>
						<td><select disabled="true" id="role"><option>Select Role...</option></select></td>
					</tr>
				</c:when>
				<c:otherwise>
					<tr>
				        <th scope="row"><label for="orgLevel">Organization Level<span class="mhv-required">*</span>:</label></th>
						<td><netui:select dataSource="actionForm.organizationType" tagId="orgLevel" optionsDataSource="${actionForm.orgTypesSelectOptions}"></netui:select>
							&nbsp;&nbsp;&nbsp;<netui:button action="assignRoleWizardStep1ChooseOrgType" value="Next >" styleClass="mhv-input-button" />
						</td>   
					</tr>
					<tr>
				        <th scope="row"><label for="organization">Organization<span class="mhv-required">*</span>:</label></th>
						<td><select disabled="true" id="organization"><option>Select Organization...</option></select></td>    
					</tr>
					<tr>
				        <th scope="row"><label for="role" >Role<span class="mhv-required">*</span>:</label></th>
						<td><select disabled="true" id="role"><option>Select Role...</option></select></td>
					</tr>
				</c:otherwise>
			</c:choose>
	</table>

	<!-- Begin Form Buttons-->
	<div class="mhv-button-container-align-right">
	    <c:choose>
	    	<c:when test="${actionForm.organizationId != null && actionForm.organizationType != null}">    
	    		&nbsp;&nbsp;&nbsp;<netui:button type="submit" action="assignRoleWizardStep3ChooseRole" value="Save" styleClass="mhv-input-button"/>
	    	</c:when>
	    	<c:otherwise>
	    		<input type="submit" value="Save" class="mhv-input-button" disabled="true"/>
	    	</c:otherwise>
	    </c:choose>
		&nbsp;&nbsp;&nbsp;<netui:button type="submit" action="assignRoleWizardReset" value="Reset" styleClass="mhv-input-button"/> 
		&nbsp;&nbsp;&nbsp;<netui:button type="submit" action="assignRoleWizardCancel" value="Cancel" styleClass="mhv-input-button"/> 
	</div>

</netui:form>	

<hr />

<!-- Begin 2nd Portlet Section Heading-->
<h3>Update Current Roles</h3>

<!--Begin 2nd Instructional Content -->
<c:choose>
	<c:when test="${empty pageFlow.employeeToManageRoles}" >
		<p>There are currently no roles assigned to this user.</p>
	</c:when>
	<c:otherwise>
		<p>
			This staff member has been assigned <c:out value="${fn:length(pageFlow.employeeToManageRoles)}" /> roles.  
			&nbsp;&nbsp;Click <img src="<%=request.getContextPath()%>/resources/images/icons15/icoDeactivate15.gif" alt="Deactivate" border="0" /> to deactivate a current role.
			&nbsp;&nbsp;Click <img src="<%=request.getContextPath()%>/resources/images/icons15/icoActivate15.gif" alt="Activate" border="0" /> to activate a role.
		</p>
		
		<!--Begin Icon Definition -->
		<p><strong>Status Key:</strong></p>
		<p>
			<img src="<%=request.getContextPath()%>/resources/images/icons15/icoActive15.gif" alt="Active" border="0" align="absmiddle" />&nbsp;&nbsp;<strong>Active.</strong>&nbsp;&nbsp;The role is currently active.
			<br /><img src="<%=request.getContextPath()%>/resources/images/icons15/icoInactive15.gif" alt="Inactive" border="0" align="absmiddle" />&nbsp;&nbsp;<strong>Inactive.</strong>&nbsp;&nbsp;The role is currently inactive.
		</p>
		
		<!-- Begin 2nd Form -->
		<br />
		<display:table sort="list" pagesize="10" requestURI="/gotoDefaultStateManageRoleTab.do" 
		    uid="row" name="${pageFlow.employeeToManageRoles}" summary="List of current role assignments for employee.">
		    <display:column title="Status" sortable="true" sortProperty="active" class="mhv-list-cell-center">
		    	<c:if test="${row.active == true}"><img src="<%=request.getContextPath()%>/resources/images/icons15/icoActive15.gif" alt="Active" border="0" align="absmiddle" /></c:if>
		    	<c:if test="${row.active == false}"><img src="<%=request.getContextPath()%>/resources/images/icons15/icoInactive15.gif" alt="Inactive" border="0" align="absmiddle" /></c:if>
		    </display:column>
		    <display:column property="organization.typeOfOrganization.name" title="Level" sortable="true"/>
		    <display:column property="role.name" title="Role" sortable="true"/> 			    
		    <display:column property="organization.name" title="Organization" sortable="true"/>	
		    <display:column title="Activate" class="mhv-list-cell-center">		    	
		    	<c:if test="${row.active == false}">
		    		<netui:anchor action="activateEmployeeOrgRole">
		    			<img src="<%=request.getContextPath()%>/resources/images/icons15/icoActivate15.gif" alt="Click to Activate" border="0" />
		    			<netui:parameter name="id" value="${row.id}" />
					</netui:anchor>
				</c:if>
		    </display:column>
		    <display:column title="Deactivate" class="mhv-list-cell-center">		    	
		    	<c:if test="${row.active == true}">
		    		<netui:anchor action="deactivateEmployeeOrgRole">
		    			<img src="<%=request.getContextPath()%>/resources/images/icons15/icoDeactivate15.gif" alt="Click to Deactivate" border="0" />
		    			<netui:parameter name="id" value="${row.id}" />
					</netui:anchor>
				</c:if>
		    </display:column>	
		</display:table>
	</c:otherwise>
</c:choose>

<div class="mhv-button-container-align-right">
	<netui:anchor action="returnToSearchResults" styleClass="mhv-input-button">Return to Search Results</netui:anchor>
</div>
