<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean"%>
<%@ taglib uri="/WEB-INF/displaytag-12.tld" prefix="display"%>
<%@taglib uri="http://www.bea.com/workshop/netui-tags-html-1.0" prefix="netui-compat"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<!-- Begin Portlet Titlebar -->
<table border="0" cellpadding="0" cellspacing="0" class="bea-portal-layout">
  <tr>
    <td class="mhv-portlet-title-td">Manage VA Staff</td>
    <td class="mhv-username-date-td">&nbsp;</td>
  </tr>
</table>

<!--Begin 7.0 Toolbar -->
<div class="mhv-portlet-toolbar">
	<a href="<%=request.getContextPath()%>/resources/jsp/help.jsp?helpDirectRequest=mur_current-assignments.html" target="_mhvHelp">Help <img src="<%=request.getContextPath()%>/resources/images/icon_help.gif" alt="View Help File" border="0" /></a>
</div>

<!-- Begin Messages -->
<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>

<!-- Begin Portlet Heading -->
<h2>View Current Role Assignments</h2>

<!--Begin Instructional Content -->
<p>The following is a list of all VA staff who have been assigned MHV roles. Click a name to view details or to assign, modify, or remove roles. Click the “Search for VA Staff” button to add a VA staff member to this list for assignment of administrative roles.</p>

<!--Begin Icon Definition -->
<p><strong>Status Key:</strong></p>
<p>
	<img src="<%=request.getContextPath()%>/resources/images/icons15/icoActive15.gif" alt="Active" border="0" />&nbsp;&nbsp;<strong>Active:</strong>&nbsp;&nbsp;the staff member's MHV administrative role is currently active.
	<br /><img src="<%=request.getContextPath()%>/resources/images/icons15/icoInactive15.gif" alt="Inactive" border="0" />&nbsp;&nbsp;<strong>Inactive:</strong>&nbsp;&nbsp;the staff member's MHV administrative role is currently inactive.
</p>

<!-- Begin Data Listing-->
<display:table pagesize="10" 				
	requestURI="/viewCurrentRoleAssignments.do" 
    uid="row" name="${pageFlow.employeeOrganizationRolesEmployeeCanManage}" sort="list" defaultorder="ascending" summary="List of current role assignments.">
    <display:column title="Name" sortable="true" sortProperty="employee.lastName" 
        href="manageEmployeeRoleAssignments.do" paramId="userName" paramProperty="employee.userName">
    	<c:out value="${row.employee.lastName}" />, <c:out value="${row.employee.firstName}" />
    </display:column>			    
    <display:column property="employee.userName" title="VA User ID" sortable="true"/>
    <display:column title="Status" sortable="true" sortProperty="active" class="mhv-list-cell-center"
    				comparator="gov.va.med.mhv.usermgmt.util.ReverseBooleanComparator">
    	<c:if test="${row.active == true}"><img src="<%=request.getContextPath()%>/resources/images/icons15/icoActive15.gif" alt="Active" border="0" /></c:if>
    	<c:if test="${row.active == false}"><img src="<%=request.getContextPath()%>/resources/images/icons15/icoInactive15.gif" alt="Inactive" border="0" /></c:if>
    </display:column> 
    <display:column property="organization.typeOfOrganization.name" title="Level" sortable="true"/>
   	<display:column property="role.name" title="Role" sortable="true"/> 			    
   	<display:column property="organization.name" title="Organization" sortable="true"/>	
</display:table>

<!-- Begin Form Buttons-->
<div class="mhv-button-container-align-right">
	<netui:anchor action="newSearch" styleClass="mhv-input-button">Search for VA Staff</netui:anchor>
</div>
