<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean"%>
<%@ taglib uri="/WEB-INF/displaytag-12.tld" prefix="display"%>
<%@taglib uri="http://www.bea.com/workshop/netui-tags-html-1.0" prefix="netui-compat"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<!-- Begin Portlet Titlebar -->
<table border="0" cellpadding="0" cellspacing="0" class="bea-portal-layout">
  <tr>
    <td class="mhv-portlet-title-td">Manage VA Staff</td>
    <td class="mhv-username-date-td">&nbsp;</td>
  </tr>
</table>

<!--Begin 7.0 Toolbar -->
<div class="mhv-portlet-toolbar">
	<a href="<%=request.getContextPath()%>/resources/jsp/help.jsp?helpDirectRequest=mur_role-history.html" target="_mhvHelp">Help <img src="<%=request.getContextPath()%>/resources/images/icon_help.gif" alt="View Help File" border="0" /></a>
</div>

<!-- Begin Messages -->
<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>

<!-- Begin Demographic Info-->
<%@ include file="employeeDetailHeader.jspf" %>

<!-- Begin Portlet Section Tabs-->
<div class="mhv-portlet-section-tabs">
	<netui:anchor action="gotoDefaultStateManageRoleTab">Assign Roles</netui:anchor>&nbsp;
	<span>Role History<span>&nbsp;
	<netui:anchor action="gotoDefaultStateManageCommentsTab">Comments</netui:anchor>	
</div>

<!-- Begin Portlet Section Heading-->
<h3>View Role History</h3>

<!--Begin Instructional Content -->
<c:choose>
	<c:when test="${empty pageFlow.employeeToManageRoleHistory}" >
		<p>This staff member has never been assigned a role.</p>
	</c:when>
	<c:otherwise>
		<p>This staff member has been assigned <c:out value="${fn:length(pageFlow.employeeToManageRoleHistory)}" /> roles.</p>
		<display:table sort="list" pagesize="10" 
			decorator="gov.va.med.mhv.usermgmt.decorator.RoleHistoryDecorator"
			requestURI="/gotoRoleHistoryTab.do" 
		    uid="row" name="${pageFlow.employeeToManageRoleHistory}" summary="List of role history.">
		    <display:setProperty name="custom.sort.class" value="gov.va.med.mhv.usermgmt.util.RoleHistorySorter" />
		    <display:column property="date" title="Date" sortable="true"/>
		    <display:column property="employeeOrganizationRole.organization.typeOfOrganization.name" title="Level" sortable="true"/>
		    <display:column property="employeeOrganizationRole.role.name" title="Role" sortable="true"/> 			    
		    <display:column property="employeeOrganizationRole.organization.name" title="Organization" sortable="true"/>
		    <display:column title="Action" sortable="true" sortProperty="roleAction.name">
		    	<c:choose>
				  <c:when test="${row.roleAction.name == 'Add'}">Added Role</c:when>
				  <c:when test="${row.roleAction.name == 'Activate'}">Activated Role</c:when>
				  <c:when test="${row.roleAction.name == 'Deactivate'}">Removed Role</c:when>
				  <c:otherwise><c:out value="${row.roleAction.name}" /></c:otherwise>
				</c:choose>
		    </display:column>
		    <display:column property="performingEmployee.userName" title="Admin Network ID" sortable="true"/>
		</display:table>		
	</c:otherwise>
</c:choose>

<div class="mhv-button-container-align-right">
	<netui:anchor action="returnToSearchResults" styleClass="mhv-input-button">Return to Search Results</netui:anchor>
</div>

