 <%@ page language="java" contentType="text/html;charset=UTF-8"%>

<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>

<%@ include file="/resources/jsp/CalendarPopup.jspf"%>
		<!-- Begin Portlet Titlebar -->
		<table border="0" cellpadding="0" cellspacing="0" class="bea-portal-layout">
		    <tr>
		        <td class="mhv-portlet-title-td">Manage MHV Users (All Accounts)</td>
		        <td class="mhv-username-date-td">&nbsp;</td>
		    </tr>
		</table>
		
		<!--Begin 7.0 Toolbar -->
		<div class="mhv-portlet-toolbar">
			<a href="<%=request.getContextPath()%>/resources/jsp/help.jsp?helpDirectRequest=ipa_all_accounts_search.html" target="_mhvHelp">Help <img src="<%=request.getContextPath()%>/resources/images/icon_help.gif" alt="View Help File" border="0" /></a>
		</div>

		<!-- Begin Messages -->
		<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>
		
		<!--Begin Portlet Heading -->
		<h2>Search MHV Users</h2>
		
		<!--Begin Instructional Content -->
		<p>
			To view account details for a specific MHV user, please complete the information below. The more information you provide will help narrow down the possible matches.
		</p>
		<p>
			<b>Note:</b> The <i><b>Cancel</b></i> button will take you back to the <i><b>IPA-Search for Advance/Premium Accounts</b></i> page.
		</p>
				
		<netui:form action="basicSearch">
			<table border="0" cellpadding="2" cellspacing="0" summary="">
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaFirstPlusFour" value="First Letter of Last Name + Last 4 of SSN"/>:
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ipaFirstPlusFourErrorMessage}"/></span></div>
						<netui:textBox dataSource="actionForm.ipaFirstPlusFour" size="5" maxlength="5" tagId="ipaFirstPlusFour"/>
					</td>
				</tr>
			</table>
			
			<hr/>
			
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaFirstName" value="First Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaFirstName" tagId="ipaFirstName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						SSN:
						<netui:label for="ssn1" value="First 3 SSN" styleClass="mhv-hidden-label"/>
						<netui:label for="ssn2" value="Second 2 SSN" styleClass="mhv-hidden-label"/>
						<netui:label for="ssn3" value="Last 4 SSN" styleClass="mhv-hidden-label"/>
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ssnFieldLevelErrorMessage}"/></span></div>
						<netui:textBox dataSource="actionForm.ssn1" tagId="ssn1" size="3" maxlength="3"/>-
						<netui:textBox dataSource="actionForm.ssn2" tagId="ssn2" size="2" maxlength="2"/>-
						<netui:textBox dataSource="actionForm.ssn3" tagId="ssn3" size="4" maxlength="4"/>
					</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaMiddleName" value="Middle Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaMiddleName" tagId="ipaMiddleName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						Date of Birth:
						<netui:label for="ipaDateOfBirthMonth" value="Month of Birth" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaDateOfBirthDay" value="Day of Birth" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaDateOfBirthYear" value="Year of Birth" styleClass="mhv-hidden-label"/>
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ipaDateOfBirthErrorMessage}"/></span></div>
						<netui:select nullable="true" nullableOptionText="Month" tagId="ipaDateOfBirthMonth" dataSource="actionForm.ipaDateOfBirthMonth" optionsDataSource="${pageFlow.monthOptions}"/>
						<netui:select nullable="true" nullableOptionText="Day" tagId="ipaDateOfBirthDay" dataSource="actionForm.ipaDateOfBirthDay" optionsDataSource="${pageFlow.dayOptions}"/>
						<netui:select nullable="true" nullableOptionText="Year" tagId="ipaDateOfBirthYear" dataSource="actionForm.ipaDateOfBirthYear" optionsDataSource="${pageFlow.yearOptions}"/>
					    <script>
					    	var birthDateCal = new MHVCalendarPopup();
					    	birthDateCal.setYearFieldId('ipaDateOfBirthYear');
					    	birthDateCal.setMonthFieldId('ipaDateOfBirthMonth');
					    	birthDateCal.setDayFieldId('ipaDateOfBirthDay');
					    	birthDateCal.setCalYearEnd(<%=org.tigris.atlas.util.CalendarUtils.getCurrentYear()%>);
					    	birthDateCal.setCalYearStart(<%=org.tigris.atlas.util.CalendarUtils.getFirstYear()%>);	
					    	birthDateCal.setContext('<%=request.getContextPath()%>/resources');
					    	birthDateCal.writeCalendarLink('birthDateCal');
					    </script>
					    <noscript>
					     <!-- For 508 Compliance -->
					    </noscript>  	
					</td>
				</tr>
				<!-- MHV_CodeCR1387 -  Added middle name-->
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaLastName" value="Last Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaLastName" tagId="ipaLastName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaMhvId" value="MHV ID"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaMhvId" tagId="ipaMhvId" maxlength="12"/>
					</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaEmail" value="Email"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaEmail" tagId="ipaEmail" size="30" maxlength="100"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">&nbsp;</th>
					<td>&nbsp;</td>
				</tr>
			</table>
			<br/>
			<br/>
			<br/>
			<br/>
			<div class="mhv-button-container-align-right">
				<netui:anchor formSubmit="true" value="Cancel" action="launchAdvancedSearch" type="submit" styleClass="mhv-input-button"/>
				<netui:anchor value="Reset" action="reset" type="button" styleClass="mhv-input-button"/>
				<netui:anchor formSubmit="true" value="Search" action="basicSearch" type="submit" styleClass="mhv-input-button"/>
			</div>
		</netui:form>