 <%@ page language="java" contentType="text/html;charset=UTF-8"%>

<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%@ include file="/resources/jsp/CalendarPopup.jspf"%>
		<!-- Begin Portlet Titlebar -->
		<table border="0" cellpadding="0" cellspacing="0" class="bea-portal-layout">
		    <tr>
		        <td class="mhv-portlet-title-td">Manage MHV Users (Advanced and Premium Accounts)</td>
		        <td class="mhv-username-date-td">&nbsp;</td>
		    </tr>
		</table>
		
		<!--Begin 7.0 Toolbar -->
		<div class="mhv-portlet-toolbar">
			<a href="<%=request.getContextPath()%>/resources/jsp/help.jsp?helpDirectRequest=ipa_search.html" target="_mhvHelp">Help <img src="<%=request.getContextPath()%>/resources/images/icon_help.gif" alt="View Help File" border="0" /></a>
		</div>

		<!-- Begin Messages -->
		<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>
		
		<!--Begin Portlet Heading -->
		<h2>Search MHV Users</h2>
		
		<!--Begin Instructional Content -->
		<p>
			Search for a specific MHV user or a group of users to authenticate. Providing more information will result in a shorter list of possible matches.
		</p>
				
		<netui:form action="search">
			<table border="0" cellpadding="2" cellspacing="0" summary="">
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaFirstPlusFour" value="First Letter of Last Name + Last 4 of SSN"/>:
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ipaFirstPlusFourErrorMessage}"/></span></div>
						<netui:textBox dataSource="actionForm.ipaFirstPlusFour" size="5" maxlength="5" tagId="ipaFirstPlusFour"/>
					</td>
				</tr>
			</table>
			
			<hr/>
			
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
                    <!-- MHV00001194 Take out MHV User ID:-->
					<th scope="row" class="mhv-basic-layout-scope-row">
						SSN:
						<netui:label for="ssn1" value="First 3 SSN" styleClass="mhv-hidden-label"/>
						<netui:label for="ssn2" value="Second 2 SSN" styleClass="mhv-hidden-label"/>
						<netui:label for="ssn3" value="Last 4 SSN" styleClass="mhv-hidden-label"/>
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ssnFieldLevelErrorMessage}"/></span></div>
						<netui:textBox dataSource="actionForm.ssn1" tagId="ssn1" size="3" maxlength="3"/>-
						<netui:textBox dataSource="actionForm.ssn2" tagId="ssn2" size="2" maxlength="2"/>-
						<netui:textBox dataSource="actionForm.ssn3" tagId="ssn3" size="4" maxlength="4"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">&nbsp;</th>
					<td>&nbsp;</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaFirstName" value="First Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaFirstName" tagId="ipaFirstName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						Date of Birth:
						<netui:label for="ipaDateOfBirthMonth" value="Month of Birth" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaDateOfBirthDay" value="Day of Birth" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaDateOfBirthYear" value="Year of Birth" styleClass="mhv-hidden-label"/>
					</th>
					<td>
						<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ipaDateOfBirthErrorMessage}"/></span></div>
						<netui:select nullable="true" nullableOptionText="Month" tagId="ipaDateOfBirthMonth" dataSource="actionForm.ipaDateOfBirthMonth" optionsDataSource="${pageFlow.monthOptions}"/>
						<netui:select nullable="true" nullableOptionText="Day" tagId="ipaDateOfBirthDay" dataSource="actionForm.ipaDateOfBirthDay" optionsDataSource="${pageFlow.dayOptions}"/>
						<netui:select nullable="true" nullableOptionText="Year" tagId="ipaDateOfBirthYear" dataSource="actionForm.ipaDateOfBirthYear" optionsDataSource="${pageFlow.yearOptions}"/>
					    <script>
					    	var birthDateCal = new MHVCalendarPopup();
					    	birthDateCal.setYearFieldId('ipaDateOfBirthYear');
					    	birthDateCal.setMonthFieldId('ipaDateOfBirthMonth');
					    	birthDateCal.setDayFieldId('ipaDateOfBirthDay');
					    	birthDateCal.setCalYearEnd(<%=org.tigris.atlas.util.CalendarUtils.getCurrentYear()%>);
					    	birthDateCal.setCalYearStart(<%=org.tigris.atlas.util.CalendarUtils.getFirstYear()%>);	
					    	birthDateCal.setContext('<%=request.getContextPath()%>/resources');
					    	birthDateCal.writeCalendarLink('birthDateCal');
					    </script>
					    <noscript>
					     <!-- For 508 Compliance -->
					    </noscript>  	
					</td>
				</tr>
				<!-- MHV_CodeCR1387 - Added middle name-->
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaMiddleName" value="Middle Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaMiddleName" tagId="ipaMiddleName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaMhvId" value="MHV ID"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaMhvId" tagId="ipaMhvId" maxlength="12"/>
					</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaLastName" value="Last Name"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaLastName" tagId="ipaLastName" size="30" maxlength="30"/>
					</td>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="ipaEmail" value="Email"/>:
					</th>
					<td>
						<netui:textBox dataSource="actionForm.ipaEmail" tagId="ipaEmail" size="30" maxlength="100"/>
					</td>
				</tr>
			</table>
			<br/>
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
					<th scope="row" rowspan="3" width="150" class="mhv-basic-layout-scope-row">
						Match Status:
					</th>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusMatched" tagId="ipaStatusMatched"/>
						<netui:label for="ipaStatusMatched" value="Matched"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusUnmatched" tagId="ipaStatusUnmatched"/>
						<netui:label for="ipaStatusUnmatched" value="Unmatched"/>
					</td>
				</tr>
			</table>
			<br/>
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
					<th scope="row" rowspan="3" width="150" class="mhv-basic-layout-scope-row">
						Correlation Status:
					</th>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusCorrelated" tagId="ipaStatusCorrelated"/>
						<netui:label for="ipaStatusCorrelated" value="Correlated"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusUncorrelated" tagId="ipaStatusUncorrelated"/>
						<netui:label for="ipaStatusUncorrelated" value="Uncorrelated"/>
					</td>
				</tr>
				<tr>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusPendingCorrelation" tagId="ipaStatusPendingCorrelation"/>
						<netui:label for="ipaStatusPendingCorrelation" value="Pending Correlation"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusPendingUncorrelated" tagId="ipaStatusPendingUncorrelated"/>
						<netui:label for="ipaStatusPendingUncorrelated" value="Pending Uncorrelation"/>
					</td>
				</tr>	
				<tr>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusFailedCorrelation" tagId="ipaStatusFailedCorrelation"/>
						<netui:label for="ipaStatusFailedCorrelation" value="Failed Correlation"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusFailedUncorrelation" tagId="ipaStatusFailedUncorrelation"/>
						<netui:label for="ipaStatusFailedUncorrelation" value="Failed Uncorrelation"/>
					</td>
				</tr>	
				<tr>
					<td>&nbsp;</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusCorrelationInvalid" tagId="ipaStatusCorrelationInvalid"/>
						<netui:label for="ipaStatusCorrelationInvalid" value="Correlation Invalid"/>
					</td>
				</tr>	
			</table>
			<br/>
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
					<th scope="row" rowspan="3" width="150" class="mhv-basic-layout-scope-row">
						Authentication Status:
					</th>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusAuthenticated" tagId="ipaStatusAuthenticated"/>
						<netui:label for="ipaStatusAuthenticated" value="Authenticated"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusPrerequisitesComplete" tagId="ipaStatusPrerequisitesComplete"/>
						<netui:label for="ipaStatusPrerequisitesComplete" value="Prerequisites Completed"/>
					</td>
					<td>	
						<netui:checkBox dataSource="actionForm.ipaStatusInProcess" tagId="ipaStatusInProcess"/>
						<netui:label for="ipaStatusInProcess" value="In Process"/>
					</td>
				</tr>
				<tr>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusUnauthenticated" tagId="ipaStatusUnauthenticated"/>
						<netui:label for="ipaStatusUnauthenticated" value="Unauthenticated"/> 
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusPendingDataMismatch" tagId="ipaStatusPendingDataMismatch"/>
						<netui:label for="ipaStatusPendingDataMismatch" value="Pending Data Mismatch"/>
					</td>
					<td>
						<netui:checkBox dataSource="actionForm.ipaStatusPendingUnauthentication" tagId="ipaStatusPendingUnauthentication"/>
						<netui:label for="ipaStatusPendingUnauthentication" value="Unauthentication Unsuccessful"/>
					</td>
				</tr>	
			</table>
			<br/>
			<table border="0" cellpadding="2" cellspacing="0" summary="Search MHV Users">
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						
						Authentication Date Range:
						<netui:label for="ipaFromAuthenticationDateMonth" value="From Authentication Date Month" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaFromAuthenticationDateDay" value="From Authentication Date Day" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaFromAuthenticationDateYear" value="From Authentication Date Year" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaToAuthenticationDateMonth" value="To Authentication Date Month" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaToAuthenticationDateDay" value="To Authentication Date Day" styleClass="mhv-hidden-label"/>
						<netui:label for="ipaToAuthenticationDateYear" value="To Authentication Date Year" styleClass="mhv-hidden-label"/>
					</th>
					<td>
						<table>
						<tr>
							<td><div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.dateRangeErrorMessage}"/></span></div></td>
							<td></td>
							<td><div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.toDateRangeErrorMessage}"/></span></div></td>
						</tr>
						<tr>
						<td>
							<netui:select nullable="true" nullableOptionText="Month" tagId="ipaFromAuthenticationDateMonth" dataSource="actionForm.ipaFromAuthenticationDateMonth" optionsDataSource="${pageFlow.monthOptions}"/>
							<netui:select nullable="true" nullableOptionText="Day" tagId="ipaFromAuthenticationDateDay" dataSource="actionForm.ipaFromAuthenticationDateDay" optionsDataSource="${pageFlow.dayOptions}"/>
							<netui:select nullable="true" nullableOptionText="Year" tagId="ipaFromAuthenticationDateYear" dataSource="actionForm.ipaFromAuthenticationDateYear" optionsDataSource="${pageFlow.yearOptions}"/>
							<script>
						    	var ipaFromAuth = new MHVCalendarPopup();
						    	ipaFromAuth.setYearFieldId('ipaFromAuthenticationDateYear');
						    	ipaFromAuth.setMonthFieldId('ipaFromAuthenticationDateMonth');
						    	ipaFromAuth.setDayFieldId('ipaFromAuthenticationDateDay');
						    	ipaFromAuth.setCalYearEnd(<%=org.tigris.atlas.util.CalendarUtils.getCurrentYear()%>);
						    	ipaFromAuth.setCalYearStart(<%=org.tigris.atlas.util.CalendarUtils.getFirstYear()%>);	 
						    	ipaFromAuth.setContext('<%=request.getContextPath()%>/resources');
						    	ipaFromAuth.writeCalendarLink('ipaFromAuth');
						    </script>
						    <noscript>
						     <!-- For 508 Compliance -->
						    </noscript> 
							</td>
							<td>
								<strong>&nbsp;to&nbsp;</strong>
							</td>
							<td>
								<netui:select nullable="true" nullableOptionText="Month" tagId="ipaToAuthenticationDateMonth" dataSource="actionForm.ipaToAuthenticationDateMonth" optionsDataSource="${pageFlow.monthOptions}"/>
								<netui:select nullable="true" nullableOptionText="Day" tagId="ipaToAuthenticationDateDay" dataSource="actionForm.ipaToAuthenticationDateDay" optionsDataSource="${pageFlow.dayOptions}"/>
								<netui:select nullable="true" nullableOptionText="Year" tagId="ipaToAuthenticationDateYear" dataSource="actionForm.ipaToAuthenticationDateYear" optionsDataSource="${pageFlow.yearOptions}"/>
								<script>
							    	var ipaToAuth = new MHVCalendarPopup();
							    	ipaToAuth.setYearFieldId('ipaToAuthenticationDateYear');
							    	ipaToAuth.setMonthFieldId('ipaToAuthenticationDateMonth');
							    	ipaToAuth.setDayFieldId('ipaToAuthenticationDateDay');
							    	ipaToAuth.setCalYearEnd(<%=org.tigris.atlas.util.CalendarUtils.getCurrentYear()%>);
							    	ipaToAuth.setCalYearStart(<%=org.tigris.atlas.util.CalendarUtils.getFirstYear()%>);	  
							    	ipaToAuth.setContext('<%=request.getContextPath()%>/resources');
							    	ipaToAuth.writeCalendarLink('ipaToAuth');
							    </script>
							    <noscript>
							     <!-- For 508 Compliance -->
							    </noscript> 
							</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="authenticatingFacilityId" value="Users authenticated at"/>:
					</th>
					<td>
						<netui:select nullable="true" nullableOptionText="Select Facility" dataSource="actionForm.authenticatingFacilityId" tagId="authenticatingFacilityId" optionsDataSource="${pageFlow.facilityOptions}"/>
					</td>
				</tr>
				<tr>
					<th scope="row" class="mhv-basic-layout-scope-row">
						<netui:label for="treatingFacilityId" value="Users who are VA patients at"/>:
					</th>
					<td>
						<netui:select nullable="true" nullableOptionText="Select Facility" dataSource="actionForm.treatingFacilityId" tagId="treatingFacilityId" optionsDataSource="${pageFlow.facilityOptions}"/>
					</td>
				</tr>
			</table>
			
			<div class="mhv-button-container-align-right">
				<netui:anchor formSubmit="true" value="Go to Search Page – All Accounts" action="launchBasicSearch" type="submit"/>
				<netui:anchor value="Reset" action="reset" type="button" styleClass="mhv-input-button"/>
				<netui:anchor formSubmit="true" value="Search" action="search" type="submit" styleClass="mhv-input-button"/>
			</div>
		</netui:form>