<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@include file="/resources/jsp/defaultNotificationTemplate.jspf"%>
<%@ include file="/resources/jsp/CalendarPopup.jspf"%>
<!-- MHV_CodeCR1387 - Added LastName+SSN, SSN, DOB   -->
	<table class="contentTable">
		<tr>
			<td class="contentCell">
			<h2>Search for a MHV User</h2>

			Enter some or all of the information below and click the Search button to locate the MHV user.
			<br /><br />

			<netui:form action="search">

						<table>
							<tr>
								<td colspan="3"><strong>First Letter of Last Name + Last Four of SSN:</strong></td>
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.firstPlusFourErrorMessage}"/></span></div>
									<label for="firstPlusFour" class="mhv-hidden-label">First Letter of Last Name + Last Four of SSN</label>
									<netui:textBox tagId="firstPlusFour" dataSource="actionForm.firstPlusFour" maxlength="50" size="16"/>
								</td>
							</tr>
							<tr>
								<th align="left"><label for="userProfileLastName">Last Name:</label></th>
								<td>
									<netui:textBox tagId="userProfileLastName" dataSource="actionForm.userProfileLastName" maxlength="50" size="16"/>
								</td>
								<th align="left"><label for="userProfileLastName">ICN:</label></th>
								<td>
									<netui:textBox tagId="userProfileIcn" dataSource="actionForm.icn" maxlength="50" size="16"/>
								</td>
							</tr>
							<tr>
								<th align="left"><label for="userProfileFirstName">First Name:</label></th>
								<td>
									<netui:textBox tagId="userProfileFirstName" dataSource="actionForm.userProfileFirstName" maxlength="50" size="16"/>
								</td>
							</tr>
							<tr>
								<th align="left"><label for="userProfileContactInfoEmail">Email Address:</label></th>
								<td>
									<netui:textBox tagId="userProfileContactInfoEmail" dataSource="actionForm.userProfileContactInfoEmail" maxlength="50" size="16"/>
								</td>
							</tr>
							<tr>
								<th align="left"><label for="mhvId">MHV ID:</label></th>
								<td>
									<netui:textBox tagId="mhvId" dataSource="actionForm.mhvId" maxlength="50" size="16"/>
								</td>
							</tr>
                            				<tr>
								<th align="left"><label for="userName">User Name:</label></th>
								<td>
									<netui:textBox tagId="userName" dataSource="actionForm.userName" maxlength="50" size="16"/>
								</td>
							</tr>
                            				<tr>
								<td colspan="2">
								<fieldset>	
	                        	   				 <legend>SSN:</legend>
										<label for="ssn1">First 3 SSN</label>
										<label for="ssn2">Second 2 SSN</label>
										<label for="ssn3">Last 4 SSN</label>

										<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.ssnFieldLevelErrorMessage}"/></span></div>
										<netui:textBox dataSource="actionForm.ssn1" tagId="ssn1" size="3" maxlength="3"/>-
										<netui:textBox dataSource="actionForm.ssn2" tagId="ssn2" size="2" maxlength="2"/>-
										<netui:textBox dataSource="actionForm.ssn3" tagId="ssn3" size="4" maxlength="4"/>
							 	</fieldset>	
								</td>
							</tr>
                           				 <tr>
								<td  colspan="2">
								<fieldset>	
	                        	   				 <legend>Date of Birth:</legend>
									<label for="userProfileBirthDateMonth">Month of Birth</label>
									<label for="userProfileBirthDateDay">Day of Birth</label>
									<label for="userProfileBirthDateYear">Year of Birth</label>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.dateOfBirthErrorMessage}"/></span></div>
									<netui:select nullable="true" nullableOptionText="Month" tagId="userProfileBirthDateMonth" dataSource="actionForm.userProfileBirthDateMonth" optionsDataSource="${pageFlow.monthOptions}"/>
									<netui:select nullable="true" nullableOptionText="Day" tagId="userProfileBirthDateDay" dataSource="actionForm.userProfileBirthDateDay" optionsDataSource="${pageFlow.dayOptions}"/>
									<netui:select nullable="true" nullableOptionText="Year" tagId="userProfileBirthDateYear" dataSource="actionForm.userProfileBirthDateYear" optionsDataSource="${pageFlow.yearOptions}"/>
								    <script>
								    	var birthDateCal = new MHVCalendarPopup();
								    	birthDateCal.setYearFieldId('userProfileBirthDateYear');
								    	birthDateCal.setMonthFieldId('userProfileBirthDateMonth');
								    	birthDateCal.setDayFieldId('userProfileBirthDateDay');
								    	birthDateCal.setCalYearEnd(<%=org.tigris.atlas.util.CalendarUtils.getCurrentYear()%>);
								    	birthDateCal.setCalYearStart(<%=org.tigris.atlas.util.CalendarUtils.getFirstYear()%>);	
								    	birthDateCal.setContext('<%=request.getContextPath()%>/resources');
								    	birthDateCal.writeCalendarLink('birthDateCal');
								    </script>
								    <noscript>
								     <!-- For 508 Compliance -->
								    </noscript>  
							 	</fieldset>	
    
								</td>
							</tr>
						</table>
				<br/>


				<netui:button value="Search" type="submit" styleClass="mhv-input-button"/>

			</netui:form>

			</td>
		</tr>
	</table>
