<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>


	<%@include file="/resources/jsp/defaultNotificationTemplate.jspf"%>

	<table>
		<tr>
			<td>

			<netui:form action="sendPassword">

			<h2>Send New Password </h2>

			<br />
			Verify the email address and modify as needed.
			<br />
			Click Send to reply to a password change request with the information listed in the form below.
			<br />
			Click Done after selecting the verification method to record the transaction and return to the View Results / Generate New Password screen.
			<br />
			Click Cancel to return to the View Results / Generate New Password screen without recording the transaction.
			<br />
			<br />

			<table border="0" summary="table used for layout purposes">
				<tr>
					<th align="left"><label for="targetEmail">To:</label></th>
					<td><netui:textBox tagId="targetEmail" dataSource="actionForm.targetEmail" defaultValue="" maxlength="50" size="50"/>&nbsp;</td>
				</tr>
        
        
				<tr>
					<th align="left">Subject:</th>
					<td><span>My HealtheVet Inquiry Response</span></td>
				</tr>

				<tr>
					<th align="left" valign="top">Comments:</th>

					<td>
						We have created a temporary password for you. &nbsp;Please log in to the site with the following password: <strong><netui:span value="${pageFlow.generatedPassword}"/></strong>
						<p>
						When logging in, make sure you type the password exactly as shown; it might be a good idea to copy and paste the password from this message.
						<p>
						After logging in, you will be prompted to create a new password; try choosing one that will be easy for you to remember.
					</td>
				</tr>

				<tr>
					<th align="left"></th>
					<td>
						<netui:textArea dataSource="actionForm.footer" rows="3" cols="128" defaultValue="Let us know if you continue to experience difficulties.  Welcome to My HealtheVet."/>
					</td>
				</tr>

			</table>

			<br />
			(Required if email address in To: field is added or modified)
			<br />

			<table>
				<tr>
					<td>User Identity Verified from:&nbsp;</td>
					<td>
						<label for="verificationMethod" class="mhv-hidden-label">User Identity Verified from</label>
						<netui:select tagId="verificationMethod" dataSource="actionForm.verificationMethod">
							<netui:selectOption value="MHV ID"/>
							<netui:selectOption value="Password Hint Answer 1"/>
							<netui:selectOption value="Password Hint Answer 2"/>
							<netui:selectOption value="Year of Birth"/>
						</netui:select>
					</td>
				</tr>

			</table>

			<br />

			<netui:button action="sendPassword" type="submit" styleClass="mhv-input-button" value="Send"/>
            <netui:button action="begin" type="submit" styleClass="mhv-input-button" value="Done"/>
<%--
			<netui:button action="doneSendPassword" styleClass="mhv-input-button" value="Done"/>

			<netui:button action="cancelSendPassword" type="submit" styleClass="mhv-input-button" value="Cancel"/>
--%>

			</netui:form>
			</td>
		</tr>
	</table>
