<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>
   <table>
	<tr>
		<td>
			<h2>Confirm Deactivation of Account</h2>
			<p>Please verify the account information below.</p>
			<br />
			<p><span class="mhv-required">*</span>Indicates Required Information</p>
				<netui:form action="deactivateUser">
				<%@ include file="userInfo.jspf" %>
				<table>
					<tr>
						<th align="right" valign="top">Description<span class="mhv-required">*</span>:</th>
						<c:choose>
							<c:when test="${pageFlow.displayDeactivateButton}">
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.deactivateNoteErrorMessage}"/></span></div>
									<label for="deactivateNote" class="mhv-hidden-label">Description</label>
									<netui:textArea tagId="deactivateNote" dataSource="actionForm.deactivateNote" rows="3" cols="50"/>
								</td>
							</c:when>
							<c:otherwise>
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.deactivateNoteErrorMessage}"/></span></div>
									<label for="deactivateNote" class="mhv-hidden-label">Description</label>
									<netui:textArea tagId="deactivateNote" dataSource="actionForm.deactivateNote" rows="3" cols="50"  disabled="true"/>
								</td>
							</c:otherwise>
						</c:choose>
					</tr>
					<tr>
						<th align="right" valign="top">Reason for Deactivation<span class="mhv-required">*</span>:</th>
						<c:choose>
							<c:when test="${pageFlow.displayDeactivateButton}">
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.deactivateReasonErrorMessage}"/></span></div>
									<label for="deactivateReason" class="mhv-hidden-label">Reason for Deactivation</label>
									<netui:select dataSource="actionForm.deactivateReason" 
										optionsDataSource="${pageFlow.deactivateReasonLabels}" tagId="deactivateReason" nullable="true" nullableOptionText="Select Reason" onChange="deactivate();"/>
								</td>
							</c:when>
							<c:otherwise>
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.deactivateReasonErrorMessage}"/></span></div>
									<label for="deactivateReason" class="mhv-hidden-label">Reason for Deactivation</label>
									<netui:select dataSource="actionForm.deactivateReason" 
										optionsDataSource="${pageFlow.deactivateReasonLabels}" tagId="deactivateReason" nullable="true" nullableOptionText="Select Reason" disabled="true"/>
								</td>
							</c:otherwise>
						</c:choose>
					</tr>
					<tr>
						<td><br /><br />
							<c:if test="${pageFlow.displayDeactivateButton}">
								<netui:button action="deactivateUser" type="submit" styleClass="mhv-input-button" value="Deactivate"/>
							</c:if>
							<netui:button action="begin" type="submit" styleClass="mhv-input-button" value="Cancel"/>
						</td>
					</tr>
				</table>
			</netui:form>
		</td>
	</tr>
</table>