<%@ page language="java" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-databinding-1.0" prefix="netui-data"%>
<%@ taglib uri="http://beehive.apache.org/netui/tags-html-1.0" prefix="netui"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://beehive.apache.org/netui/tags-template-1.0" prefix="netui-template"%>
<%@ include file="/resources/jsp/defaultNotificationTemplate.jspf"%>
   <table>
	<tr>
		<td>
			<h2>Confirm Reactivation of Account</h2>
			<p>Please verify the account information below.</p>
			<br />
			<p><span class="mhv-required">*</span>Indicates Required Information</p>
			<netui:form action="reactivateUser">
				<%@ include file="userInfo.jspf" %>
				<table>
					<tr>
						<th align="right" valign="top">Description<span class="mhv-required">*</span>:</th>
						<c:choose>
							<c:when test="${pageFlow.displayReactivateButton}">
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.reactivateNoteErrorMessage}"/></span></div>
									<label for="reactivateNote" class="mhv-hidden-label">Description</label>
									<netui:textArea tagId="reactivateNote" dataSource="actionForm.reactivateNote" rows="3" cols="50"/>
								</td>
							</c:when>
							<c:otherwise>
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.reactivateNoteErrorMessage}"/></span></div>
									<label for="reactivateNote" class="mhv-hidden-label">Description</label>
									<netui:textArea tagId="reactivateNote" dataSource="actionForm.reactivateNote" rows="3" cols="50" disabled="true"/>
								</td>
							</c:otherwise>
						</c:choose>
					</tr>
					<tr>
						<th align="right" valign="top">Reason for Reactivation<span class="mhv-required">*</span>:</th>
						<c:choose>
							<c:when test="${pageFlow.displayReactivateButton}">
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.reactivateReasonErrorMessage}"/></span></div>
									<label for="reactivateReason" class="mhv-hidden-label">Reason for Reactivation</label>
									<netui:select dataSource="actionForm.reactivateReason" 
										optionsDataSource="${pageFlow.reactivateReasonLabels}" tagId="reactivateReason"  nullable="true" nullableOptionText="Select Reason"/>
								</td>
							</c:when>
							<c:otherwise>
								<td>
									<div><span class="mhv-field-level-message-critical"><netui:content value="${actionForm.reactivateReasonErrorMessage}"/></span></div>
									<label for="reactivateReason" class="mhv-hidden-label">Reason for Reactivation</label>
									<netui:select dataSource="actionForm.reactivateReason" 
										optionsDataSource="${pageFlow.reactivateReasonLabels}" tagId="reactivateReason" nullable="true" nullableOptionText="Select Reason"  disabled="true" onChange="checkDeceased();"/>
								</td>
							</c:otherwise>
						</c:choose>
					</tr>
					<tr>
						<td><br /><br />
							<c:if test="${pageFlow.displayReactivateButton}">
								<netui:button action="reactivateUser" type="submit" styleClass="mhv-input-button" value="Reactivate"/>
							</c:if>
							<netui:button action="begin" type="submit" styleClass="mhv-input-button" value="Cancel"/>
						</td>
					</tr>
				</table>
			</netui:form>
		</td>
	</tr>
</table>