package gov.va.med.mhv.usermgmt.decorator;

import java.lang.reflect.Method;

import org.displaytag.decorator.TableDecorator;

import gov.va.med.mhv.usermgmt.form.EmergencyContactForm;
import gov.va.med.mhv.usermgmt.transfer.EmergencyContact;

public class EmergencyContactTableDecorator extends TableDecorator {

    public String getPreferredContactMethod() {
        EmergencyContact contact = (EmergencyContact) getCurrentRowObject();

        return EmergencyContactForm
            .getEmergencyContactContactInfoContactMethodName(contact
                .getContactInfoContactMethod());
    }

    /**
     * Get the prefered contact number for display in the table
     * @return
     */
    public String getPreferredContactNumber() {
        EmergencyContact contact = (EmergencyContact) getCurrentRowObject();
        String contactMethodMethodName = "getContactInfo"
            + contact.getContactInfoContactMethod().getName();
        String contactNumber = null;
        try {
            Method contactMethodMethod = contact.getClass().getMethod(
                contactMethodMethodName, (Class[]) null);
            contactNumber = (String) contactMethodMethod.invoke(contact,
                (Object[]) null);
        } catch (Exception e) {
            contactNumber = null;
        }

        return contactNumber;
    }

    public String getName() {
        EmergencyContact contact = (EmergencyContact) getCurrentRowObject();
        return new StringBuilder().
        append(contact.getLastName()).
        append(", ").
        append(contact.getFirstName()).
        toString();
        
    }
    
    public String getPrimaryIndicatorAndName() {
        EmergencyContact contact = (EmergencyContact) getCurrentRowObject();
        return new StringBuilder().
            append("<img src=\"/").
            append(getPageContext().getServletContext().
                getServletContextName()).
            append("/resources/images/").
            append((contact.getIsPrimary()) ? "ec-primary-indicator.gif"
                : "ec-non-primary-indicator.gif").
            append("\" height=\"15\" width=\"15\" border=\"0\" alt=\"").
            append("This is the ").
            append((contact.getIsPrimary()) ? "" : "not "). 
            append("primary contact").
            append("\"/>").
            append(contact.getLastName()).
            append(", ").
            append(contact.getFirstName()).
            toString();
    }

}
