package gov.va.med.mhv.usermgmt.decorator;

import gov.va.med.mhv.usermgmt.transfer.UserProfile;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.displaytag.decorator.TableDecorator;
import org.tigris.atlas.util.CalendarUtils;


public class IPABasicSearchResultsDecorator extends TableDecorator {
	private static final Log LOG = LogFactory.getLog(IPASearchResultsDecorator.class);

	//MHV_CodeCR1386 - Added Gender to display
	public String getGender() {
		UserProfile userProfile = getUserProfile();
		
		if(userProfile.getGender() == null) {
			return "";
		} else if(userProfile.getGender().getName().equals("Male")) {
			return "M";
		} else if (userProfile.getGender().getName().equals("Female")) {
			return "F";
		}
		return "";
	}
	
	public String getName() {
		UserProfile userProfile = getUserProfile();
		StringBuffer buff = new StringBuffer(100);
		buff.append(userProfile.getLastName()!=null?userProfile.getLastName():"");
		buff.append(", ");
		buff.append(userProfile.getFirstName()!=null?userProfile.getFirstName():"");

		if (LOG.isDebugEnabled()) {
			LOG.debug("************** In IPASearchResultsDecorator.getName() info.getMiddleName(): " + userProfile.getMiddleName());
		}
		
		//MHV_CodeCR1386 - adding middle name if exists in the search result
		if(userProfile.getMiddleName() != null && userProfile.getMiddleName().length() > 0) {
			buff.append(" ");
			buff.append(userProfile.getMiddleName());
		}
		return buff.toString();
	}
	
	public String getLastFourSsn() {
		UserProfile userProfile = getUserProfile();
		if(!StringUtils.isBlank(userProfile.getSsn())){
			String ssn = userProfile.getSsn();
			if(ssn.length() > 4){
				return ssn.substring(ssn.length()-4, ssn.length());
			}
		}
		return "N/A";
	}
	
	public String getDateOfBirth() {
		UserProfile userProfile = getUserProfile();
		return CalendarUtils.getYear(userProfile.getBirthDate());
	}
	
	private UserProfile getUserProfile() {
		return (UserProfile) getCurrentRowObject();
	}
}
