package gov.va.med.mhv.usermgmt.decorator;

import gov.va.med.mhv.usermgmt.transfer.UserProfile;

import java.text.SimpleDateFormat;

import org.displaytag.decorator.TableDecorator;

public class UserProfileDecorator extends TableDecorator {
	//MHV_CodeCR1387 - Added Gender to display
	public String getGender() {
		UserProfile profile = (UserProfile) this.getCurrentRowObject();
		
		if(profile.getGender() == null) {
			return "";
		} else if(profile.getGender().getName().equals("Male")) {
			return "M";
		} else if (profile.getGender().getName().equals("Female")) {
			return "F";
		}
		return "";
	}

	public String getSortableFullName() {
		UserProfile profile = (UserProfile) this.getCurrentRowObject();
	    return profile.getLastName() + profile.getFirstName() + " " +profile.getMiddleName();
	}

	public String getSsn() {
		UserProfile profile = (UserProfile) this.getCurrentRowObject();
		if (profile.getSsn() == null)
			return null;

	    return profile.getSsn().replaceAll("-", "");
	}

	public String getBirthDate() {
		UserProfile profile = (UserProfile) this.getCurrentRowObject();
		if (profile.getBirthDate() == null)
			return null;

		SimpleDateFormat sdf = new SimpleDateFormat("MM-dd-yyyy");

	    return sdf.format(profile.getBirthDate());
	}

	public String getPatientFlag() {
		UserProfile profile = (UserProfile) this.getCurrentRowObject();
        if (profile.getIsPatient() == null)
            return "No";
	    return profile.getIsPatient().booleanValue() ? "Yes" : "No";
	}


    public String getDeactivated() {
        UserProfile profile = (UserProfile) this.getCurrentRowObject();
        return (profile.getDeactivationReason() != null) ? "Yes" : "No";
    }

    public String getDeactivationReason() {
        UserProfile profile = (UserProfile) this.getCurrentRowObject();
        return (profile.getDeactivationReason() != null) 
            ? profile.getDeactivationReason().getName()
            : "N/A";
    }

}
