/**
 * 
 */
package gov.va.med.mhv.usermgmt.portal.backing;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.bea.netuix.servlets.controls.application.backing.DesktopBackingContext;
import com.bea.netuix.servlets.controls.content.backing.AbstractJspBacking;
import com.bea.netuix.servlets.controls.page.BookBackingContext;
import com.bea.netuix.servlets.controls.page.PageBackingContext;

/**
 * This backing file supports the post login portal backing.
 * This portal provides a means to require the user to perform the actions
 * that are mandated by the current (*active) portlet. 
 * All other portlets will be hidden from view.
 * @author Rob Proper
 *
 */
public class PostLoginDesktopNavigationBacking extends AbstractJspBacking {
	
	/**
     * Is called for each request prior to the rendering of any pages.
     */
    public boolean preRender(HttpServletRequest request, 
    	HttpServletResponse response) 
    {
    	// NOTE This backing file assumes the poct login (or term and 
    	// conditions) portal onlty has one book and the book only contains 
    	// portlet pages. No further subbooks. 
    	// This assumption seems reasonable as the purpose of the portal
    	// is to require to user to perform a specific action and then
    	// redirect to the next action. The user should only see that single
    	// page, the active page.
    	DesktopBackingContext desktopBacking = DesktopBackingContext.
    		getDesktopBackingContext(request);
        BookBackingContext bookContext = desktopBacking.getBookBackingContext();
    	List pageContexts = bookContext.getPageBackingContexts();
    	if (pageContexts != null) {
	    	for (Iterator i = pageContexts.iterator(); i.hasNext();) {
	    		PageBackingContext pageContext = (PageBackingContext) i.next();
	    		pageContext.setHidden(!pageContext.isActive());
	    	}
    	}
        return true;
    }

}
