package gov.va.med.mhv.usermgmt.portlet; 

import gov.va.med.mhv.usermgmt.enumeration.CountryEnumeration;
import gov.va.med.mhv.usermgmt.form.UserProfileForm;
import java.util.ArrayList;
import java.util.List;
import org.tigris.atlas.util.ListBasedComparator;

public class UserProfileLabelManager {
    
    private static List stateLabels = null;
    private static List countryLabels = null;
    private static List contactMethodLabels = null;
    private static List titleLabels = null;
    private static List suffixLabels = null;
    private static List bloodTypeLabels = null;
    private static List genderLabels = null;
    private static List maritalStatusLabels = null;
    private static List passwordHintLabels = null;

    public static List getStateLabels() {
        if( stateLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            stateLabels = UserProfileForm.getOrderedUserProfileAddressStateLabels( c );
        }
        
        return stateLabels;
    }
    
    public static List getCountryLabels() {
        if( countryLabels == null ) {
            List countriesAtTopOfList = new ArrayList( 1 );
            CountryEnumeration usa = CountryEnumeration.getEnum( CountryEnumeration.UNITED_STATES );
            countriesAtTopOfList.add( UserProfileForm.getUserProfileAddressCountryName( usa ) );
            ListBasedComparator c = new ListBasedComparator( countriesAtTopOfList );
            countryLabels = UserProfileForm.getOrderedUserProfileAddressCountryLabels( c );
        }
        
        return countryLabels;
    }
    
    
    public static List getContactMethodLabels() {
        if( contactMethodLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            contactMethodLabels = UserProfileForm.getOrderedUserProfileContactInfoContactMethodLabels( c );
        }
        
        return contactMethodLabels;
    }
    
    
    public static List getTitleLabels() {
        if( titleLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            titleLabels = UserProfileForm.getOrderedUserProfileTitleLabels( c );
        }
        
        return titleLabels;
    }
    
    
    public static List getSuffixLabels() {
        if( suffixLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            suffixLabels = UserProfileForm.getOrderedUserProfileSuffixLabels( c );
        }
        
        return suffixLabels;
    }
    
    
    public static List getBloodTypeLabels() {
        if( bloodTypeLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            bloodTypeLabels = UserProfileForm.getOrderedUserProfileBloodTypeLabels( c );
        }
        
        return bloodTypeLabels;
    }
    
    
    public static List getGenderLabels() {
        if( genderLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() ) {
            	//US8.7 & US7.7  - Gender:  Male displays first
            	//Made sure that Male comes first by ordering desc
            	@Override
            	public int compare(Object o1, Object o2) {
            		String gend1 = (String)o1;
            		String gend2 = (String)o2;
            		return gend2.compareTo(gend1);
            	}
            };
            genderLabels = UserProfileForm.getOrderedUserProfileGenderLabels( c );
        }
        
        return genderLabels;
    }
    
    
    public static List getMaritalStatusLabels() {
        if( maritalStatusLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            maritalStatusLabels = UserProfileForm.getOrderedUserProfileMaritalStatusLabels( c );
        }
        
        return maritalStatusLabels;
    }
    
    
    public static List getPasswordHintLabels() {
        if( passwordHintLabels == null ) {
            ListBasedComparator c = new ListBasedComparator( new ArrayList() );
            passwordHintLabels = UserProfileForm.getOrderedUserProfilePasswordHintQuestion1Labels( c );
        }
        
        return passwordHintLabels;
    }

} 
