package gov.va.med.mhv.usermgmt.portlet.aal.decorator;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Comparator;
import java.util.Date;
import java.util.Map;
import java.util.Set;

import org.displaytag.decorator.TableDecorator;

import gov.va.med.mhv.usermgmt.enumeration.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityTypeEnumeration;
import gov.va.med.mhv.usermgmt.transfer.Activity;



public class ActivityDecorator extends TableDecorator implements Comparator<Timestamp>
{
	//static private SimpleDateFormat df = new SimpleDateFormat("M/d/yyyy h:mma zzz");
	// CR 7196
	static private SimpleDateFormat df = new SimpleDateFormat("M/d/yyyy h:mm:ss a zzz");
	

	
	public Timestamp getCompletionTime()
	{
		Activity a = (Activity)getCurrentRowObject();
		Timestamp tstamp = a.getCompletionTime();
		return tstamp;
	}	
	
	/**
	 * Returns the date formatter object used by the getCompletionTime()
	 * and compare() methods.
	 * Here so subclasses can use a different date format without having
	 * to override both methods.
	 * @return SimpleDateFormat
	 */
	protected SimpleDateFormat getDateFormatter() {
		return df;
	}
	

	public int compare(Timestamp o1, Timestamp o2) {
		  Timestamp d1 = o1;
		  Timestamp d2 = o2; 
		  return d1.compareTo(d2);
	}	
	
	public String getStatus() {
		String result;
		Activity a = (Activity)getCurrentRowObject();
		if (a.getStatus() == true)
			result = "Successful";
		else
			result = "Unsuccessful";
		
		return result;
	}
	
	public String getActionType()
	{
		Activity a = (Activity)getCurrentRowObject();
		String label = a.getActionType();
		label = label.replaceAll("_","/");
		return label;
	}
	
	public String getAction()
	{
		Activity a = (Activity)getCurrentRowObject();
		String label = getNameForEnumeration(ActivityActionTypeEnumeration.getEnumMap(),a.getAction());
		return label;
	}
	
	public String getPerformerType()
	{
		Activity a = (Activity)getCurrentRowObject();
		String label = getNameForEnumeration(ActivityActorTypeEnumeration.getEnumMap(),a.getPerformerType());
		return label;
	}
	
	private String getNameForEnumeration(Map<String, Object> enumerations, Object e){
		Set<Map.Entry<String, Object>> entries = enumerations.entrySet();
		for (Map.Entry<String, Object> entry:entries) {
			if (entry.getValue().equals(e)) {
				return entry.getKey();	
			}
		}
		throw new IllegalArgumentException("The enumerated type " + e + " cannot be mapped to a name");
	}
}
