package gov.va.med.mhv.usermgmt.portlet.aal.decorator;


import gov.va.med.mhv.usermgmt.transfer.UserProfile;

import java.io.Serializable;

public class UserProfileDecorator  implements Serializable {
	private static final long serialVersionUID = 5388615976997002379L;
	private UserProfile userProfile;
				
	public UserProfileDecorator(UserProfile userProfile) {
		this.userProfile = userProfile;
	}
	
	public Long getId(){
		return userProfile.getId();
	}
	public String getUserName(){
		return userProfile.getUserName();
	}
	
	public String getFullName() {
		String firstName = userProfile.getFirstName();
		String middleName = userProfile.getMiddleName();
		String lastName = userProfile.getLastName();
		
		StringBuffer buff = new StringBuffer();
		buff.append(firstName);
		if (middleName != null) {
			buff.append(' ');
			buff.append(middleName);
			if (middleName.length() == 1)
				buff.append('.');
		}
		buff.append(' ');
		buff.append(lastName);
		
		return(buff.toString());
	}
}
