package gov.va.med.mhv.usermgmt.portlet.accounttype;

import gov.va.med.mhv.usermgmt.enumeration.AccountStatusEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.form.ChangePasswordForm;
import gov.va.med.mhv.usermgmt.form.InPersonAuthenticationForm;
import gov.va.med.mhv.usermgmt.portlet.login.loginbase.LoginNavigateBaseController;
import gov.va.med.mhv.usermgmt.service.InPersonAuthenticationServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.transfer.InPersonAuthentication;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.util.Auditor;
import gov.va.med.mhv.usermgmt.util.PatientCorrelationStatusUtils;

import java.text.SimpleDateFormat;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.service.StringServiceResponse;

/**
 * @jpf:controller struts-merge="/WEB-INF/struts-override.xml"
 *  */
@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class AccountTypeController extends LoginNavigateBaseController {
    private static final Log LOG = LogFactory.getLog(AccountTypeController.class);

	private static final long serialVersionUID = 1L;
    private UserProfile selectedProfile;
    private String selectedUserProfileVaRelationship;
    private String selectedUserProfileAccountStatus;
    private String selectedUserProfileCreatedDate;
    private String selectedUserProfileEmail;
    private String displayError;
	private static final String TIME_FORMAT = "MM/dd/yyyy hh:mm a z";
	private Boolean displayDownloadERARButton;


	//JAZZ#32763 US01 - MHV View the eRAR Form 
    public String getDisplayError() {
		return displayError;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setDisplayError(String displayError) {
		this.displayError = displayError;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public String getSelectedUserProfileEmail() {
		return selectedUserProfileEmail;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setSelectedUserProfileEmail(String selectedUserProfileEmail) {
		this.selectedUserProfileEmail = selectedUserProfileEmail;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public UserProfile getSelectedProfile() {
		return selectedProfile;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public Boolean getDisplayDownloadERARButton() {
		return displayDownloadERARButton;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setDisplayDownloadERARButton(Boolean displayDownloadERARButton) {
		this.displayDownloadERARButton = displayDownloadERARButton;
	}
	
	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public String getSelectedUserProfileCreatedDate() {
		return selectedUserProfileCreatedDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setSelectedUserProfileCreatedDate(String createdDate) {
		this.selectedUserProfileCreatedDate = createdDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public String getSelectedUserProfileAccountStatus() {
		return selectedUserProfileAccountStatus;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setSelectedUserProfileAccountStatus(
			String selectedUserProfileAccountStatus) {
		this.selectedUserProfileAccountStatus = selectedUserProfileAccountStatus;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public String getSelectedUserProfileVaRelationship() {
		return selectedUserProfileVaRelationship;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form 
	public void setSelectedUserProfileVaRelationship(String vaRelationship) {
		this.selectedUserProfileVaRelationship = vaRelationship;
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path = "viewPrintPDFDownloadReport.jsp"),
	        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
	    )
	public Forward viewPrint(InPersonAuthenticationForm form) {
		getRequest().setAttribute("username", selectedProfile.getUserName());
		//JAZZ#32763 US01 RQ#8 For View/Print, MHV system shall make following entry in the AAL table:  
		Auditor.auditDownloadViewPrintERAREvent(selectedProfile.getId(), true, ActivityActionTypeEnumeration.VIEWPRINT_10_5345A_MHV_FORM_ONLINE, "");
		return new Forward("success");
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "cancel", navigateTo = Jpf.NavigateTo.previousPage) } )
	public Forward cancel() {
		return new Forward("cancel");
	}
	
    /**
     * This method represents the point of entry into the pageflow
     * @jpf:action
     * @jpf:forward name="success" path="changePassword.jsp"
     */
    @Jpf.Action(forwards = { 
        	@Jpf.Forward(name = "success", path = "accountType.jsp")
    	})
    protected Forward begin() {
        String currentUserName = getRequest().getRemoteUser();
        
        UserProfileServiceResponse response = 
        	ServiceDelegateFactory.createUserProfileServiceDelegate().getProfileForUser(currentUserName);
        selectedProfile = response.getUserProfile();
        
		PatientServiceResponse patientResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(selectedProfile);
    	Patient patient = patientResponse.getPatient();
    	
		//JAZZ#32763 US01 REQ# The My Account Type landing page shall display following Account Holders details inserted in the landing page:
		if(selectedProfile.getContactInfoEmail()!=null && selectedProfile.getContactInfoEmail().length() > 0) {
			setSelectedUserProfileEmail(selectedProfile.getContactInfoEmail());
		} else {
			setSelectedUserProfileEmail("Your My Health<em><strong>e</strong></em>Vet account does not show an email address. You may enter an email by going to your Profile page under Personal Information");
		}
		
		//JAZZ#32763 US01 REQ#5 The My Account Type landing page shall display following Account Holders details inserted in the landing page:
		//Relationship to the VA (multiple values shall be separated by commas)
		//Account Type  provides a link to information about specified account type and associate icon (B, A, or P)
		//Account Creation Date/Time (military format)
		//Email Address
		//Section Containing Link to the eRAR form (only if the Signed 10-5345a-MHV form online field is populated)
		StringBuffer relationshipToVA = new StringBuffer("");
		if(selectedProfile.getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if(selectedProfile.getIsVeteran()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if(selectedProfile.getIsHealthCareProvider()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if(selectedProfile.getIsPatientAdvocate()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if(selectedProfile.getIsEmployee()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if(selectedProfile.getIsOther()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}

		setSelectedUserProfileVaRelationship(relationshipToVA.toString());
		setSelectedUserProfileAccountStatus(getAccountStatus(selectedProfile));
		
		if(selectedProfile.getCreatedDate()!=null){
			// Account Created Date
			setSelectedUserProfileCreatedDate(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCreatedDate()));
		}
		
		//JAZZ#32763 US01 - MHV View the eRAR Form 
		StringServiceResponse vapiiStatusResponse = 
			gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
					selectedProfile);
		
		if (LOG.isDebugEnabled()) {
		    LOG.error("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@EAuthGatewayServlet vapiiStatusResponse="+vapiiStatusResponse);
		}

		setDisplayDownloadERARButton(false);
		//JAZZ#32763 US01 REQ#7 When VAPii is Unavailable, MHV System shall display a user friendly error message to the user indicating the signed form was not located within VAPii at the top of the page.
		if(patient != null) {
			InPersonAuthenticationServiceDelegate ipaDelegate = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
			InPersonAuthenticationServiceResponse ipaServiceResponse = ipaDelegate.getAuthenticationForPatient(patient.getId());
			InPersonAuthentication ipa = ipaServiceResponse.getInPersonAuthentication();
			if(ipa.getSignedFormOnlineDateTime()!= null) {
				if(vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "vapiiError");
				}else if(!"Submitted".equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "formNotFound");
				}
				setDisplayDownloadERARButton(true);
			}
		}

        return new Forward("success");
    }
   
    protected Class getFormClass(){
        return ChangePasswordForm.class;
    }

	private String getAccountStatus(UserProfile profile) {
		// Adding for MVI Account Status Check
		Boolean isPatientAuthenticated = null;
		PatientServiceResponse patientResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(profile);
    	Patient patient = patientResponse.getPatient();
    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    	if (patient != null) {
    		isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
    	}
    	
    	
    	if(patient != null) {
    		if(patient.getMatchedDateTime() != null){
	    		if(isPatientAuthenticated != null) {
	    			if(isPatientAuthenticated == true && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.PREMIUM;
	    			else if(isPatientAuthenticated == true && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.ADVANCED;
	        		else if(isPatientAuthenticated == false)
						return AccountStatusEnumeration.ADVANCED;
	    		}
	    		else {
					return AccountStatusEnumeration.ADVANCED;
	    		}
    		}else{
				return AccountStatusEnumeration.BASIC;
    		}
    	}else {
			return AccountStatusEnumeration.BASIC;
    	}
		return AccountStatusEnumeration.BASIC;
	}
}
