package gov.va.med.mhv.usermgmt.portlet.base;

import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.UserProfileServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import javax.servlet.http.HttpServletRequest;

import org.tigris.atlas.beehive.AbstractPageFlowController;

public abstract class UserBaseController extends AbstractPageFlowController {

	protected UserProfile getCurrentUser() {
		return getUserProfile(getRequest());
	}

	protected static UserProfile getUserProfile(HttpServletRequest request) {
		String username = request.getRemoteUser();
		UserProfileServiceDelegate sd = ServiceDelegateFactory
			.createUserProfileServiceDelegate();
		UserProfileServiceResponse response = sd.getProfileForUser(username);
		return response.getUserProfile();
	}
}
