package gov.va.med.mhv.usermgmt.portlet.ipa;

import gov.va.med.mhv.core.portlet.util.PageFlowUrlBuilder;
import gov.va.med.mhv.core.util.ServiceResponseUtils;
import gov.va.med.mhv.usermgmt.enumeration.AccountStatusEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.AuthenticationStatus;
import gov.va.med.mhv.usermgmt.enumeration.OrganizationTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.PatientCorrelationStatus;
import gov.va.med.mhv.usermgmt.enumeration.RoleNameEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.SuffixEnumeration;
import gov.va.med.mhv.usermgmt.form.IPACriteriaForm;
import gov.va.med.mhv.usermgmt.form.InPersonAuthenticationForm;
import gov.va.med.mhv.usermgmt.portlet.constants.DefinitionLabelConstants;
import gov.va.med.mhv.usermgmt.service.EmployeeServiceResponse;
import gov.va.med.mhv.usermgmt.service.InPersonAuthenticationServiceResponse;
import gov.va.med.mhv.usermgmt.service.OrganizationCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientInformationCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.EmployeeRoleManagementServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.EntityMaintenanceServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.MviIntegrationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.transfer.Employee;
import gov.va.med.mhv.usermgmt.transfer.Facility;
import gov.va.med.mhv.usermgmt.transfer.FacilityInfo;
import gov.va.med.mhv.usermgmt.transfer.InPersonAuthentication;
import gov.va.med.mhv.usermgmt.transfer.InPersonAuthenticationCriteria;
import gov.va.med.mhv.usermgmt.transfer.Organization;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.PatientInformation;
import gov.va.med.mhv.usermgmt.transfer.TransferObjectFactory;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.transfer.UserProfilePK;
import gov.va.med.mhv.usermgmt.util.Auditor;
import gov.va.med.mhv.usermgmt.util.InPersonAuthenticator;
import gov.va.med.mhv.usermgmt.util.PatientCorrelationStatusUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.beehive.AbstractPageFlowController;
import org.tigris.atlas.beehive.PageFlowControllerConstants;
import org.tigris.atlas.messages.DefaultMessages;
import org.tigris.atlas.messages.DefaultMessagesHandler;
import org.tigris.atlas.messages.Message;
import org.tigris.atlas.messages.MessageUtils;
import org.tigris.atlas.messages.Messages;
import org.tigris.atlas.messages.MessagesHandler;
import org.tigris.atlas.service.StringServiceResponse;
import org.tigris.atlas.service.VoidServiceResponse;
import org.tigris.atlas.util.CalendarUtils;

import com.bea.netuix.servlets.controls.page.PagePresentationContext;
import com.bea.portlet.PageURL;

@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class InPersonAuthenticatonController extends AbstractPageFlowController {
	private static final Log LOG = LogFactory.getLog(InPersonAuthenticatonController.class);

	private static final long serialVersionUID = 500117087L;
	private static final String RESULTS_SESSION_KEY = "_ipaSearchResults";
	private InPersonAuthentication currentIPA;
	//Admin Portal_CodeCR1747 - Changed the format of the date according to the user format.
	private static final String TIME_FORMAT = "MM/dd/yyyy hh:mm a z";

	public List authenticateManyItems = new ArrayList();
	public Map<Long, String> facilityOptions = new HashMap<Long, String>();
	private PatientSummaryDecorator patientSummaryDecorator;
    private InPersonAuthenticationCriteria currentSearchCriteria = null;
    private Collection userProfiles;
    
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
    private String selectedUserProfileVaRelationship;
    private UserProfile selectedProfile;
    private String selectedUserProfileCreatedDate;
	private String selectedUserProfileAccountStatus;
	private String selectedUserProfileMatchingStatus;
	private String selectedUserProfileMatchingDate;
	private String selectedUserProfileAuthenticatedBy;
	private String selectedUserProfileAuthenticationStatus;
	private String selectedUserProfileAuthenticationDate;
	private String selectedUserProfileAuthenticationPerformedBy;
	private String selectedUserProfileAuthenticatingFacility;
	private String selectedUserProfileTreatingFacilities;
	private String selectedUserProfileCorrelationStatus;
	private String selectedUserProfileCorrelationDate;
	private String selectedUserProfileCorrelationRequestDate;
	private String selectedUserProfileCorrelationPerformedBy;
	
	//JAZZ#32763 US01 - MHV View the eRAR Form   
	private String selectedUserProfileStartUpgradeManualDate;
	private String selectedUserProfileStartUpgradeAutoDate;
	private String selectedUserProfileSignedErarDate;
	
	private Boolean displayAuthenticationButton;
	private Boolean displayCorrelateButton;
	private Boolean displayUncorrelateButton;
	private String selectedUserProfileName;
	private Boolean displayMatchButton;
	private Boolean displayDownloadERARButton;

	private String getURLWithActionOverride(HttpServletRequest request, HttpServletResponse response, String pageLabel, String portletLabel, String override)
	{
		PagePresentationContext pageCtx = PagePresentationContext.getPagePresentationContext(getRequest());
		if(! pageLabel.equals(pageCtx.getDefinitionLabel()))
			LOG.error("Definition Label and PageLabel Do NOT match..."+ " pageLabel:" +pageLabel + " Definition Label:" +pageCtx.getDefinitionLabel());
		PageURL url = PageURL.createPageURL(request, response, pageLabel);
		url.addParameter((new StringBuilder()).append(portletLabel).append("_actionOverride").toString(), override, false, false);

		return url.toString();
	}
	
	
	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getSelectedUserProfileStartUpgradeManualDate() {
		return selectedUserProfileStartUpgradeManualDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public void setSelectedUserProfileStartUpgradeManualDate(
			String selectedUserProfileStartUpgradeManualDate) {
		this.selectedUserProfileStartUpgradeManualDate = selectedUserProfileStartUpgradeManualDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getSelectedUserProfileStartUpgradeAutoDate() {
		return selectedUserProfileStartUpgradeAutoDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public void setSelectedUserProfileStartUpgradeAutoDate(
			String selectedUserProfileStartUpgradeAutoDate) {
		this.selectedUserProfileStartUpgradeAutoDate = selectedUserProfileStartUpgradeAutoDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getSelectedUserProfileSignedErarDate() {
		return selectedUserProfileSignedErarDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public void setSelectedUserProfileSignedErarDate(
			String selectedUserProfileSignedErarDate) {
		this.selectedUserProfileSignedErarDate = selectedUserProfileSignedErarDate;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getViewPDFReportUrl() {
		return getURLWithActionOverride(getRequest(), getResponse(),
				DefinitionLabelConstants.DOWNLOAD_DATA_PAGE, DefinitionLabelConstants.DOWNLOAD_DATA_PORTLET,
		"/gov/va/med/mhv/usermgmt/downloadYourData/viewPDFReport");
	}
	
	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public Boolean getDisplayDownloadERARButton() {
		return displayDownloadERARButton;
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public void setDisplayDownloadERARButton(Boolean displayDownloadERARButton) {
		this.displayDownloadERARButton = displayDownloadERARButton;
	}

	//MHV_CodeCRTBD - US12.6 MVI Compliance Implementation - Display Matched Date
	public String getSelectedUserProfileMatchingDate() {
		return selectedUserProfileMatchingDate;
	}

	//MHV_CodeCRTBD - US12.6 MVI Compliance Implementation - Display Matched Date
	public void setSelectedUserProfileMatchingDate(
			String selectedUserProfileMatchingDate) {
		this.selectedUserProfileMatchingDate = selectedUserProfileMatchingDate;
	}

	//MHV_CodeCR1918 - US12.5 MVI Compliance Implementation - Display Uncorrelate Button
	public Boolean getDisplayUncorrelateButton() {
		return displayUncorrelateButton;
	}

	//MHV_CodeCR1918 - US12.5 MVI Compliance Implementation - Display Uncorrelate Button
	public void setDisplayUncorrelateButton(Boolean displayUncorrelateButton) {
		this.displayUncorrelateButton = displayUncorrelateButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public Boolean getDisplayMatchButton() {
		return displayMatchButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public void setDisplayMatchButton(Boolean displayMatchButton) {
		this.displayMatchButton = displayMatchButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public String getSelectedUserProfileCorrelationRequestDate() {
		return selectedUserProfileCorrelationRequestDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public void setSelectedUserProfileCorrelationRequestDate(
			String selectedUserProfileCorrelationRequestDate) {
		this.selectedUserProfileCorrelationRequestDate = selectedUserProfileCorrelationRequestDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public List getAuthenticateManyItems() {
		return authenticateManyItems;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation
	public void setAuthenticateManyItems(List authenticateManyItems) {
		this.authenticateManyItems = authenticateManyItems;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Correlate Button Display
	public Boolean getDisplayCorrelateButton() {
		return displayCorrelateButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Correlate Button Display
	public void setDisplayCorrelateButton(Boolean displayCorrelateButton) {
		this.displayCorrelateButton = displayCorrelateButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Auth Button Display
	public Boolean getDisplayAuthenticationButton() {
		return displayAuthenticationButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Auth Button Display
	public void setDisplayAuthenticationButton(Boolean displayAuthenticationButton) {
		this.displayAuthenticationButton = displayAuthenticationButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAuthenticatedBy() {
		return selectedUserProfileAuthenticatedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAuthenticatedBy(
			String selectedUserProfileAuthenticatedBy) {
		this.selectedUserProfileAuthenticatedBy = selectedUserProfileAuthenticatedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAccountStatus() {
		return selectedUserProfileAccountStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAccountStatus(
			String selectedUserProfileAccountStatus) {
		this.selectedUserProfileAccountStatus = selectedUserProfileAccountStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAuthenticatingFacility() {
		return selectedUserProfileAuthenticatingFacility;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAuthenticatingFacility(
			String selectedUserProfileAuthenticatingFacility) {
		this.selectedUserProfileAuthenticatingFacility = selectedUserProfileAuthenticatingFacility;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAuthenticationDate() {
		return selectedUserProfileAuthenticationDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAuthenticationDate(
			String selectedUserProfileAuthenticationDate) {
		this.selectedUserProfileAuthenticationDate = selectedUserProfileAuthenticationDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAuthenticationPerformedBy() {
		return selectedUserProfileAuthenticationPerformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAuthenticationPerformedBy(
			String selectedUserProfileAuthenticationPerformedBy) {
		this.selectedUserProfileAuthenticationPerformedBy = selectedUserProfileAuthenticationPerformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileTreatingFacilities() {
		return selectedUserProfileTreatingFacilities;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileTreatingFacilities(
			String selectedUserProfileTreatingFacilities) {
		this.selectedUserProfileTreatingFacilities = selectedUserProfileTreatingFacilities;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileCorrelationStatus() {
		return selectedUserProfileCorrelationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileCorrelationStatus(
			String selectedUserProfileCorrelationStatus) {
		this.selectedUserProfileCorrelationStatus = selectedUserProfileCorrelationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileCorrelationDate() {
		return selectedUserProfileCorrelationDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileCorrelationDate(
			String selectedUserProfileCorrelationDate) {
		this.selectedUserProfileCorrelationDate = selectedUserProfileCorrelationDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileCorrelationPerformedBy() {
		return selectedUserProfileCorrelationPerformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileCorrelationPerformedBy(
			String selectedUserProfileCorrelationPerformedBy) {
		this.selectedUserProfileCorrelationPerformedBy = selectedUserProfileCorrelationPerformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAuthenticationStatus() {
		return selectedUserProfileAuthenticationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAuthenticationStatus(
			String selectedUserProfileAuthenticationStatus) {
		this.selectedUserProfileAuthenticationStatus = selectedUserProfileAuthenticationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileName(String selectedUserProfileName) {
		this.selectedUserProfileName = selectedUserProfileName;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileName() {
		return selectedUserProfileName;
	}
    
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	//MHV_CodeCR1956 - Made sure that the correct DOB displays.
    public String getSelectedProfileBirthDate() {
        if (selectedProfile == null)
        {
            return "";
        }
		return(CalendarUtils.getDateAsMDY(selectedProfile.getBirthDate()));
    }
    
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public UserProfile getSelectedProfile() {
		return selectedProfile;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedProfile(UserProfile selectedProfile) {
		this.selectedProfile = selectedProfile;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileVaRelationship() {
		return selectedUserProfileVaRelationship;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileVaRelationship(String vaRelationship) {
		this.selectedUserProfileVaRelationship = vaRelationship;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileCreatedDate() {
		return selectedUserProfileCreatedDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileCreatedDate(String createdDate) {
		this.selectedUserProfileCreatedDate = createdDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileMatchingStatus() {
		return selectedUserProfileMatchingStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileMatchingStatus(String matchingStatus) {
		this.selectedUserProfileMatchingStatus = matchingStatus;
	}

	@Jpf.Action(forwards = { @Jpf.Forward(name = "default", path = "search.jsp") })
	public Forward begin() {
		setupFacilityInfo();
		return new Forward("default");
	}

	private void setupFacilityInfo(){
		if(getRequest().getUserPrincipal() != null){
			String username = getRequest().getUserPrincipal().getName();
			EmployeeRoleManagementServiceDelegate del = ServiceDelegateFactory.createEmployeeRoleManagementServiceDelegate();
			EmployeeServiceResponse sr = del.getEmployeeByUserName(username);
			Employee employee = sr.getEmployee();
			OrganizationCollectionServiceResponse eocResponse = del.getOrganizationsOfTypeWhereEmployeeHasRole(employee,
					OrganizationTypeEnumeration.getEnum(OrganizationTypeEnumeration.FACILITY),
					RoleNameEnumeration.getEnum(RoleNameEnumeration.AUTHENTICATOR).getName());
			
			if(eocResponse.getItems()!= null){
				Iterator i = eocResponse.getItems().iterator();
				while(i.hasNext()){
					Organization org = (Organization)i.next();
					if(org != null){
						FacilityInfo facilityInfo = org.getFacilityInfo();
						if(facilityInfo != null)
							facilityOptions.put(facilityInfo.getId(), facilityInfo.getName());	
					}
				}
			}		
		}
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path = "viewPrintPDFDownloadReport.jsp"),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward viewPrint(InPersonAuthenticationForm form) {
		getRequest().setAttribute("username", currentIPA.getPatient().getUserProfile().getUserName());
		Forward forward = determineForward();
		return forward;
	}
	
	/*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Matching Process
     */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", 
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward match(InPersonAuthenticationForm form) {		
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse response = 
			mviSyncServiceDelegate.matchPersonInIPA(currentIPA.getPatient().getUserProfile());
		
		Patient patient = response.getPatient();
		if(patient != null) {
			currentIPA.setPatient(patient);
			setSelectedUserProfileAccountStatus(getAccountStatus(patient));
		}
		
	    patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
		
	    //CR1840 - Made sure the correct messages are logged.
        if (ServiceResponseUtils.hasErrorMessages(response)) {
    		Auditor.auditMviEvent(currentIPA.getPatient().getUserProfile().getId(),
    				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, false, 
    				ActivityActionTypeEnumeration.UPGRADE_TO_ADVANCED, ActivityTypeEnumeration.ACCOUNT_UPGRADE);
        } else {
    		Auditor.auditMviEvent(currentIPA.getPatient().getUserProfile().getId(),
    				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true, 
    				ActivityActionTypeEnumeration.UPGRADE_TO_ADVANCED, ActivityTypeEnumeration.ACCOUNT_UPGRADE);
        }
        
		handleMessages(response);
	    //CR1838 - Made sure that the search results are updated
		updateSearchResults();
		
		determineMatchStatus();
		determineDisplayButtons();
		
		Forward forward = determineForward();
		return forward;
	}
	
    /*
	 * 	JAZZ:Task#20797 - Display Match Button in the Search All Page in IPA
     */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", 
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward basicMatch(InPersonAuthenticationForm form) {		
		currentIPA = null;
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse response = 
			mviSyncServiceDelegate.matchPersonInIPA(selectedProfile);
		
		Patient patient = response.getPatient();
		if(patient != null) {
			currentIPA = getIPA(patient);
			if(currentIPA != null) {
				currentIPA.setPatient(patient);
			}
		} else {
			setSelectedUserProfileAccountStatus(AccountStatusEnumeration.BASIC);
		}
		
	    //CR1840 - Made sure the correct messages are logged.
        if (ServiceResponseUtils.hasErrorMessages(response)) {
    		Auditor.auditMviEvent(selectedProfile.getId(),
    				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, false, 
    				ActivityActionTypeEnumeration.UPGRADE_TO_ADVANCED, ActivityTypeEnumeration.ACCOUNT_UPGRADE);
        } else {
			setSelectedUserProfileAccountStatus(AccountStatusEnumeration.ADVANCED);
    		Auditor.auditMviEvent(selectedProfile.getId(),
    				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true, 
    				ActivityActionTypeEnumeration.UPGRADE_TO_ADVANCED, ActivityTypeEnumeration.ACCOUNT_UPGRADE);
        }
        
		handleMessages(response);

        if (selectedProfile == null) {
        	setSelectedUserProfileName("");
        } else {
        	StringBuffer buffer = new StringBuffer();
        	buffer.append(selectedProfile.getFirstName()!=null?selectedProfile.getFirstName():"");
        	buffer.append(" ");
        	buffer.append(selectedProfile.getMiddleName()!=null?selectedProfile.getMiddleName():"");
        	buffer.append(" ");
        	buffer.append(selectedProfile.getLastName()!=null?selectedProfile.getLastName():"");
        	setSelectedUserProfileName(buffer.toString());
        }
    	
  		//MHV_CodeCR1387 - Added relationship to VA in search detail page.
		StringBuffer relationshipToVA = new StringBuffer("");
		if(selectedProfile.getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if(selectedProfile.getIsVeteran()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if(selectedProfile.getIsHealthCareProvider()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if(selectedProfile.getIsPatientAdvocate()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if(selectedProfile.getIsEmployee()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if(selectedProfile.getIsOther()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}

		setSelectedUserProfileVaRelationship(relationshipToVA.toString());
			
		if(selectedProfile.getCreatedDate()!=null){
			// Account Created Date
			setSelectedUserProfileCreatedDate(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCreatedDate()));
		}

		//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
		
		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected. 
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileTreatingFacilities("");
		setSelectedUserProfileCorrelationStatus("");
		setSelectedUserProfileCorrelationDate("");
		setSelectedUserProfileCorrelationRequestDate("");
		setSelectedUserProfileCorrelationPerformedBy("");
		setSelectedUserProfileAuthenticationStatus("");
		setSelectedUserProfileAuthenticationDate("");
		setSelectedUserProfileAuthenticatingFacility("");
		setSelectedUserProfileAuthenticatedBy("");
		setSelectedUserProfileAccountStatus("");
		setSelectedUserProfileStartUpgradeAutoDate("");
		setSelectedUserProfileStartUpgradeManualDate("");
		setSelectedUserProfileSignedErarDate("");
		
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileMatchingDate("");
		patient = getPatient(selectedProfile);
		displayMatchButton = false;
		
		if(patient !=null && patient.getMatchedDateTime()==null && selectedProfile.getDeactivationReason() == null) {
			displayMatchButton = true;
		} else if(patient ==null && (selectedProfile.getIsPatient()||selectedProfile.getIsVeteran())) {
			displayMatchButton = true;
		}
		
		if(patient != null) {
			if(patient.getMatchedDateTime()!=null) {
				setSelectedUserProfileMatchingStatus("Matched");
				setSelectedUserProfileMatchingDate(
						new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
			}
			InPersonAuthentication ipa = getIPA(patient);
			setSelectedUserProfileTreatingFacilities(getTxFacilities(patient));
			setSelectedUserProfileCorrelationStatus(getCorrelationStatus(patient));
			setSelectedUserProfileCorrelationDate(getCorrelationDate(patient));
			setSelectedUserProfileCorrelationRequestDate(getCorrelationRequestDate(patient));
			setSelectedUserProfileCorrelationPerformedBy(getCorrelatedBy(patient));
			if(ipa != null) {
				setSelectedUserProfileAuthenticationStatus(getAuthenticationStatus(ipa));
				setSelectedUserProfileAuthenticationDate(getAuthenticationDate(ipa));
				setSelectedUserProfileAuthenticatingFacility(getAuthenticatingFacility(ipa));
				setSelectedUserProfileAuthenticatedBy(getAuthenticatedBy(ipa));
				setSelectedUserProfileStartUpgradeAutoDate(getStartUpgradeAutoDate(ipa));
				setSelectedUserProfileStartUpgradeManualDate(getStartUpgradeManualDate(ipa));
				setSelectedUserProfileSignedErarDate(getSignedFormOnlineDateTime(ipa));
				
				//JAZZ#32763 US02 RQ#5- The MHV system shall check if the Signed 10-5345a-MHV form online field is set and display two new buttons: 
				StringServiceResponse vapiiStatusResponse = 
					gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
							ipa.getPatient().getUserProfile());
				
				if(vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "vapiiError");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}			
				}else if(!"Submitted".equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "formNotFound");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() !Submitted.equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}			
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() getRequest().getSession().removeAttribute(displayError)");
					}			
					getRequest().getSession().removeAttribute("displayError");
				}
				
				if(ipa.getSignedFormOnlineDateTime()!=null) {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()!=null");
					}			
					setDisplayDownloadERARButton(true);
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()==null");
					}			
					setDisplayDownloadERARButton(false);
				}
			}
		}
		setSelectedUserProfileAccountStatus(getAccountStatus(patient));
		
	    //CR1838 - Made sure that the search results are updated
		updateSearchResults();
		determineDisplayButtons();
		
		Forward forward = determineForward();
		return forward;
	}
	
	private void determineMatchStatus() {
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileMatchingDate("");
		if(currentIPA!=null && currentIPA.getPatient() != null) {
			if(currentIPA.getPatient().getMatchedDateTime()!=null) {
				setSelectedUserProfileMatchingStatus("Matched");
				setSelectedUserProfileMatchingDate(
						new SimpleDateFormat(TIME_FORMAT).format(currentIPA.getPatient().getMatchedDateTime()));
			}
		}
	}
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", 
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward syncCorrelate(InPersonAuthenticationForm form) {
		Forward forward = null;

		/*
		Auditor.auditMviEvent(currentIPA.getPatient().getUserProfile().getId(),
				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true, 
				ActivityActionTypeEnumeration.ACCOUNT_CORRELATION_REQUESTED, ActivityTypeEnumeration.ACCOUNT_UPGRADE);
		*/
		forward = determineForward();
		if(currentIPA.getPatient().getMatchedDateTime() == null){
			if (LOG.isErrorEnabled()) {
				LOG.error("Trying to Correlate a user who is NOT Matched for VA Patient ICN: " + currentIPA.getPatient().getIcn() + " : Match Status:  " + currentIPA.getPatient().getCorrelationStatus().getValue());
			}			
			forward.setName("failure");
			return forward;
		}			
		
		// Sync correlate service
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();		
		PatientServiceResponse mviSyncServiceResponse = 
			mviSyncServiceDelegate.addPersonForCorrelationForIPA(currentIPA.getPatient(), currentIPA.getPatient().getUserProfile(),getEmployeeName());
		
		Patient patient = mviSyncServiceResponse.getPatient();
		if(patient != null) {
			currentIPA.setPatient(patient);
		}
		
	    patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
		
		handleMessages(mviSyncServiceResponse);
	    //CR1838 - Made sure that the search results are updated
		updateSearchResults();
		
		determineMatchStatus();
		determineDisplayButtons();
		
		forward = determineForward();
		
		return forward;
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "newSearch", path = "search.jsp") } )
	public Forward newSearch() {
		return new Forward("newSearch");
	}

	/*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
	 */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "newBasicSearch", path = "basicSearch.jsp") } )
	public Forward newBasicSearch() {
		return new Forward("newBasicSearch");
	}

    @Jpf.Action(forwards = { 
        @Jpf.Forward(name = "success", path="showResults.do", redirect=true),
        @Jpf.Forward(name = "newSearch", path="newSearch.do", redirect=true),
        @Jpf.Forward(name="noResults", navigateTo = Jpf.NavigateTo.currentPage) 
    },
    validationErrorForward = 
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage),
        preventDoubleSubmit=true
    ) 
    public Forward refresh() {
        return (currentSearchCriteria != null) ? find(currentSearchCriteria)
            : new Forward("newSearch");
    }

    @Jpf.Action(forwards = { 
            @Jpf.Forward(name = "success", path="showBasicResults.do", redirect=true),
            @Jpf.Forward(name = "newSearch", path="newBasicSearch.do", redirect=true),
            @Jpf.Forward(name="noResults", navigateTo = Jpf.NavigateTo.currentPage) 
    },
    validationErrorForward = 
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage),
        preventDoubleSubmit=true
    ) 
    public Forward basicRefresh() {
        return (currentSearchCriteria != null) ? basicFind(currentSearchCriteria)
            : new Forward("newSearch");
    }

    @Jpf.Action(forwards = { 
			@Jpf.Forward(name = "success", path="showResults.do", redirect=true),
			@Jpf.Forward(name="noResults", navigateTo = Jpf.NavigateTo.currentPage) 
		},
		validationErrorForward = 
			@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage),
		preventDoubleSubmit=true
	) 
	public Forward search(gov.va.med.mhv.usermgmt.form.IPACriteriaForm form) {
		InPersonAuthenticationCriteria criteria = TransferObjectFactory.createInPersonAuthenticationCriteria();
		copyFromIPACriteriaFormToCriteria(criteria, form);
		return find(criteria);
	}
    
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
	@Jpf.Action(forwards = { 
			@Jpf.Forward(name = "success", path = "basicSearch.jsp")
		})
	public Forward launchBasicSearch(gov.va.med.mhv.usermgmt.form.IPACriteriaForm form) {
		return new Forward("success");
	}
    
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
	@Jpf.Action(forwards = { 
			@Jpf.Forward(name = "success", path = "search.jsp")
		})
	public Forward launchAdvancedSearch(gov.va.med.mhv.usermgmt.form.IPACriteriaForm form) {
		return new Forward("success");
	}
	
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
	@Jpf.Action(forwards = { 
			@Jpf.Forward(name = "success", path="showBasicResults.do", redirect=true),
			@Jpf.Forward(name="noResults", navigateTo = Jpf.NavigateTo.currentPage) 
		},
		validationErrorForward = 
			@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage),
		preventDoubleSubmit=true
	) 
	public Forward basicSearch(gov.va.med.mhv.usermgmt.form.IPACriteriaForm form) {
		InPersonAuthenticationCriteria criteria = TransferObjectFactory.createInPersonAuthenticationCriteria();
		//form.setIpaStatusUnmatched("true");
		copyFromIPABasicCriteriaFormToCriteria(criteria, form);
		return basicFind(criteria);
	}
    
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
    @SuppressWarnings("unchecked")
    private Forward basicFind(InPersonAuthenticationCriteria criteria) {
        currentSearchCriteria = criteria;

    	//MHV_CodeCR1387 - Added last name and ssn in the search
    	String lastName = "";
    	String ssn = "";
    	if(criteria.getFirstPlusFour() != null && criteria.getFirstPlusFour().length() > 0) {

    		String firstPlusFour = criteria.getFirstPlusFour();
    		lastName = criteria.getFirstPlusFour().substring(0, 1);
    		ssn = criteria.getFirstPlusFour().substring(1);
    	} else {
    		lastName = criteria.getLastName();
    		ssn = criteria.getSsn();
    	}


    	//Date birthDate = CalendarUtils.getDate(form.getUserProfileBirthDateMonth(), form.getUserProfileBirthDateDay(), form.getUserProfileBirthDateYear());
    	Date birthDate = criteria.getDateOfBirth();
        // JAZZ:Defect# 19718 - Include middle name in the basic search. 
		UserProfileCollectionServiceResponse response = ServiceDelegateFactory.createUserProfileServiceDelegate().findUser(
        	(criteria.getMhvId()!=null)?criteria.getMhvId():"",
        	(criteria.getFirstName()!=null)?criteria.getFirstName():"",
            (criteria.getMiddleName()!=null)?criteria.getMiddleName():"",
			(lastName!=null)?lastName:"",
			(criteria.getEmail()!=null)?criteria.getEmail():"",
			(criteria.getUsername()!=null)?criteria.getUsername():"",
            (ssn!=null)?ssn:"",
            birthDate);

        userProfiles = response.getUserProfiles();
        handleMessages(response);

        getSession().removeAttribute( "userProfiles" );
        getSession().setAttribute( "userProfiles", userProfiles );

        Forward forward = determineForward();
        if(userProfiles.isEmpty()){
        	forward =  new Forward(PageFlowControllerConstants.FORWARD_FAILURE);
        } else {
        	forward =  determineForward();
        }
        
        if ("success".equalsIgnoreCase(forward.getName())) {
            // Note that the success action is being redirected to the browser.
            // Therefor we need to build the path, because the context will 
            // change. Must redirect to the browser to drop the form data from 
            // the request, which will otherwise get added to the URLs created
            // by e.g. display-tag
            forward.setPath(buildPath("showBasicResults"));
        }
        return forward;
    }
    
    @SuppressWarnings("unchecked")
    private Forward find(InPersonAuthenticationCriteria criteria) {
        InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
        //Admin Portal_CodeCR1961 - Made sure that the to date is end of the end of the day
        if(criteria.getToAuthenticationDate() != null) {
        	criteria.getToAuthenticationDate().setTime(criteria.getToAuthenticationDate().getTime()+((1439*60*1000)+(59*1000)));
        }
        PatientInformationCollectionServiceResponse response = delegate.findPatients(criteria);
        handleMessages(response);

        Collection<PatientInformation> items = response.getPatientInformations();
        
        currentSearchCriteria = criteria;
        setSearchResults(items);
        if ((items == null || items.isEmpty()) && !response.getMessages().hasErrorMessages()) {
            Message msg = MessageUtils.createInformationalMessage("no.search.results", null, null);
            response.getMessages().addMessage(msg);
            handleMessages(response);
            return new Forward("noResults");
        }

        authenticateManyItems = new ArrayList();

        Forward forward = determineForward();
        if ("success".equalsIgnoreCase(forward.getName())) {
            // Note that the success action is being redirected to the browser.
            // Therefor we need to build the path, because the context will 
            // change. Must redirect to the browser to drop the form data from 
            // the request, which will otherwise get added to the URLs created
            // by e.g. display-tag
            forward.setPath(buildPath("showResults"));
        }
        return forward;
    }
	
	private String buildPath(String actionName) {
		return new PageFlowUrlBuilder(getClass()).build(getRequest(), 
			actionName);
	}

	@Jpf.Action(forwards = { 
		@Jpf.Forward(name = "success", path = "searchResults.jsp")
	})
	public Forward showResults() {
		return new Forward("success");
	}
	
    /*
	 * 	MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
     */
	@Jpf.Action(forwards = { 
			@Jpf.Forward(name = "success", path = "basicSearchResults.jsp")
	})
	public Forward showBasicResults() {
		return new Forward("success");
	}
		
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.currentPage),
			@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward reset(gov.va.med.mhv.usermgmt.form.IPACriteriaForm form) {
		form = new IPACriteriaForm();
		return determineForward();
	}
	
	/*
	 * MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic (Unmatched Accounts) Search
	 */
	private void copyFromIPABasicCriteriaFormToCriteria(InPersonAuthenticationCriteria criteria, IPACriteriaForm form) {	
		form.copyTo(criteria, new PatientInformation());
		form.copySsnToCriteria(criteria);
		form.copyFacilityToCriteria(criteria);
		form.copyTrimmedStringsToCriteria(criteria);
	}
	
	private void copyFromIPACriteriaFormToCriteria(InPersonAuthenticationCriteria criteria, IPACriteriaForm form) {	
		form.copyTo(criteria, new PatientInformation());
		form.copySsnToCriteria(criteria);
		form.copyFacilityToCriteria(criteria);
		form.copyTrimmedStringsToCriteria(criteria);
		
		if(criteria.getFirstName() != null && !criteria.getFirstName().trim().equals("")){
			criteria.setFirstName(criteria.getFirstName()+"*");
		}
		if(criteria.getLastName() != null && !criteria.getLastName().trim().equals("")){
			criteria.setLastName(criteria.getLastName()+"*");
		}
		//MHV_CodeCR1386 - Added the wild card on the middle name 
		if(criteria.getMiddleName() != null && !criteria.getMiddleName().trim().equals("")){
			criteria.setMiddleName(criteria.getMiddleName()+"*");
		}
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="confirmBatchAuthentication.jsp"),
			                @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward authenticateMany() {
		if (authenticateManyItems.isEmpty()) {
			Message msg = MessageUtils.createErrorMessage("no.users.selected", null, null);
			Messages msgs = new DefaultMessages();
			msgs.addMessage(msg);
			handleMessages(msgs);
		} else {
			List<PatientInformation> items = new ArrayList<PatientInformation>();
			for (PatientInformation p : getSearchResults()) {
				if (authenticateManyItems.contains(p.getPatientId().toString())) {
					items.add(p);
				}
			}
			getSession().setAttribute("_usersToAuthenticate", items);
		}
		
		return determineForward();
	}
	

	private void handleMessages(Messages msgs) {
		MessagesHandler handler = new DefaultMessagesHandler();
		handler.handleMessages(msgs, getFormClass(), getRequest());
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward handleDisplayTagAction() {
		Forward forward = new Forward("success");
		return forward;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Detail Impl
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="basicSearchDetail.jsp"),
            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward performBasicSearchDetail() {
        Long id = new Long(getRequest().getParameter("id"));
        UserProfileServiceResponse response = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate().findByPrimaryKey(new UserProfilePK(id));
        selectedProfile = response.getUserProfile();
        handleMessages(response);
        //form.copyFrom(selectedProfile);

        if (selectedProfile == null) {
        	setSelectedUserProfileName("");
        } else {
        	StringBuffer buffer = new StringBuffer();
        	buffer.append(selectedProfile.getFirstName()!=null?selectedProfile.getFirstName():"");
        	buffer.append(" ");
        	buffer.append(selectedProfile.getMiddleName()!=null?selectedProfile.getMiddleName():"");
        	buffer.append(" ");
        	buffer.append(selectedProfile.getLastName()!=null?selectedProfile.getLastName():"");
        	setSelectedUserProfileName(buffer.toString());
        }
    	
  		//MHV_CodeCR1387 - Added relationship to VA in search detail page.
		StringBuffer relationshipToVA = new StringBuffer("");
		if(selectedProfile.getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if(selectedProfile.getIsVeteran()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if(selectedProfile.getIsHealthCareProvider()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if(selectedProfile.getIsPatientAdvocate()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if(selectedProfile.getIsEmployee()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if(selectedProfile.getIsOther()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}

		setSelectedUserProfileVaRelationship(relationshipToVA.toString());
			
		if(selectedProfile.getCreatedDate()!=null){
			// Account Created Date
			setSelectedUserProfileCreatedDate(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCreatedDate()));
		}

		//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
		
		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected. 
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileTreatingFacilities("");
		setSelectedUserProfileCorrelationStatus("");
		setSelectedUserProfileCorrelationDate("");
		setSelectedUserProfileCorrelationRequestDate("");
		setSelectedUserProfileCorrelationPerformedBy("");
		setSelectedUserProfileAuthenticationStatus("");
		setSelectedUserProfileAuthenticationDate("");
		setSelectedUserProfileAuthenticatingFacility("");
		setSelectedUserProfileAuthenticatedBy("");
		setSelectedUserProfileAccountStatus("");
		setSelectedUserProfileStartUpgradeAutoDate("");
		setSelectedUserProfileStartUpgradeManualDate("");
		setSelectedUserProfileSignedErarDate("");
		
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileMatchingDate("");
		Patient patient = getPatient(selectedProfile);
		displayMatchButton = false;
		
		if(patient !=null && patient.getMatchedDateTime()==null && selectedProfile.getDeactivationReason() == null) {
			displayMatchButton = true;
		} else if(patient ==null && (selectedProfile.getIsPatient()||selectedProfile.getIsVeteran())) {
			displayMatchButton = true;
		}
		
		if(patient != null) {
			if(patient.getMatchedDateTime()!=null) {
				setSelectedUserProfileMatchingStatus("Matched");
				setSelectedUserProfileMatchingDate(
						new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
			}
			InPersonAuthentication ipa = getIPA(patient);
			setSelectedUserProfileTreatingFacilities(getTxFacilities(patient));
			setSelectedUserProfileCorrelationStatus(getCorrelationStatus(patient));
			setSelectedUserProfileCorrelationDate(getCorrelationDate(patient));
			setSelectedUserProfileCorrelationRequestDate(getCorrelationRequestDate(patient));
			setSelectedUserProfileCorrelationPerformedBy(getCorrelatedBy(patient));
			if(ipa != null) {
				setSelectedUserProfileAuthenticationStatus(getAuthenticationStatus(ipa));
				setSelectedUserProfileAuthenticationDate(getAuthenticationDate(ipa));
				setSelectedUserProfileAuthenticatingFacility(getAuthenticatingFacility(ipa));
				setSelectedUserProfileAuthenticatedBy(getAuthenticatedBy(ipa));
				setSelectedUserProfileStartUpgradeAutoDate(getStartUpgradeAutoDate(ipa));
				setSelectedUserProfileStartUpgradeManualDate(getStartUpgradeManualDate(ipa));
				setSelectedUserProfileSignedErarDate(getSignedFormOnlineDateTime(ipa));
				
				//JAZZ#32763 US02 RQ#5- The MHV system shall check if the Signed 10-5345a-MHV form online field is set and display two new buttons: 
				StringServiceResponse vapiiStatusResponse = 
					gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
							ipa.getPatient().getUserProfile());
				
				if(vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "vapiiError");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}			
				}else if(!"Submitted".equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "formNotFound");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() !Submitted.equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}			
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() getRequest().getSession().removeAttribute(displayError)");
					}			
					getRequest().getSession().removeAttribute("displayError");
				}
				
				if(ipa.getSignedFormOnlineDateTime()!=null) {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()!=null");
					}			
					setDisplayDownloadERARButton(true);
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()==null");
					}			
					setDisplayDownloadERARButton(false);
				}
			}
		}
		setSelectedUserProfileAccountStatus(getAccountStatus(patient));
		
	    return new Forward("success");
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
    private InPersonAuthentication getIPA(Patient patient) {
        return ServiceDelegateFactory.
            createInPersonAuthenticationServiceDelegate().
            getAuthenticationForPatient(patient.getId()).getInPersonAuthentication();
    }

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
    private Patient getPatient(UserProfile userProfile) {
        PatientServiceResponse pResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(userProfile);
	    return pResponse.getPatient();
    }
    
	@Jpf.Action(forwards = {
        @Jpf.Forward(name = AuthenticationStatus.UNAUTHENTICATED, action="initiateAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGAUTHENTICATION, action="initiateAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGFAILED, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGDATAMISMATCH, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.INPROCESS, action="continueAuthentication"),
		@Jpf.Forward(name = AuthenticationStatus.PREREQUISITESCOMPLETE, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.AUTHENTICATED, action = "removeAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGREMOVAL, action = "initiateAuthentication"),
		@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} 
    )
	public Forward performAuthentication() {
		String value = getRequest().getParameter("patientId");
		Long patientId = Long.parseLong(value);
		
		InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		InPersonAuthenticationServiceResponse response = delegate.getAuthenticationForPatient(patientId);
		handleMessages(response);
		
		if(facilityOptions != null && facilityOptions.size()==0){
			this.setupFacilityInfo();
		}
		
		List msgs = (List) getRequest().getAttribute(Messages.REQ_ATTR_ERROR_MSGS);
	    if (msgs != null && !msgs.isEmpty()) {
	    	return new Forward( PageFlowControllerConstants.FORWARD_FAILURE );
	    }
	    
	    currentIPA = response.getInPersonAuthentication();
        updateSearchResults();
	    patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
		
		determineMatchStatus();
		determineDisplayButtons();
		
	    return new Forward(currentIPA.getStatus().getName());
	}
	
	private void determineDisplayButtons() {
		setDisplayMatchButton(false);
		if ((currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGDATAMISMATCH) ||
			 currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.INPROCESS) ||
			 currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.PREREQUISITESCOMPLETE) ||
			 currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.UNAUTHENTICATED) ||
			 currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGREMOVAL)) &&
			(currentIPA.getPatient().getMatchedDateTime() == null) &&
			(currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED))) {
			setDisplayMatchButton(true);
		} else if((currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)||
				   currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDCORRELATION)||
				   currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDUNCORRELATION)||
				   currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATIONINVALID))
				  //Jazz # 128619 - Admin Portal Enhancement - Display Match button for stuck accounts 
				  /*(currentIPA.getPatient().getMatchedDateTime() == null)*/) {
			setDisplayMatchButton(true);
		} else if (//(currentIPA.getStatus() != AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGAUTHENTICATION)) &&
				//Jazz # 128619 - Admin Portal Enhancement - Display Match button for stuck accounts 
				//(currentIPA.getPatient().getMatchedDateTime() == null) &&
				(currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGCORRELATION) ||
				 currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGUNCORRELATION))) {
			setDisplayMatchButton(true);
		}		
		
		if((currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)||
			currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.MVIDATAMATCH)||
			currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDCORRELATION)||
			currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDUNCORRELATION)||
			currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATIONINVALID)) &&
		   (currentIPA.getPatient().getMatchedDateTime() != null) && !getDisplayMatchButton()) {
			setDisplayCorrelateButton(true);
		}else if((currentIPA.getStatus() == AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGAUTHENTICATION) &&
				(currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGCORRELATION)))&& !getDisplayMatchButton()) {
			//CR2013 - Make sure that correlat button displays for PendingAuth/PendingCorr situation
			setDisplayCorrelateButton(true);
		} else {
			setDisplayCorrelateButton(false);
		}
		
		if ((currentIPA.getPatient().getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) &&
				(currentIPA.getPatient().getMatchedDateTime() != null) &&
				(currentIPA.getStatus() != AuthenticationStatus.getEnum(AuthenticationStatus.AUTHENTICATED)) &&
				(currentIPA.getStatus() != AuthenticationStatus.getEnum(AuthenticationStatus.PENDINGAUTHENTICATION))){
			setDisplayAuthenticationButton(true);
		} else {
			setDisplayAuthenticationButton(false);
		}
		
		//JAZZ#32763 US02 RQ#5- The MHV system shall check if the Signed 10-5345a-MHV form online field is set and display two new buttons: 
		StringServiceResponse vapiiStatusResponse = 
			gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
				currentIPA.getPatient().getUserProfile());
		
		if(vapiiStatusResponse.getMessages().hasErrorMessages() && currentIPA != null && currentIPA.getSignedFormOnlineDateTime()!=null) {
			if (LOG.isDebugEnabled()) {
				LOG.debug("********** InPersonAuthenticatonController.determineDisplayButtons() vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
			}			
			getRequest().getSession().setAttribute("displayError", "vapiiError");
		}else if(!"Submitted".equalsIgnoreCase(vapiiStatusResponse.getString()) && currentIPA != null && currentIPA.getSignedFormOnlineDateTime()!=null) {
			if (LOG.isDebugEnabled()) {
				LOG.debug("********** InPersonAuthenticatonController.determineDisplayButtons() !Submitted.equalsIgnoreCase(vapiiStatusResponse.getString()) && currentIPA != null && currentIPA.getSignedFormOnlineDateTime()!=null");
			}			
			getRequest().getSession().setAttribute("displayError", "formNotFound");
		} else {
			if (LOG.isDebugEnabled()) {
				LOG.debug("********** InPersonAuthenticatonController.determineDisplayButtons() getRequest().getSession().removeAttribute(displayError)");
			}			
			getRequest().getSession().removeAttribute("displayError");
		}
		
		if(currentIPA.getSignedFormOnlineDateTime()!=null) {
			if (LOG.isDebugEnabled()) {
				LOG.debug("********** InPersonAuthenticatonController.determineDisplayButtons() currentIPA.getSignedFormOnlineDateTime()!=null");
			}			
			setDisplayDownloadERARButton(true);
		} else {
			if (LOG.isDebugEnabled()) {
				LOG.debug("********** InPersonAuthenticatonController.determineDisplayButtons() currentIPA.getSignedFormOnlineDateTime()==null");
			}			
			setDisplayDownloadERARButton(false);
		}
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="authenticatePatient.jsp"),
                            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward initiateAuthentication(InPersonAuthenticationForm form) {

        // Need to refresh the current IPA, because the record may have been
        // updated asynchronously by MPI
        if (refreshCurrentIPA()) {
            copyToIPAForm(form, currentIPA);
        }
		
		return determineForward();
	}
    
    private boolean refreshCurrentIPA() {
        if(currentIPA == null) {
        	return false;
        }
        
    	InPersonAuthenticationServiceResponse response = ServiceDelegateFactory.
            createInPersonAuthenticationServiceDelegate().
            getAuthenticationForPatient(currentIPA.getPatient().getId());
    	
        if (ServiceResponseUtils.hasErrorMessages(response)) {
            handleMessages(response);
            return false;
        } 
        currentIPA = response.getInPersonAuthentication();
        return true;
    }
	
	private void copyToIPAForm(InPersonAuthenticationForm form, InPersonAuthentication ipa) {
		form.copyFrom(ipa);
		FacilityInfo auth = ipa.getAuthenticatingFacility();
		if (auth != null) {
			form.setAuthenticatingFacility(auth.getId().toString());
		}
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="authenticatePatient.jsp"),
                            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward continueAuthentication(InPersonAuthenticationForm form) {
		copyToIPAForm(form, currentIPA);
		return determineForward();
	}
	
	private String getEmployeeName() {
		//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Section 3.7 Add Authenticated By  
		String username = "";
		if(getRequest().getUserPrincipal()!=null) {
			username = getRequest().getUserPrincipal().getName();
		} else {
			return "";
		}
		
		if (LOG.isDebugEnabled()) {
			LOG.info("InPersonAuthenticationController.authenticate(): getRequest().getUserPrincipal().getName(): "
			+ getRequest().getUserPrincipal().getName());
		}
		
		EmployeeRoleManagementServiceDelegate del = ServiceDelegateFactory.createEmployeeRoleManagementServiceDelegate();
		EmployeeServiceResponse sr = del.getEmployeeByUserName(username);
		Employee employee = sr.getEmployee();
		
		if (LOG.isDebugEnabled()) {
			LOG.info("InPersonAuthenticationController.authenticate(): employee: " + employee);
		}
		
		if (LOG.isDebugEnabled()) {
			LOG.info("InPersonAuthenticationController.authenticate(): currentIPA.setAuthenticatedBy entering employee: "
			+ employee.getLastName() + ", " + 
			employee.getFirstName()+ " " + "(" + employee.getUserName() + ")");
		}
		
		//Set up the Authenticated by in this format: VA Staff -  Smith, Jane VHAMWVSMITHJ
		return employee.getLastName() + ", " + 
			employee.getFirstName()+ " " + "(" + employee.getUserName() + ")";
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", 
            path="searchResults.jsp"),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward authenticate(InPersonAuthenticationForm form) {
		Forward forward = null;
		String username = "";
		if(getRequest().getUserPrincipal()!=null) {
			username = getRequest().getUserPrincipal().getName();
		}
		copyFromIPAFormToIPA(currentIPA, form);
		currentIPA.setAuthenticatedBy(getEmployeeName());
		
		String authenticatingFacilityName = "";
		if(currentIPA.getAuthenticatingFacility()!=null) {
			authenticatingFacilityName = currentIPA.getAuthenticatingFacility().getName();
		}
		
		// CR 1861
		//Auditor.auditMviAuthenticateRequestEvent(currentIPA.getPatient().getUserProfile().getId(), 
		//		ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true, authenticatingFacilityName);
		
		forward = determineForward();
		
		if((currentIPA.getPatient().getCorrelationStatus() != PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) ||
				(currentIPA.getPatient().getMatchedDateTime() == null)){
			if (LOG.isErrorEnabled()) {
				LOG.error("Trying to Authenticate a user who is NOT Correlated for VA Patient ICN: " + currentIPA.getPatient().getIcn() + " : Correlation Status:  " + currentIPA.getPatient().getCorrelationStatus().getValue());
			}			
			forward.setName("failure");
			return forward;
		}		
		
		InPersonAuthenticationServiceResponse response = InPersonAuthenticator.
    	getInstance().authenticate(currentIPA);
		handleMessages(response);
		
		forward = determineForward();
		
		currentIPA = response.getInPersonAuthentication();
		patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.
            getPatient(), currentIPA);
				
		updateSearchResults();
		
		if (forward.getName().equals("success")) {
		//if ((!ServiceResponseUtils.hasErrorMessages(response)) || (forward.getName().equals("success")) ){
			addSuccessMessage("auth.complete", 
                new Object [] {getPatientName()});
			//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Section 12.6 Add to AAL  
			Auditor.auditMviAuthenticateEvent(currentIPA.getPatient().getUserProfile().getId(), 
				ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true, 
				currentIPA.getAuthenticatingFacility()!=null?currentIPA.getAuthenticatingFacility().getName():"");
		} else {
			if (!ServiceResponseUtils.hasErrorMessages(response)){
				//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Section 12.7 Add to AAL  
				Auditor.auditMviAuthenticateEvent(currentIPA.getPatient().getUserProfile().getId(), 
					ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, false, 
					currentIPA.getAuthenticatingFacility()!=null?currentIPA.getAuthenticatingFacility().getName():"");
			}
		}
		return forward;
	}
    
	private void updateSearchResults() {
        refreshCurrentIPA();
        
		for (PatientInformation p : getSearchResults()) {
			if (currentIPA!=null && p.getPatientId().equals(currentIPA.getPatient().getId())) {
				//Admin Portal_CodeCR1838 - Make sure the search result displays the correct Correlation Status
				p.setCorrelationStatus(new Long(""+currentIPA.getPatient().getCorrelationStatus().getValue()));
				p.setAuthenticationStatus(currentIPA.getStatus());
				p.setAuthenticationDate(currentIPA.getAuthenticationDate());
				FacilityInfo facilityInfo = currentIPA.getAuthenticatingFacility();
				if(facilityInfo != null){
					p.setAuthenticatingFacilityInfoId(facilityInfo.getId());
					p.setAuthenticatingFacilityInfoName(facilityInfo.getName());
				} else {
					//Admin Portal_CodeCR1837 - made sure that facility doesn't display in the search result if not available
					p.setAuthenticatingFacilityInfoId(null);
					p.setAuthenticatingFacilityInfoName(null);
				}
                break;
			}else{
				if(LOG.isDebugEnabled()){
					LOG.debug("currentIPA is null or you are not trying to refresh the appropriate IPA patient");
				}
			}
		}
        //refreshCurrentIPA();
	}
	
	private void updateSearchResults(Collection ids) {
		InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		for (PatientInformation p : getSearchResults()) {
			if (ids.contains(p.getPatientId())) {
				p.setAuthenticationStatus(AuthenticationStatus.getEnum(AuthenticationStatus.AUTHENTICATED));
				p.setAuthenticationDate(new Date());
				InPersonAuthenticationServiceResponse response = del.getAuthenticationForPatient(p.getPatientId());
				handleMessages(response);
				InPersonAuthentication ipaObject = response.getInPersonAuthentication();
				FacilityInfo info = ipaObject.getAuthenticatingFacility();
				if(info != null){
					p.setAuthenticatingFacilityInfoId(info.getId());
					p.setAuthenticatingFacilityInfoName(info.getName());
				}
			}
		}
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="searchResults.jsp"),
            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward deferAuthentication(InPersonAuthenticationForm form) {
		copyFromIPAFormToIPA(currentIPA, form);
		
		InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		InPersonAuthenticationServiceResponse response = del.deferAuthentication(currentIPA);
		handleMessages(response, form);
		form.populateFieldLevelMessages(form.getMessages(), getRequest());
		
		currentIPA = response.getInPersonAuthentication();
		patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
	    
		updateSearchResults();
		
		Forward forward = determineForward();
		if (forward.getName().equals("success")) {
			addSuccessMessage("prereqs.saved", null);
		}
		return determineForward();
	}
	
	private void addSuccessMessage(String key, Object [] inserts) {
		Message msg = MessageUtils.createInformationalMessage(key, null, inserts);
		Messages msgs = new DefaultMessages();
		msgs.addMessage(msg);
		handleMessages(msgs);
	}

	private void copyFromIPAFormToIPA(InPersonAuthentication ipa, InPersonAuthenticationForm form) {
		form.copyTo(ipa);
		form.copyFacilityToIPA(ipa);
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.currentPage),
			@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward reset(InPersonAuthenticationForm form) {
		EntityMaintenanceServiceDelegate del = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate();
		InPersonAuthenticationServiceResponse response = del.findByPrimaryKey(currentIPA.getInPersonAuthenticationPK());
		handleMessages(response);
		
		currentIPA = response.getInPersonAuthentication();
		patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
	    
		this.copyToIPAForm(form, currentIPA);
		
		return determineForward();
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "cancel", navigateTo = Jpf.NavigateTo.previousPage) } )
	public Forward cancel() {
		return new Forward("cancel");
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "cancel", path="basicSearchResults.jsp") } )
	public Forward cancelToBasicResults() {
		return new Forward("cancel");
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "cancel", path="searchResults.jsp") } )
	public Forward cancelToResults() {
        updateSearchResults();
		return new Forward("cancel");
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="searchResults.jsp"),
            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)})
	public Forward terminateAuthentication(InPersonAuthenticationForm form) {
		InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		InPersonAuthenticationServiceResponse response = del.terminateAuthentication(currentIPA);
		handleMessages(response);
		
		currentIPA = response.getInPersonAuthentication();
		patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
	    
		updateSearchResults();
		
		Forward forward = determineForward();
		if (forward.getName().equals("success")) {
			addSuccessMessage("auth.terminated", new Object [] {getPatientName()});
		}
		return forward;
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="removeAuthentication.jsp"),
            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward removeAuthentication(InPersonAuthenticationForm form) {
		copyToIPAForm(form, currentIPA);
		return determineForward();
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="searchResults.jsp"),
            @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)})
	public Forward remove(InPersonAuthenticationForm form) {
		InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		InPersonAuthenticationServiceResponse response = del.unauthenticate(currentIPA);
		handleMessages(response);
		currentIPA = response.getInPersonAuthentication();
		patientSummaryDecorator = new PatientSummaryDecorator(currentIPA.getPatient(), currentIPA);
	    
		updateSearchResults();		
		
		Forward forward = determineForward();
		if (forward.getName().equals("success")) {
			//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Section 13.6 Add to AAL  
			Auditor.auditMviUnauthenticateEvent(currentIPA.getPatient().getUserProfile().getId(), 
					ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, true);
			addSuccessMessage("auth.removed", new Object [] {getPatientName()});
		} else {
			//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Section 13.7 Add to AAL  
			Auditor.auditMviUnauthenticateEvent(currentIPA.getPatient().getUserProfile().getId(), 
					ActivityActorTypeEnumeration.MHV_AUTHENTICATOR, false);
		}
		return forward;
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="confirmTermination.jsp") } )
	public Forward confirmTerminateAuthentication(InPersonAuthenticationForm form) {
		copyFromIPAFormToIPA(currentIPA, form);
		
		return determineForward();
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="confirmRemoval.jsp"),
			@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)} )
	public Forward confirmRemove(InPersonAuthenticationForm form) {
		// Redundant check; needed because of confirmation page
		if (StringUtils.isBlank(form.getIpaRemovalReason())) {
			Message msg = MessageUtils.createErrorMessage("removal.reason.missing", new String [] {"removalReason"}, null);
			Messages messages = new DefaultMessages();
			messages.addMessage(msg);
			handleMessages(messages);
			form.populateFieldLevelMessages(messages, getRequest());
		}
		return determineForward();
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", path="searchResults.jsp"),
			                @Jpf.Forward(name = "failure", navigateTo=Jpf.NavigateTo.currentPage)} )
	public Forward doManyAuthentication() {
		List<Long> ids = new ArrayList<Long>(authenticateManyItems.size());
		for (Iterator i = authenticateManyItems.iterator(); i.hasNext();) {
			String sId = (String) i.next();
			Long id = Long.parseLong(sId);
			ids.add(id);
		}
		
		InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
		VoidServiceResponse resp = del.authenticateMany(ids);
		handleMessages(resp);
		
		Forward forward = determineForward();
		if (forward.getName().equals("success")) {
			updateSearchResults(ids);
			authenticateManyItems = new ArrayList();
			addSuccessMessage("auth.multiple.complete", null);
			getSession().removeAttribute("_usersToAuthenticate");
		}
		
		return forward;
	}
	
	private String getPatientName() {
		StringBuffer buffer = new StringBuffer(100);
		buffer.append("");
		Patient p = currentIPA.getPatient();
		if (p != null) {
			UserProfile up = p.getUserProfile();
			if (up != null) {
				String first = up.getFirstName();
				String last = up.getLastName();
				String middle = up.getMiddleName();
				SuffixEnumeration suffix = up.getSuffix();
				buffer.append(first);
				if (!StringUtils.isBlank(middle)) {
					buffer.append(" ");
					buffer.append(middle);
				}
				buffer.append(" ");
				buffer.append(last);
				if (suffix != null) {
					buffer.append(" ");
					buffer.append(suffix.getName());
				}
			}
		}
		return buffer.toString();
	}
	
	private void setSearchResults(Collection<PatientInformation> items) {
		getSession().setAttribute(RESULTS_SESSION_KEY, items);
	}
	
	@SuppressWarnings("unchecked")
    private Collection<PatientInformation> getSearchResults() {
		return (Collection<PatientInformation>) getSession().getAttribute(RESULTS_SESSION_KEY);
	}

	/**
	 * Callback that is invoked when this controller instance is created.
	 */
	@Override
	protected void onCreate() {
	}

	/**
	 * Callback that is invoked when this controller instance is destroyed.
	 */
	@Override
	protected void onDestroy(HttpSession session) {
	}

	@Override
	protected Class getFormClass() {
		return InPersonAuthenticationForm.class;
	}
	
    public Map getDayOptions() {
    	return CalendarUtils.getDays();
    }

    public Map getMonthOptions() {
    	return CalendarUtils.getMonths();
    }

    public List getYearOptions() {
    	List years = CalendarUtils.getYears();
    	if(!years.get(0).equals(CalendarUtils.getFirstYear()+"")){
    		Collections.reverse(years);
    	}
    	return years;
    }
    
    public Map getFacilityOptions() {
    	return facilityOptions;
    }
    
    public List getDefermentReasonOptions() {
    	return InPersonAuthenticationForm.getIpaDefermentReasonLabels();
    }
    
    public List getRemovalReasonOptions() {
    	return InPersonAuthenticationForm.getIpaRemovalReasonLabels();
    }
    
    //  property accessors
	public InPersonAuthentication getCurrentIPA() {
		return currentIPA;
	}
   
	/*
     * MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Printer friendly page 
	 */
    @Jpf.Action(forwards = {@Jpf.Forward(name = "basicPrinterFriendlyPage", path="basicPrinterFriendlyList.jsp")} )
    public Forward basicPrinterFriendlyView() {
    	getRequest().setAttribute("_pfList", getRowListPage());
    	
    	return new Forward("basicPrinterFriendlyPage");
    }
    
    @Jpf.Action(forwards = {@Jpf.Forward(name = "printerFriendlyPage", path="printerFriendlyList.jsp")} )
    public Forward printerFriendlyView() {
    	getRequest().setAttribute("_pfList", getRowListPage());
    	
    	return new Forward("printerFriendlyPage");
    }
    
	// TODO The following code is duplicated from one of the Atlas Beehive controllers
	// This should be refactored up into atlas-beehive at some point.
	
	private static final int DEFAULT_PAGE_SIZE = 10;
	private static final String ROW_LIST_SESSION_KEY = "rowListPage";
	
	private Integer pageSize;
	private List<List> rowListPage = new ArrayList<List>();
	
	@SuppressWarnings("unchecked")
    protected List getRowListPage() {
		Object rowList = getSession().getAttribute(ROW_LIST_SESSION_KEY);
		if (rowList != null) {
			rowListPage.clear();
			rowListPage.addAll((List) rowList);
			getSession().removeAttribute(ROW_LIST_SESSION_KEY);
		}
		return Collections.unmodifiableList(rowListPage);
	}
	
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success", navigateTo=Jpf.NavigateTo.currentPage)} )
    public Forward updatePageSize() {
		String sSize = getRequest().getParameter("pageSize");
		if (sSize != null) {
			setPageSize(Integer.parseInt(sSize));
		} else {
			setPageSize(DEFAULT_PAGE_SIZE);
		}
		return new Forward("success");
	}
	
	public void setPageSize(int size) {
		this.pageSize = new Integer(pageSize);
	}
	
	public int getPageSize() {
		if (this.pageSize == null) {
			pageSize = new Integer(DEFAULT_PAGE_SIZE);
		}
		return pageSize.intValue();
	}
	public PatientSummaryDecorator getPatientSummary() {
		return patientSummaryDecorator;
	}
	
	public String getAuthenticationStatus(InPersonAuthentication ipa) {
		if(ipa.getStatus()==null){
			return "N/A";
		}
		AuthenticationStatus status = ipa.getStatus().getName() == null ? AuthenticationStatus.getEnum(AuthenticationStatus.UNAUTHENTICATED) : AuthenticationStatus.getEnum(ipa.getStatus().getName());
		return IPACriteriaForm.getPatientInfoAuthenticationStatusName(status);
	}
	
	public String getAuthenticationDate(InPersonAuthentication ipa) {
		if(ipa.getAuthenticationDate()==null){
			return "N/A";
		}
		//Admin Portal_CodeCR1747 - Fixed the date format 
		return(new SimpleDateFormat(TIME_FORMAT).format(ipa.getAuthenticationDate()));
	}
	
	public String getAuthenticatingFacility(InPersonAuthentication ipa) {
		if(ipa.getAuthenticatingFacility()==null){
			return "N/A";
		}
		return(ipa.getAuthenticatingFacility().getName());
	}

	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getStartUpgradeManualDate(InPersonAuthentication ipa) {
		String returnValue = "";
		if(ipa.getStartUpgradeManualDateTime() != null && ipa.getStartUpgradeManualDateTime() != null) {
			returnValue = new SimpleDateFormat(TIME_FORMAT).format(ipa.getStartUpgradeManualDateTime());
		}
		return returnValue;
	}
	
	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getStartUpgradeAutoDate(InPersonAuthentication ipa) {
		String returnValue = "";
		if(ipa.getStartUpgradeOnlineDateTime() != null && ipa.getStartUpgradeOnlineDateTime() != null) {
			returnValue = new SimpleDateFormat(TIME_FORMAT).format(ipa.getStartUpgradeOnlineDateTime());
		}
		return returnValue;
	}
	
	//JAZZ#32763 US01 - MHV View the eRAR Form   
	public String getSignedFormOnlineDateTime(InPersonAuthentication ipa) {
		String returnValue = "";
		if(ipa.getSignedFormOnlineDateTime() != null && ipa.getSignedFormOnlineDateTime() != null) {
			returnValue = new SimpleDateFormat(TIME_FORMAT).format(ipa.getSignedFormOnlineDateTime());
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getAuthenticatedBy(InPersonAuthentication ipa) {
		String returnValue = "";
		if(ipa.getAuthenticationDate() != null && ipa.getAuthenticatedBy() != null) {
			returnValue = ipa.getAuthenticatedBy();
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getCorrelatedBy(Patient patient) {
		String returnValue = "";
		if(patient.getCorrelatedBy() != null) {
			returnValue = patient.getCorrelatedBy();
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getCorrelateRequestDate(Patient patient) {
		String returnValue = "";
		PatientCorrelationStatus correlationStatus = patient.getCorrelationStatus() ; 
		if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) {
			if(patient.getCorrelateRequestDateTime() != null) {
				returnValue = new SimpleDateFormat(TIME_FORMAT).format(patient.getCorrelateRequestDateTime());
			}
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getCorrelationDate(Patient patient) {
		String returnValue = "";
		PatientCorrelationStatus correlationStatus = patient.getCorrelationStatus() ; 
		if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) {
			if(patient.getCorrelatedDateTime() != null) {
				returnValue = new SimpleDateFormat(TIME_FORMAT).format(patient.getCorrelatedDateTime());
			}
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getCorrelationRequestDate(Patient patient) {
		String returnValue = "";
		if(patient.getCorrelateRequestDateTime() != null) {
			returnValue = new SimpleDateFormat(TIME_FORMAT).format(patient.getCorrelateRequestDateTime());
		}
		return returnValue;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getCorrelationStatus(Patient patient) {
		PatientCorrelationStatus correlationStatus = patient.getCorrelationStatus() ; 
		if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)) {
			return "Uncorrelated";
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGCORRELATION)) {
			return "Pending Correlation";
        //Admin Portal_CodeCR1844 - Made sure that Pending uncorrelation shows up..
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGUNCORRELATION)) {
			return "Pending Uncorrelation";
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) {
			String returnValue = "Correlated";
			return returnValue;
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATIONINVALID)) {
			return "Correlation Invalid";
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDCORRELATION)) {
			return "Failed Correlation";
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDUNCORRELATION)) {
			return "Failed Uncorrelation";
		} else if(correlationStatus == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.MVIDATAMATCH)) {	
        	//Admin Portal_CodeCR1848 - Made sure that Uncorrelated shows up..
			return "Uncorrelated";
		}
		return "";
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page 
	public String getTxFacilities(Patient patient) {
		StringBuffer buff = new StringBuffer(); 
		if(patient.getFacilitys()==null || patient.getFacilitys().size()==0){
			return "N/A";
		}
		Iterator itr = patient.getFacilitys().iterator();
		while (itr.hasNext()) {
			Facility facility = (Facility)itr.next();
			FacilityInfo fi = facility.getFacilityInfo();
			if(fi != null){
				//JAZZ: Task#20186 - Task:Add comma at the end of each treating facility name in IPA detail pages.
				if (buff.length() > 0)
					buff.append(", <br/>");
				buff.append(fi.getName());
			}
			else{
				//JAZZ: Task#20186 - Task:Add comma at the end of each treating facility name in IPA detail pages.
				if (buff.length() > 0)
					buff.append(", <br/>");
				buff.append(facility.getName());
			}
		}
		return buff.toString();
	}
	
	private String getAccountStatus(Patient patient) {
		Boolean isPatientAuthenticated = false;
    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    	if(delegate == null){
			if(patient != null){
				if (patient.getMatchedDateTime() == null){
					return AccountStatusEnumeration.BASIC;
				}else{
					return AccountStatusEnumeration.ADVANCED;
				}
			}else{
				return AccountStatusEnumeration.BASIC;
			}
    	}else{	
			if(patient != null){
		    	isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
				if (patient.getMatchedDateTime() == null){
					return AccountStatusEnumeration.BASIC;
				} else if(isPatientAuthenticated != null) {
					if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.PREMIUM;
					else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.ADVANCED;
		    		else if(!isPatientAuthenticated && patient.getMatchedDateTime() != null)
		    			return AccountStatusEnumeration.ADVANCED;
				}else{
					return AccountStatusEnumeration.ADVANCED;
				}
			}else{
				return AccountStatusEnumeration.BASIC;
			}
			return AccountStatusEnumeration.ADVANCED;
				
			/*
			if(isPatientAuthenticated != null) {
				if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
	    			return AccountStatusEnumeration.PREMIUM;
				else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
	    			return AccountStatusEnumeration.ADVANCED;
	    		else if(!isPatientAuthenticated)
	    			return AccountStatusEnumeration.ADVANCED;
			}
			return AccountStatusEnumeration.ADVANCED;
			*/
    	}
	}
	
}