package gov.va.med.mhv.usermgmt.portlet.myaccounttype;

import java.text.SimpleDateFormat;

import gov.va.med.mhv.usermgmt.enumeration.AccountStatusEnumeration;
import gov.va.med.mhv.usermgmt.portlet.ipa.InPersonAuthenticatonController;
import gov.va.med.mhv.usermgmt.portlet.ipa.PatientSummaryDecorator;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.MviIntegrationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.transfer.UserProfilePK;
import gov.va.med.mhv.usermgmt.util.PatientCorrelationStatusUtils;

import javax.servlet.http.HttpSession;
import org.apache.beehive.netui.pageflow.PageFlowController;
import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.service.StringServiceResponse;

// Substitute with this annotation if nested pageflow
// @Jpf.Controller( nested=true )

@Jpf.Controller()
public class MyAccountType extends PageFlowController {
	private static final long serialVersionUID = 1L;
	private static final Log LOG = LogFactory.getLog(InPersonAuthenticatonController.class);

    private UserProfile selectedProfile;
    private String selectedUserProfileVaRelationship;
    private String selectedUserProfileAccountStatus;
    private String selectedUserProfileCreatedDate;
	private static final String TIME_FORMAT = "MM/dd/yyyy hh:mm a z";
	private Boolean displayDownloadERARButton;

	//MHV_CodeCRTBD - US12.8 VAPii Implementation
	public Boolean getDisplayDownloadERARButton() {
		return displayDownloadERARButton;
	}

	//MHV_CodeCRTBD - US12.8 VAPii Implementation
	public void setDisplayDownloadERARButton(Boolean displayDownloadERARButton) {
		this.displayDownloadERARButton = displayDownloadERARButton;
	}
	
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileCreatedDate() {
		return selectedUserProfileCreatedDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileCreatedDate(String createdDate) {
		this.selectedUserProfileCreatedDate = createdDate;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileAccountStatus() {
		return selectedUserProfileAccountStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileAccountStatus(
			String selectedUserProfileAccountStatus) {
		this.selectedUserProfileAccountStatus = selectedUserProfileAccountStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public String getSelectedUserProfileVaRelationship() {
		return selectedUserProfileVaRelationship;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
	public void setSelectedUserProfileVaRelationship(String vaRelationship) {
		this.selectedUserProfileVaRelationship = vaRelationship;
	}

	@Jpf.Action(forwards = {@Jpf.Forward(name = "cancel", navigateTo = Jpf.NavigateTo.previousPage) } )
	public Forward cancel() {
		return new Forward("cancel");
	}
	
	@Jpf.Action(forwards = { @Jpf.Forward(name = "index", path = "/portlets/myaccounttype/myAccountType.jsp") })
	protected Forward begin() {
        Long id = new Long(getRequest().getParameter("id"));
        UserProfileServiceResponse response = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate().findByPrimaryKey(new UserProfilePK(id));
        selectedProfile = response.getUserProfile();
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse pResponse = 
			mviSyncServiceDelegate.matchPersonInIPA(selectedProfile);
		
		Patient patient = pResponse.getPatient();
        
        
        
		StringBuffer relationshipToVA = new StringBuffer("");
		if(selectedProfile.getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if(selectedProfile.getIsVeteran()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if(selectedProfile.getIsHealthCareProvider()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if(selectedProfile.getIsPatientAdvocate()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if(selectedProfile.getIsEmployee()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if(selectedProfile.getIsOther()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}

		setSelectedUserProfileVaRelationship(relationshipToVA.toString());
		setSelectedUserProfileAccountStatus(getAccountStatus(patient));
		
		if(selectedProfile.getCreatedDate()!=null){
			// Account Created Date
			setSelectedUserProfileCreatedDate(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCreatedDate()));
		}
		
		//MHV_CodeCRTBD - US12.8 VAPii Implementation
		StringServiceResponse vapiiStatusResponse = 
			gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
					selectedProfile);
		
		if (LOG.isDebugEnabled()) {
			LOG.debug("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@EAuthGatewayServlet vapiiStatusResponse="+vapiiStatusResponse);
		}			
		if("Submitted".equalsIgnoreCase(vapiiStatusResponse.getString())) {
			setDisplayDownloadERARButton(true);
		} else {
			setDisplayDownloadERARButton(false);
		}
		
		return new Forward("index");
	}

	// Uncomment this block if nested pageflow
	/**
	@Jpf.Action(
	    forwards={
	       @Jpf.Forward(name="done", returnAction="NestedTemplateDone")
	    }
	)
	protected Forward done()
	{
		return new Forward("done");
	}
	 **/

	/**
	 * Callback that is invoked when this controller instance is created.
	 */
	protected void onCreate() {
	}

	/**
	 * Callback that is invoked when this controller instance is destroyed.
	 */
	protected void onDestroy(HttpSession session) {
	}
	
	private String getAccountStatus(Patient patient) {
		Boolean isPatientAuthenticated = false;
    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    	if(delegate == null){
			if(patient != null){
				if (patient.getMatchedDateTime() == null){
					return AccountStatusEnumeration.BASIC;
				}else{
					return AccountStatusEnumeration.ADVANCED;
				}
			}else{
				return AccountStatusEnumeration.BASIC;
			}
    	}else{	
			if(patient != null){
		    	isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
				if (patient.getMatchedDateTime() == null){
					return AccountStatusEnumeration.BASIC;
				} else if(isPatientAuthenticated != null) {
					if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.PREMIUM;
					else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
						return AccountStatusEnumeration.ADVANCED;
		    		else if(!isPatientAuthenticated && patient.getMatchedDateTime() != null)
		    			return AccountStatusEnumeration.ADVANCED;
				}else{
					return AccountStatusEnumeration.ADVANCED;
				}
			}else{
				return AccountStatusEnumeration.BASIC;
			}
			return AccountStatusEnumeration.ADVANCED;
				
			/*
			if(isPatientAuthenticated != null) {
				if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
	    			return AccountStatusEnumeration.PREMIUM;
				else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
	    			return AccountStatusEnumeration.ADVANCED;
	    		else if(!isPatientAuthenticated)
	    			return AccountStatusEnumeration.ADVANCED;
			}
			return AccountStatusEnumeration.ADVANCED;
			*/
    	}
	}

}