package gov.va.med.mhv.usermgmt.portlet.resetpassword;
import gov.va.med.mhv.beehive.EntityReadOnlyListPageFlowController;
import gov.va.med.mhv.usermgmt.enumeration.AccountStatusEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.PatientCorrelationStatus;
import gov.va.med.mhv.usermgmt.enumeration.UserProfileDeactivateReason;
import gov.va.med.mhv.usermgmt.enumeration.UserProfileReactivateReason;
import gov.va.med.mhv.usermgmt.form.AccountActivityCriteriaForm;
import gov.va.med.mhv.usermgmt.form.DeactivateUserForm;
import gov.va.med.mhv.usermgmt.form.InPersonAuthenticationForm;
import gov.va.med.mhv.usermgmt.form.ReactivateUserForm;
import gov.va.med.mhv.usermgmt.form.SendPasswordForm;
import gov.va.med.mhv.usermgmt.form.UserProfileForm;
import gov.va.med.mhv.usermgmt.portlet.aal.controller.AalController;
import gov.va.med.mhv.usermgmt.portlet.aal.decorator.ActivityDetailDecorator;
import gov.va.med.mhv.usermgmt.portlet.aal.decorator.UserProfileDecorator;
import gov.va.med.mhv.usermgmt.service.ActivityCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.ActivityServiceResponse;
import gov.va.med.mhv.usermgmt.service.InPersonAuthenticationServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileDeactivationAuditCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.ActivityAuditServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.EntityMaintenanceServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.MviIntegrationServiceDelegate;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.UserProfileServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.Activity;
import gov.va.med.mhv.usermgmt.transfer.ActivityPK;
import gov.va.med.mhv.usermgmt.transfer.InPersonAuthentication;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.TransferObjectFactory;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.transfer.UserProfileDeactivationAudit;
import gov.va.med.mhv.usermgmt.transfer.UserProfileDeactivationReason;
import gov.va.med.mhv.usermgmt.transfer.UserProfilePK;
import gov.va.med.mhv.usermgmt.util.PatientCorrelationStatusUtils;
import gov.va.med.mhv.usermgmt.util.UserProfileDeactivationUtils;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import java.util.regex.Pattern;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.commons.lang.StringUtils;
import org.displaytag.properties.SortOrderEnum;
import org.tigris.atlas.beehive.PageFlowControllerConstants;
import org.tigris.atlas.config.ConfigurationManager;
import org.tigris.atlas.messages.Message;
import org.tigris.atlas.messages.MessageUtils;
import org.tigris.atlas.service.EntityCollectionServiceResponse;
import org.tigris.atlas.service.StringServiceResponse;
import org.tigris.atlas.service.VoidServiceResponse;
import org.tigris.atlas.util.CalendarUtils;

/**
 * @jpf:controller struts-merge="/WEB-INF/struts-override.xml"
 *  */
@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class ResetPasswordController extends EntityReadOnlyListPageFlowController
{

	// [TODO] Add back in this control, however it's done in 9.2
    // @Control()
    //private gov.va.med.mhv.usermgmt.portlet.resetpassword.emailJcx emailControl;
    private static final Properties PROPS = ConfigurationManager.getConfiguration("/mailCfg.properties");
	private static final Pattern pattern = Pattern.compile("^[A-Za-z][0-9][0-9][0-9][0-9]$");

	private static final String TIME_FORMAT = "MM-dd-yyyy hh:mm a z";
    private Collection userProfiles;
    private UserProfile selectedProfile;
    private String generatedPassword;
    private String email;

	//JAZZ#112876 - US#9 Admin Portal Enhancements - Admin Portal User Activity Log
	private static final long serialVersionUID = 1205561710L;
	private static final String TABLE_SESSION_KEY = AalController.class.getName() + ".activities";
	private	java.util.Collection currentActivities = null;
	private UserProfileDecorator currentUserProfile = null;
	private	ActivityDetailDecorator	currentActivity = null;
	private Date twelveMonthsFromToday;
	private Date today;

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
    private String correlationStatus;
    private String correlationRequestDateTime;
    private String correlationDateTime;
    private String correlationPeformedBy;
    private String matchingStatus;
    private String accountStatus;
    private String matchingDate;
    private String createdDate;
    private String icn;
    private String mviAuthenticationStatus;

    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
    private String deactivated;
    private String deactivatedReason;
    private String deactivatedDescription;

    private List deactivateReasonLabels;
    private List reactivateReasonLabels;

    private Boolean displayGeneratePasswordButton;
    
	//MHV_CodeCR1919 - US12.4.x MVI Compliance Implementation - Adding Uncorrelate Button in Help Desk
    private Boolean displayUncorrelateButton;
    private Boolean displayReactivateButton;
    private Boolean displayDeactivateButton;
    //JAZZ#112876 - US#4 Admin Portal Enhancements - Force Deactivation
    private Boolean displayForceDeactivateButton;

	//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk - Update Profile Button
    private Boolean displayProfileUpdateButton;

    //JAZZ# 128619 - Admin Portal Enhancements - Remove Correlation in MVI
    private Boolean displayRemoveCorrelationInMVIButton;
    
	private static final String SUBJECT = "My HealtheVet Inquiry Response";
    private static final String BODY = "We have reset your password for you.  Your new password is: ";

    // Uncomment this declaration to access Global.app.
    //
    //     protected global.Global globalApp;
    //

    // For an example of page flow exception handling see the example "catch" and "exception-handler"
    // annotations in {project}/WEB-INF/src/global/Global.app



    public List getDeactivateReasonLabels() {
    	Map deactivateReasonLabelsMap = new TreeMap();
      	deactivateReasonLabelsMap.putAll(UserProfileDeactivateReason.getEnumMap());
      	deactivateReasonLabels = new ArrayList();
      	deactivateReasonLabels.addAll(deactivateReasonLabelsMap.keySet());
      	Collections.sort(deactivateReasonLabels, new SortIgnoreCase());
      	Collections.unmodifiableList(deactivateReasonLabels);
      	return deactivateReasonLabels;
    }

    private class SortIgnoreCase implements Comparator<Object> {
    	public int compare(Object o1, Object o2) {
	    	String s1 = (String) o1;
	    	String s2 = (String) o2;
	    	return s1.toLowerCase().compareTo(s2.toLowerCase());
    	}
    }

    public List getReactivateReasonLabels() {
    	Map reactivateReasonLabelsMap = new TreeMap();
      	reactivateReasonLabelsMap.putAll(UserProfileReactivateReason.getEnumMap());
      	reactivateReasonLabels = new ArrayList();
      	reactivateReasonLabels.addAll(reactivateReasonLabelsMap.keySet());
      	Collections.sort(reactivateReasonLabels, new SortIgnoreCase());
      	Collections.unmodifiableList(reactivateReasonLabels);
      	return reactivateReasonLabels;
    }

    //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
    public Boolean getDisplayGeneratePasswordButton() {
		return displayGeneratePasswordButton;
	}

    //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
	public void setDisplayGeneratePasswordButton(
			Boolean displayGeneratePasswordButton) {
		this.displayGeneratePasswordButton = displayGeneratePasswordButton;
	}

	//JAZZ# 128619 - Admin Portal Enhancements - Remove Correlation in MVI
    public Boolean getDisplayRemoveCorrelationInMVIButton() {
		return displayRemoveCorrelationInMVIButton;
	}

    //JAZZ# 128619 - Admin Portal Enhancements - Remove Correlation in MVI
	public void setDisplayRemoveCorrelationInMVIButton(
			Boolean displayRemoveCorrelationInMVIButton) {
		this.displayRemoveCorrelationInMVIButton = displayRemoveCorrelationInMVIButton;
	}

	public String getMatchingDate() {
		return matchingDate;
	}

	public void setMatchingDate(String matchingDate) {
		this.matchingDate = matchingDate;
	}

	public Boolean getDisplayDeactivateButton() {
		return displayDeactivateButton;
	}

	public void setDisplayDeactivateButton(Boolean displayDeactivateButton) {
		this.displayDeactivateButton = displayDeactivateButton;
	}

	//JAZZ#112876 - US#4 Admin Portal Enhancements - Force Deactivation
	public Boolean getDisplayForceDeactivateButton() {
		return displayForceDeactivateButton;
	}

	//JAZZ#112876 - US#4 Admin Portal Enhancements - Force Deactivation
	public void setDisplayForceDeactivateButton(Boolean displayForceDeactivateButton) {
		this.displayForceDeactivateButton = displayForceDeactivateButton;
	}

	public Boolean getDisplayReactivateButton() {
		return displayReactivateButton;
	}

	public void setDisplayReactivateButton(Boolean displayReactivateButton) {
		this.displayReactivateButton = displayReactivateButton;
	}

	//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk - Update Profile Button
	public Boolean getDisplayProfileUpdateButton() {
		return displayProfileUpdateButton;
	}

	//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk - Update Profile Button
	public void setDisplayProfileUpdateButton(Boolean displayProfileUpdateButton) {
		this.displayProfileUpdateButton = displayProfileUpdateButton;
	}

	public String getMviAuthenticationStatus() {
		return mviAuthenticationStatus;
	}

	public void setMviAuthenticationStatus(String mviAuthenticationStatus) {
		this.mviAuthenticationStatus = mviAuthenticationStatus;
	}

    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
	public String getDeactivated() {
		return deactivated;
	}

	public void setDeactivated(String deactivated) {
		this.deactivated = deactivated;
	}

	public String getDeactivatedReason() {
		return deactivatedReason;
	}

	public void setDeactivatedReason(String deactivatedReason) {
		this.deactivatedReason = deactivatedReason;
	}

	public String getDeactivatedDescription() {
		return deactivatedDescription;
	}

	public void setDeactivatedDescription(String deactivatedDescription) {
		this.deactivatedDescription = deactivatedDescription;
	}

	//MHV_CodeCR1919 - US12.4.x MVI Compliance Implementation - Adding Uncorrelate Button Field.
	public Boolean getDisplayUncorrelateButton() {
		return displayUncorrelateButton;
	}

	//MHV_CodeCR1919 - US12.4.x MVI Compliance Implementation - Adding Uncorrelate Button Field.
	public void setDisplayUncorrelateButton(Boolean displayUncorrelateButton) {
		this.displayUncorrelateButton = displayUncorrelateButton;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - ICN field
	public String getIcn() {
		return icn;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - ICN field
	public void setIcn(String icn) {
		this.icn = icn;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
    public String getCorrelationStatus() {
		return correlationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setCorrelationStatus(String correlationStatus) {
		this.correlationStatus = correlationStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public String getCorrelationRequestDateTime() {
		return correlationRequestDateTime;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setCorrelationRequestDateTime(String correlationRequestDateTime) {
		this.correlationRequestDateTime = correlationRequestDateTime;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public String getCorrelationDateTime() {
		return correlationDateTime;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setCorrelationDateTime(String correlationDateTime) {
		this.correlationDateTime = correlationDateTime;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public String getCorrelationPeformedBy() {
		return correlationPeformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setCorrelationPeformedBy(String correlationPeformedBy) {
		this.correlationPeformedBy = correlationPeformedBy;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
    public String getMatchingStatus() {
		return matchingStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setMatchingStatus(String matchingStatus) {
		this.matchingStatus = matchingStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public String getAccountStatus() {
		return accountStatus;
	}

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
	public void setAccountStatus(String accountStatus) {
		this.accountStatus = accountStatus;
	}

    public String getCreatedDate() {
		return createdDate;
	}

	public void setCreatedDate(String createdDate) {
		this.createdDate = createdDate;
	}

	/**
     * This method represents the point of entry into the pageflow
     * @jpf:action
     * @jpf:forward name="success" path="search.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "search.jsp")
    })
    public Forward begin()
    {
		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected.
    	resetValues();
        return determineForward();
    }

    public String getEmail()
    {
        return email;
    }

    public String getSelectedProfileBirthDate()
    {
        if (selectedProfile == null)
        {
            return "";
        }

        Calendar cal = GregorianCalendar.getInstance();
        cal.setTime(selectedProfile.getBirthDate());

        StringBuffer bd = new StringBuffer();
        bd.append(cal.get(Calendar.MONTH));
        bd.append("/");
        bd.append(cal.get(Calendar.DATE));
        bd.append("/");
        bd.append(cal.get(Calendar.YEAR));

        return bd.toString();

    }

    public UserProfileDecorator getCurrentUserProfile() {
    	return currentUserProfile;
    }
    
    public java.util.Collection getCurrentActivities () {
    	return currentActivities;
    }
    
	public String getTodayMonth(){
		return CalendarUtils.getMonth(today);
	}
	public String getTodayYear(){
		return CalendarUtils.getYear(today);
	}
	public String getTodayDay(){
		return CalendarUtils.getDay(today);
	}
	public String getTwelveMonthsFromTodayMonth(){
		return CalendarUtils.getMonth(twelveMonthsFromToday);
	}
	public String getTwelveMonthsFromTodayYear(){
		return CalendarUtils.getYear(twelveMonthsFromToday);
	}
	public String getTwelveMonthsFromTodayDay(){
		return CalendarUtils.getDay(twelveMonthsFromToday);
	}
	public String getTwelveMonthsFromTodayAsString(){
		return SimpleDateFormat.getDateInstance().format(twelveMonthsFromToday.getTime());
	}
  
	//JAZZ#112876 - US#9 Admin Portal Enhancements - Admin Portal User Activity Log
	//When the Help Desk Administrator selects the Display Activity button, System 
	//shall display the Account Activity Summary page for the MHV account.
	@Jpf.Action(forwards = { @Jpf.Forward(name = "default", path = "/gov/va/med/mhv/usermgmt/portlet/resetpassword/accountActivityHistory.jsp")})
    public Forward displayActivity(AccountActivityCriteriaForm form) {
		currentUserProfile = new UserProfileDecorator(selectedProfile);
		currentActivities = new ArrayList();

		today = new Date();
		Calendar newTime = Calendar.getInstance();
		newTime.add(Calendar.MONTH, -12);
		twelveMonthsFromToday = newTime.getTime();

		form = getDefaultCriteria();
		currentActivities = getUserAccountActivities(form);
		return new Forward("default");
    }

	//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward profileUpdate(UserProfileForm form) {
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse response = 
			mviSyncServiceDelegate.updateUserProfile(selectedProfile);
		handleMessages(response);
        
        if(response.getPatient()!=null) {
        	selectedProfile = response.getPatient().getUserProfile();
        }
		
		populateSelectedUserFields(form);
        return determineForward();

	}
	
	//JAZZ#112876 - US#9 Admin Portal Enhancements - Admin Portal User Activity Log
	//When the Help Desk Administrator selects the Display Activity button, System 
	//shall display the Account Activity Summary page for the MHV account.
	//*************************** BEGIN *******************************************
    private Collection getUserAccountActivities(AccountActivityCriteriaForm form){
    	if(form.getActivityPerformerType().equals("User")) {
    		form.setActivityPerformerType("Self");
    	} else if(form.getActivityPerformerType().equals("Everyone But User")) {
    		form.setActivityPerformerType("Everyone But Self");
    	}
    	
		ActivityAuditServiceDelegate delegate = ServiceDelegateFactory.createActivityAuditServiceDelegate();
		ActivityCollectionServiceResponse response = delegate.getActivitiesForSubject(currentUserProfile.getId(), form.getActivityPerformerType(), new Timestamp(form.getFromDate().getTime()), new Timestamp(form.getToDate().getTime()));
		handleMessages(response);
		return response.getActivitys();
	}
	
	private AccountActivityCriteriaForm getDefaultCriteria(){
		AccountActivityCriteriaForm form = new AccountActivityCriteriaForm();
		Calendar twelveMonthsAgo = Calendar.getInstance();
		twelveMonthsAgo.setTime(new Date());
		twelveMonthsAgo.add(Calendar.MONTH, -12);
		form.setFromDate(new Timestamp(twelveMonthsAgo.getTime().getTime()));
		form.setToDate(new Timestamp(new Date().getTime()));
		form.setActivityPerformerType(ActivityActorTypeEnumeration.EVERYONE);
		return form;
	}
	
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "/gov/va/med/mhv/usermgmt/portlet/resetpassword/accountActivityHistory.jsp")})
	public Forward queryForUserAccountActivities(AccountActivityCriteriaForm form){
		form.validate(this.getRequest());
		if(form.getMessages() != null && form.getMessages().hasErrorMessages() && !form.getMessages().hasErrorMessages("error.date.span")){
			this.getMessagesHandler().handleMessages(form.getMessages(),AccountActivityCriteriaForm.class,this.getRequest());
			return new Forward("success");
		}
		
		if(currentUserProfile != null){
			currentActivities = getUserAccountActivities(form);
			
	    	if(form.getActivityPerformerType().equals("Self")) {
	    		form.setActivityPerformerType("User");
	    	} else if(form.getActivityPerformerType().equals("Everyone But Self")) {
	    		form.setActivityPerformerType("Everyone But User");
	    	}
		}
		return new Forward("success");
	}
	
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "accountActivityHistory.jsp")})
	public Forward backToSummary(){
		return new Forward("success");
	}
	
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "accountActivityHistoryPF.jsp")})
	public Forward printerFriendlyListView(){
		return new Forward("success");
	}

	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "accountActivityDetailPF.jsp")})
	public Forward printerFriendlyDetailView(){
		return new Forward("success");
	}
    
    protected String getActionEntityIdParameter() {
        return getRequest().getParameter("activityId");
    }

	@Jpf.Action(forwards = {
            @Jpf.Forward(name = "success", path="accountActivityDetail.jsp"),
            @Jpf.Forward(name = "failure", action = "begin")} )
	public Forward viewAccountActivityDetail(){
        Forward forward = null;
		String id = getActionEntityIdParameter(); 
        if (isValidActivityId(id)) {
    		Long activityId = Long.parseLong(id);
    		ActivityPK pk = TransferObjectFactory.createActivityPK();
    		pk.setActivityId(activityId);
    		EntityMaintenanceServiceDelegate delegate = ServiceDelegateFactory.
                createEntityMaintenanceServiceDelegate();
    		ActivityServiceResponse response = delegate.findByPrimaryKey(pk);
    		handleMessages(response);
    		currentActivity = new ActivityDetailDecorator(response.getActivity());
            forward = determineForward();
        } else {
            forward = determineForwardOnUnknownEntity("view");
        }
		return forward;
	}
    
    private boolean isValidActivityId(String activityId) {
        if ((currentActivities != null) && !StringUtils.isBlank((activityId))) {
            for (Object a : currentActivities) {
                Activity activity = (Activity) a;
                if (activityId.equals(activity.getActivityId().toString())) {
                    return true;
                }
            }
        }
        return false;
    }

	@Jpf.Action(forwards = { @Jpf.Forward(name = "default", path = "accountActivityHistory.jsp")})
	public Forward reset(AccountActivityCriteriaForm form){
		form = new AccountActivityCriteriaForm();
		return new Forward("default");
	}

	@Jpf.Action(forwards = { @Jpf.Forward(name = "default", path = "accountActivityHistory.jsp")})
	public Forward printerFriendlyAAHView() {
		return new Forward("default");
	}

	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success", path = "accountActivityHistory.jsp")
	})
	@Override
	public Forward handlePagingAndSorting() {
		return super.handlePagingAndSorting();
	}

    @Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "accountActivityHistory.jsp")})
    public Forward returnToViewAction(){
		return new Forward("success");
	}
    
	@Override
	protected final EntityCollectionServiceResponse lookupEntities() {
		AccountActivityCriteriaForm form = getDefaultCriteria();
		return ServiceDelegateFactory.createActivityAuditServiceDelegate().getActivitiesForSubject(currentUserProfile.getId(),form.getActivityPerformerType(),new Timestamp(form.getFromDate().getTime()), new Timestamp(form.getToDate().getTime()));
	}
	
	//JAZZ#112876 - US#9 Admin Portal Enhancements - Admin Portal User Activity Log
	//*************************** END *******************************************

	@Override
	protected final Class getTransferObjectClass() {
		return Activity.class;
	}

	@Override
	protected final String getEntityName() {
		return Activity.ENTITY;
	}

	@Override
	protected final Long getCurrentUserId() {
		if(currentUserProfile == null){
			currentUserProfile = new UserProfileDecorator(getCurrentUser());
		}
		return (currentUserProfile != null) ? currentUserProfile.getId() : null;
	}

	/**
     * Specifies the UID of the table.
     * This is used to initialize paging setting.
     * Must match the value of the uid attribute of display:table
     * <pre>
     *    &lt;diplay-table uid="${pageFlow.tableUID}" .... &gt;
     *</pre>
     * or
     * <pre>
     *    &lt;diplay-table uid="${pageFlow.paging.tableUID}" .... &gt;
     *</pre>
     * @return The UID of the table.
     */
    public String getTableUID(){
    	return "accountActivity";
    }

    @Override
	protected final String getTableSessionKey() {
		return TABLE_SESSION_KEY;
	}

    @Override
	public SortOrderEnum getDefaultSortOrder() {
		return SortOrderEnum.DESCENDING;
	}

	@Override
	public Integer getDefaultSortProperty() {
		return 1;
	}
    public List getPerformedByOptions() {
    	List performerTypes = AccountActivityCriteriaForm.getActivityPerformerTypeLabels();
    	List updatedPerformerTypes = new ArrayList();
    	for (Object object : performerTypes) {
			if(object.toString().equals("Everyone But Self")) {
				updatedPerformerTypes.add("Everyone But User");
			} else if(object.toString().equals("Self")) {
				updatedPerformerTypes.add("User");
			} else {
				updatedPerformerTypes.add(object);
			}
		}
    	
    	return updatedPerformerTypes;
    }

    public UserProfile getCurrentUser(){
    	UserProfileServiceDelegate sd = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate();
    	UserProfileServiceResponse response = sd.getProfileForUser(selectedProfile.getUserName());
    	handleMessages(response);
    	return response.getUserProfile();
    }

    public ActivityDetailDecorator getCurrentActivity(){
    	return this.currentActivity;
    }
	
    /*
	 * 	Jazz # 128619 - Admin Portal Enhancement - Remove Correlation in MVI
     */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward removeCorrelationInMVI(InPersonAuthenticationForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse mviSyncServiceResponse =
			mviSyncServiceDelegate.removeCorrelationInMVI(patient, selectedProfile, "");

		patient = mviSyncServiceResponse.getPatient();
        handleMessages(mviSyncServiceResponse);
		//updateCorrrelationFields(patient);
		//CodeCR  Admin Portal_CodeCR2060 - Make sure that deactivate button displays after uncorrelate
		//determineActivationButtonDisplay(patient);
		//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk
		//determineDisplayProfileUpdateButtonDisplay(patient);
		
		forward = determineForward();
		return forward;
	}
    
    
    /*
	 * 	MHV_CodeCR1919 - US12.4.x MVI Compliance Implementation - Uncorrelate call from Helpdesk
     */
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
	public Forward syncUncorrelate(InPersonAuthenticationForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);
		MviIntegrationServiceDelegate mviSyncServiceDelegate = ServiceDelegateFactory.createMviIntegrationServiceDelegate();
		PatientServiceResponse mviSyncServiceResponse =
			mviSyncServiceDelegate.deletePersonFromCorrelationForHelpDesk(patient, selectedProfile, "");

		patient = mviSyncServiceResponse.getPatient();
		//JAZZ:18079 - Made sure that all the fields are refreshed.
		if(patient != null) {
			selectedProfile = patient.getUserProfile();
			//JAZZ:18073 - Made sure that Match Status is updated.
			if(patient.getMatchedDateTime() != null) {
				setMatchingStatus("Matched");
				setMatchingDate(new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
			} else {
				setMatchingStatus("Unmatched");
				setMatchingDate("");
			}

			if(patient.getIcn() != null) {
				setIcn(patient.getIcn());
			} else {
				setIcn("");
			}

			//JAZZ:18079 - Made sure that account status is refreshed.
			Boolean isPatientAuthenticated = false;
	    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    		isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
    		if (patient.getMatchedDateTime() == null){
    			setAccountStatus(AccountStatusEnumeration.BASIC);
    		} else if(isPatientAuthenticated != null) {
    			if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
        			setAccountStatus(AccountStatusEnumeration.PREMIUM);
    			else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
        			setAccountStatus(AccountStatusEnumeration.ADVANCED);
        		else if(!isPatientAuthenticated && patient.getMatchedDateTime() != null)
        			setAccountStatus(AccountStatusEnumeration.ADVANCED);
    		}else{
    			setAccountStatus(AccountStatusEnumeration.ADVANCED);
    		}
		}
    	else {
			setAccountStatus(AccountStatusEnumeration.BASIC);
    	}


        handleMessages(mviSyncServiceResponse);
		updateCorrrelationFields(patient);
		//CodeCR  Admin Portal_CodeCR2060 - Make sure that deactivate button displays after uncorrelate
		determineActivationButtonDisplay(patient);
		//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk
		determineDisplayProfileUpdateButtonDisplay(patient);
		
		forward = determineForward();
		return forward;
	}

    /**
     * @jpf:action
	 * @jpf:validation-error-forward name="failure" return-to="currentPage"
	 * @jpf:forward name="success" path="searchResult.jsp"
     */

    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "searchResult.jsp")
    },
    validationErrorForward = @Jpf.Forward(name = "failure", path = "search.jsp"))
    protected Forward search(UserProfileForm form)
    {
    	if(form.getIcn()!=null && form.getIcn().trim().length()>0) {
    		String icn = form.getIcn().toLowerCase();
    		icn = icn.trim();
    		
        	PatientCollectionServiceResponse pResponse = 
				ServiceDelegateFactory.createPatientServiceDelegate().getPatientByPartialIcn(icn.trim());
    		Collection patients = pResponse.getEntities();
            List<UserProfile> userProfiles = new ArrayList<UserProfile>();
           
            getSession().removeAttribute( "userProfiles" );
            if (patients.size() > 0) {
                for (Iterator iterator = patients.iterator(); iterator.hasNext();) {
    				Patient patient = (Patient) iterator.next();
    				userProfiles.add(patient.getUserProfile());
    			}
                getSession().setAttribute( "userProfiles", userProfiles );
            } else {
            	if(!pResponse.getMessages().hasErrorMessages()) {
            		pResponse.getMessages().addMessage(MessageUtils.createInformationalMessage(
	            	"no.users.found", null, null));
            	}
	            handleMessages(pResponse);
            }
            return userProfiles.isEmpty() ? new Forward(PageFlowControllerConstants.FORWARD_FAILURE) : determineForward();
    	}
    	
    	//MHV_CodeCR1387 - Added last name and ssn in the search
    	String lastName = null;
    	String ssn = null;
    	if(form.getFirstPlusFour() != null && form.getFirstPlusFour().length() > 0) {

    		String firstPlusFour = form.getFirstPlusFour();
    		lastName = form.getFirstPlusFour().substring(0, 1);
    		ssn = form.getFirstPlusFour().substring(1);
    	} else {
    		lastName = form.getUserProfileLastName();
    		ssn = form.getUserProfileSsn();
    	}

		if(ssn == null || ssn.length()==0) {
			StringBuffer ssnBuf = new StringBuffer(10);
			String ssn1 = StringUtils.isBlank(form.getSsn1()) ? "" : form.getSsn1();
			ssnBuf.append(ssn1);

			if(!StringUtils.isBlank(form.getSsn2())){
				if(!StringUtils.isBlank(form.getSsn1())){
					ssnBuf.append("-");
				}
				ssnBuf.append(form.getSsn2());
			}
			if(!StringUtils.isBlank(form.getSsn3())){
				if(!StringUtils.isBlank(form.getSsn2()) || (StringUtils.isBlank(
						form.getSsn2()) && !StringUtils.isBlank(form.getSsn1())))
	            {
					ssnBuf.append("-");
				}
				ssnBuf.append(form.getSsn3());
			}

			ssn = ssnBuf.toString();
		}

    	Date birthDate = CalendarUtils.getDate(form.getUserProfileBirthDateMonth(), form.getUserProfileBirthDateDay(), form.getUserProfileBirthDateYear());
        UserProfileCollectionServiceResponse response = ServiceDelegateFactory.createUserProfileServiceDelegate().searchUser(
			form.getMhvId(),
			form.getUserProfileFirstName(),
			lastName,
            form.getUserProfileContactInfoEmail(),
            form.getUserName(),
            ssn,
            birthDate);
        userProfiles = response.getUserProfiles();
        handleMessages(response);

        getSession().removeAttribute( "userProfiles" );
        getSession().setAttribute( "userProfiles", userProfiles );

        return userProfiles.isEmpty() ? new Forward(PageFlowControllerConstants.FORWARD_FAILURE) : determineForward();
    }
/*
	@Jpf.Action(forwards = {@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
    protected Forward deactivateUser(UserProfileForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);

		UserProfileDeactivationReason reason = UserProfileDeactivationUtils.findReason(form.getDeactivateReason());

		//If the patient is null, just deactivate user profile.
		if(patient == null) {
			VoidServiceResponse response = ServiceDelegateFactory.createUserProfileServiceDelegate().changeActivationState(
				selectedProfile, reason, UserProfileDeactivationUtils.STATE_CHANGED_BY_SYSTEM, form.getDeactivateNote());
	        handleMessages(response);
			if(!response.getMessages().hasErrorMessages()) {
				setDisplayDeactivateButton(false);
			}
		} else {
			PatientServiceResponse response =
				ServiceDelegateFactory.createPatientServiceDelegate().invalidatePatientInHelpDesk(
					patient, null, reason, form.getDeactivateNote());
			handleMessages(response);
	        patient = response.getPatient();

	        if(patient != null) {
				selectedProfile = patient.getUserProfile();
			}

			if(!response.getMessages().hasErrorMessages()) {
				setDisplayDeactivateButton(false);
			} else {
				setDisplayDeactivateButton(true);
			}
		}

		updateCorrrelationFields(patient);

		forward = determineForward();
		return forward;
    }

	@Jpf.Action(forwards = {@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage),
        @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}
    )
    protected Forward reactivateUser(UserProfileForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);

		UserProfileDeactivationReason reason = UserProfileDeactivationUtils.findReason(form.getDeactivateReason());

		//If the patient is null, just deactivate user profile.
		if(patient == null) {
			VoidServiceResponse response = ServiceDelegateFactory.createUserProfileServiceDelegate().reactivateUserInHelpDesk(
				selectedProfile, reason, UserProfileDeactivationUtils.STATE_CHANGED_BY_SYSTEM, form.getDeactivateNote());
	        handleMessages(response);
			if(!response.getMessages().hasErrorMessages()) {
				setDisplayReactivateButton(false);
			}
		} else {
			PatientServiceResponse response =
				ServiceDelegateFactory.createPatientServiceDelegate().reactivatePatientInHelpDesk(
					patient, null, reason, form.getDeactivateNote());
			handleMessages(response);
	        patient = response.getPatient();
			if(patient != null) {
				selectedProfile = patient.getUserProfile();
			}

			if(!response.getMessages().hasErrorMessages()) {
				setDisplayReactivateButton(false);
			} else {
				setDisplayReactivateButton(true);
			}
		}

		updateCorrrelationFields(patient);

		forward = determineForward();
		return forward;
    }
*/
    
	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Basic Search Pages Impl
    private InPersonAuthentication getIPA(Patient patient) {
        return ServiceDelegateFactory.
            createInPersonAuthenticationServiceDelegate().
            getAuthenticationForPatient(patient.getId()).getInPersonAuthentication();
    }
    
	@Jpf.Action(forwards = {
		@Jpf.Forward(name = "success",
			navigateTo = Jpf.NavigateTo.currentPage)
    }, validationErrorForward = @Jpf.Forward(name = "failure",
            navigateTo = Jpf.NavigateTo.currentPage))
    protected Forward deactivateUser(DeactivateUserForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);
		UserProfileDeactivationReason reason = null;
		String adminNetworkId = "System";
		VoidServiceResponse response = new VoidServiceResponse();
		if(form.getDeactivateReason()!=null) {
			reason = UserProfileDeactivationUtils.findReason(form.getDeactivateReason());
		}

		Date birthDate = null;
		if(this.getSelectedProfile().getBirthDate() != null) {
			birthDate = this.getSelectedProfile().getBirthDate();
			selectedProfile.setBirthDate(birthDate);
			form.setUserProfileBirthDateMonth(CalendarUtils.getMonth(birthDate));
			form.setUserProfileBirthDateDay(CalendarUtils.getDay(birthDate));
			form.setUserProfileBirthDateYear(CalendarUtils.getYear(birthDate));

		}
		Calendar today = Calendar.getInstance();
		Date now = today.getTime();
		Date deathDate = null;
		if(form.getUserProfileDeathDateMonth() != null && form.getUserProfileDeathDateDay() != null && form.getUserProfileDeathDateYear() != null) {
			deathDate = CalendarUtils.getDate(form.getUserProfileDeathDateMonth(), form.getUserProfileDeathDateDay(), form.getUserProfileDeathDateYear());
		}
		if(deathDate != null) {
			if(deathDate.after(now) || deathDate.before(birthDate)) {
				Message msg = null;
				Message msg1 = null;
				Message msg2 = null;
				if (deathDate == null) {
					if(form.getUserProfileDeathDateDay() == null) {
						msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.deathdate.day", null, new Object[] {getFullName()});
					}
					if (form.getUserProfileDeathDateMonth() == null) {
						msg1 = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.deathdate.month", null, new Object[] {getFullName()});
					}
					if (form.getUserProfileDeathDateYear() == null) {
						msg2 = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.deathdate.year", null, new Object[] {getFullName()});
					}
				} else if (deathDate.before(birthDate)) {
					msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.deathdate.before.birthdate", null, new Object[] {getFullName()});
				} else {
					msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.deathdate", null, new Object[] {getFullName()});
				}
				deathDate = null;
				setDisplayDeactivateButton(true);
				if(msg != null) {
					response.getMessages().addMessage(msg);
				}
				if(msg1 != null) {
					response.getMessages().addMessage(msg1);
				}
				if(msg2 != null) {
					response.getMessages().addMessage(msg2);
				}
	            handleMessages(response);
			}
		} else {
			setDisplayDeactivateButton(false);
			selectedProfile.setDeathDate(deathDate);
			selectedProfile.setDeactivationReason(reason);
			form.copyFrom(selectedProfile);

			if(getRequest().getUserPrincipal()!=null) {
				adminNetworkId = getRequest().getUserPrincipal().getName();
			}
		}
		if(!response.getMessages().hasInformationalMessages()) {
			//If the patient is null, just deactivate user profile.
			if(patient == null) {
				response = ServiceDelegateFactory.createUserProfileServiceDelegate().changeActivationState(
					selectedProfile, reason, adminNetworkId, form.getDeactivateNote(), deathDate);
				if(!response.getMessages().hasErrorMessages() && !response.getMessages().hasInformationalMessages()) {
					setDisplayDeactivateButton(false);
		            //JAZZ:19556 - Make sure that user profile info is refreshed.
					selectedProfile = ServiceDelegateFactory.createUserProfileServiceDelegate().getUserProfileById(
							selectedProfile.getId()).getUserProfile();
	
					Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.invalidate.success", null, new Object[] {getFullName()});
		            response.getMessages().addMessage(msg);
				} else {
					setDisplayDeactivateButton(true);
		            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.invalidate.fail", null, new Object[] {getFullName()});
		            response = new VoidServiceResponse();
		            response.getMessages().addMessage(msg);
				}
		        handleMessages(response);
			} else {
				//JAZZ#112876 - US#4 Admin Portal Enhancements - Force Deactivation
				InPersonAuthentication ipa = getIPA(patient);
				if(ipa != null) {
					InPersonAuthenticationServiceDelegate del = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
					InPersonAuthenticationServiceResponse ipaResponse = del.forceUnauthenticateUnCorrelate(ipa);
					ipa = ipaResponse.getInPersonAuthentication();
					patient = ipa.getPatient();
					selectedProfile = patient.getUserProfile();
				}
				PatientServiceResponse patientResponse =
					ServiceDelegateFactory.createPatientServiceDelegate().deactivatePatientInHelpDesk(
						patient, null, adminNetworkId, reason, form.getDeactivateNote(), deathDate);
		        patient = patientResponse.getPatient();
		        
		        if(patient != null) {
					selectedProfile = patient.getUserProfile();
					icn = patient.getIcn();
	
					//JAZZ:18073 - Made sure that Match Status is updated.
					if(patient.getMatchedDateTime() != null) {
						setMatchingStatus("Matched");
						setMatchingDate(new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
					} else {
						setMatchingStatus("Unmatched");
						setMatchingDate("");
					}
				}
				if(!patientResponse.getMessages().hasErrorMessages()&& !patientResponse.getMessages().hasInformationalMessages()) {
		            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.invalidate.success", null, new Object[] {getFullName()});
		            patientResponse.getMessages().addMessage(msg);
					setDisplayDeactivateButton(false);
				} else {
					setDisplayDeactivateButton(true);
		            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.invalidate.fail", null, new Object[] {getFullName()});
		            patientResponse = new PatientServiceResponse();
		            patientResponse.getMessages().addMessage(msg);
				}
				handleMessages(patientResponse);
			}
		}
		
		updateCorrrelationFields(patient);
		determineDeactivationFields();
		form.setRelationshipToVA(determineRelationshipToVA());
		determineAccountStatus(patient);
		
		forward = determineForward();
		return forward;
    }

	public String getFullName() {
		String firstName = selectedProfile.getFirstName();
		String middleName = selectedProfile.getMiddleName();
		String lastName = selectedProfile.getLastName();

		StringBuffer buff = new StringBuffer();
		buff.append(firstName);
		if (middleName != null) {
			buff.append(' ');
			buff.append(middleName);
		}
		buff.append(' ');
		buff.append(lastName);

		return(buff.toString());
	}


	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
				navigateTo = Jpf.NavigateTo.currentPage)
	    }, validationErrorForward = @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage))
    protected Forward reactivateUser(ReactivateUserForm form) {
		Forward forward = null;
		Patient patient = getPatient(selectedProfile);
		selectedProfile.setDeathDate(null);
        form.copyFrom(selectedProfile);
		UserProfileDeactivationReason reason = null;

		if(form.getReactivateReason()!=null) {
			reason = UserProfileDeactivationUtils.findReason(form.getReactivateReason());
		}

		String adminNetworkId = "System";
		if(getRequest().getUserPrincipal()!=null) {
			adminNetworkId = getRequest().getUserPrincipal().getName();
		}

		//If the patient is null, just deactivate user profile.
		if(patient == null) {
			VoidServiceResponse response = ServiceDelegateFactory.createUserProfileServiceDelegate().reactivateUserInHelpDesk(
				selectedProfile, reason, adminNetworkId, form.getReactivateNote());
			if(!response.getMessages().hasErrorMessages()) {
				setDisplayReactivateButton(false);

	            //JAZZ:19556 - Make sure that user profile info is refreshed.
				selectedProfile =
					ServiceDelegateFactory.createUserProfileServiceDelegate().getUserProfileById(
						selectedProfile.getId()).getUserProfile();

				Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.success", null, new Object[] {getFullName()});
	            response.getMessages().addMessage(msg);
			} else {
				setDisplayReactivateButton(true);
	            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.fail", null, new Object[] {getFullName()});
	            response = new VoidServiceResponse();
	            response.getMessages().addMessage(msg);
			}
	        handleMessages(response);
		} else {
			PatientServiceResponse response =
				ServiceDelegateFactory.createPatientServiceDelegate().getPatientByIcn(patient.getInvalidatedIcn());

			if(response.getPatient() != null) {
	            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.error.icn.exists", null, new Object[] {getFullName()});
	            response.getMessages().addMessage(msg);
				setDisplayReactivateButton(false);
			} else {
				//Admin Portal_CodeCR2064 AdminPortal - Make sure to include adminNetwork Id so that react happens.
				response = ServiceDelegateFactory.createPatientServiceDelegate().reactivatePatientInHelpDesk(
					patient, adminNetworkId, reason, form.getReactivateNote());
		        patient = response.getPatient();
				if(patient != null) {
					selectedProfile =
						ServiceDelegateFactory.createUserProfileServiceDelegate().getUserProfileById(
							selectedProfile.getId()).getUserProfile();
					icn = patient.getIcn();

					//JAZZ:18073 - Made sure that Match Status is updated.
					if(patient.getMatchedDateTime() != null) {
						setMatchingStatus("Matched");
						setMatchingDate(new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
					} else {
						setMatchingStatus("Unmatched");
						setMatchingDate("");
					}
				}

				if(!response.getMessages().hasErrorMessages()) {
		            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.success", null, new Object[] {getFullName()});
		            response.getMessages().addMessage(msg);
					setDisplayReactivateButton(false);
				} else {
					setDisplayReactivateButton(true);
		            Message msg = MessageUtils.createInformationalMessage("mvi.helpdesk.revalidate.fail", null, new Object[] {getFullName()});
		            response = new PatientServiceResponse();
		            response.getMessages().addMessage(msg);
				}
			}
			handleMessages(response);
		}

		updateCorrrelationFields(patient);
		determineDeactivationFields();
		form.setRelationshipToVA(determineRelationshipToVA());

		forward = determineForward();
		return forward;
    }

	private void resetValues() {
		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected.
	    email = "";
	    correlationStatus = "";
	    correlationRequestDateTime = "";
	    correlationDateTime = "";
	    correlationPeformedBy = "";
	    matchingStatus = "";
	    accountStatus = "";
	    createdDate = "";
	    icn = "";
	    mviAuthenticationStatus = "";
	}

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="viewSelectedUser.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "viewSelectedUser.jsp")
    })
	public Forward backToSelectedUser(UserProfileForm form){
    	resetValues();
        populateSelectedUserFields(form);
		return new Forward("success");
	}
	
    /**
     * @jpf:action
	 * @jpf:forward name="success" path="viewSelectedUser.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "viewSelectedUser.jsp")
    })
    protected Forward selectUser(UserProfileForm form)
    {
		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected.
    	resetValues();
        Long id = new Long(getRequest().getParameter("id"));
        UserProfileServiceResponse response = ServiceDelegateFactory.createEntityMaintenanceServiceDelegate().findByPrimaryKey(new UserProfilePK(id));
        selectedProfile = response.getUserProfile();
        handleMessages(response);
        
        populateSelectedUserFields(form);

        return determineForward();
    }
    
    private void populateSelectedUserFields(UserProfileForm form) {
        form.copyFrom(selectedProfile);

        //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
        if(selectedProfile.getFccxDate() != null) {
        	form.setUserProfilePasswordHintQuestion1("");
        	form.setUserProfilePasswordHintQuestion2("");
        	form.setUserProfilePasswordHintAnswer1("");
        	form.setUserProfilePasswordHintAnswer2("");
        }
        
    	//MHV_CodeCR1387 - Added relationship to VA in search detail page.
        form.setRelationshipToVA(determineRelationshipToVA());
        
		//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
		setMatchingStatus("Unmatched");
		setMatchingDate("");
		Patient patient = getPatient(selectedProfile);
		updateCorrrelationFields(patient);

	    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
		determineDeactivationFields();
		determineDisplayProfileUpdateButtonDisplay(patient);
		determineActivationButtonDisplay(patient);
		determineAccountStatus(patient);
        //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
		determineGeneratePasswordButton();
    }
    
    private void determineGeneratePasswordButton() {
        //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
        if(selectedProfile.getUserName() == null || selectedProfile.getUserName().length()==0) {
        	setDisplayGeneratePasswordButton(false);
        } else {
        	setDisplayGeneratePasswordButton(true);
        }
    	
    }
    
    private void determineAccountStatus(Patient patient) {
		if(patient != null) {
			if(patient.getIcn() != null) {
				setIcn(patient.getIcn());
			} else {
				setIcn("");
			}

			if(patient.getMatchedDateTime() != null) {
				setMatchingStatus("Matched");
				setMatchingDate(new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
			}

			Boolean isPatientAuthenticated = false;
	    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    		isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
    		if (patient.getMatchedDateTime() == null){
    			setAccountStatus(AccountStatusEnumeration.BASIC);
    		} else if(isPatientAuthenticated != null) {
    			if(isPatientAuthenticated && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
        			setAccountStatus(AccountStatusEnumeration.PREMIUM);
    			else if(isPatientAuthenticated && !patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))
        			setAccountStatus(AccountStatusEnumeration.ADVANCED);
        		else if(!isPatientAuthenticated && patient.getMatchedDateTime() != null)
        			setAccountStatus(AccountStatusEnumeration.ADVANCED);
    		}else{
    			setAccountStatus(AccountStatusEnumeration.ADVANCED);
    		}
		}
    	else {
			setAccountStatus(AccountStatusEnumeration.BASIC);
    	}
    }
    
    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
    private void determineDeactivationFields() {
    	deactivated = "No";
    	deactivatedReason = "";
    	deactivatedDescription = "";

    	UserProfileDeactivationAuditCollectionServiceResponse response =
    		ServiceDelegateFactory.createUserProfileServiceDelegate().findDeactivationAudits(selectedProfile);

    	Iterator<UserProfileDeactivationAudit> iter = response.getItems().iterator();
    	if(iter.hasNext()) {
    		UserProfileDeactivationAudit upda = iter.next();
    		//upda.getAction() UserProfileActivationStateUtils.DEACTIVATED
    		if(selectedProfile.getDeactivationReason()!=null) {
    			deactivated = "Yes";
    		}

    		deactivatedReason = upda.getDeactivationReason().getName();
    		deactivatedDescription = upda.getNotes();
    	}

    }

	//JAZZ 113572 - Update User Profile in Admin Portal HelpDesk
    private void determineDisplayProfileUpdateButtonDisplay(Patient patient) {
		if(patient!=null && (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED))&&
			(patient.getMatchedDateTime()!=null)) {
			setDisplayProfileUpdateButton(true);
		} else {
			setDisplayProfileUpdateButton(false);
		}
    }
    
    private void determineActivationButtonDisplay(Patient patient) {
		Boolean isPatientAuthenticated = false;
		InPersonAuthentication ipa = null;

		if(patient !=null) {
	    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
			ipa = delegate.getIPAPatientById(patient.getId()).getInPersonAuthentication();
	    	isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
		}

		//if it is not patient, and and account is active
		//show deactivate button.
		//check if the correlation status is null
		if((patient == null) && (selectedProfile.getDeactivationReason() == null) &&
		   (getDisplayUncorrelateButton()==null || !getDisplayUncorrelateButton())) {
			setDisplayDeactivateButton(true);
		} else if((isPatientAuthenticated == null || !isPatientAuthenticated) &&
		   (ipa != null && (ipa.getMviAuthenticationStatus()==null||ipa.getMviAuthenticationStatus().equals("")||
			ipa.getMviAuthenticationStatus().equals("OK"))) &&
		   ((patient.getCorrelationStatus()==null) || (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.UNCORRELATED)) ||
		    (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.MVI_DATA_MATCH))) &&
		    selectedProfile.getDeactivationReason() == null &&
		    (!getDisplayUncorrelateButton())) {
			setDisplayDeactivateButton(true);
		} else {
			setDisplayDeactivateButton(false);
		}
		//Admin Portal_CodeCR2061 - Make sure that Correlate Button displays for MVI Data Match status
		//JAZZ:19556 - Make sure that user profile info is refreshed. And took care of null exception
		if(patient == null && selectedProfile.getDeactivationReason() != null &&
			(getDisplayUncorrelateButton() == null ||!getDisplayUncorrelateButton())) {
			setDisplayReactivateButton(true);
		} else if((patient!=null && (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.UNCORRELATED)||
				  (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.MVI_DATA_MATCH)))) &&
		    selectedProfile.getDeactivationReason() != null && (!getDisplayUncorrelateButton())) {
			setDisplayReactivateButton(true);
		} else {
			setDisplayReactivateButton(false);
		}
		
		if(selectedProfile.getDeactivationReason() != null) {
			setDisplayForceDeactivateButton(false);
		} else {
			if(!getDisplayDeactivateButton()) {
				setDisplayForceDeactivateButton(true);
			}
		}
		
	    //JAZZ# 128619 - Admin Portal Enhancements - Remove Correlation in MVI
		if((patient != null && patient.getIcn()!=null) &&(isPatientAuthenticated == null || !isPatientAuthenticated) && 
		   (getDisplayUncorrelateButton() == null ||!getDisplayUncorrelateButton())) {
			setDisplayRemoveCorrelationInMVIButton(true);
		} else {
			setDisplayRemoveCorrelationInMVIButton(false);
		}
    }

    private void updateCorrrelationFields(Patient patient) {
		if(patient != null) {
			if(patient.getCorrelationStatus() != null) {
				setCorrelationStatus(patient.getCorrelationStatus().getName());
				//Admin Portal_CodeCR1846 - Formatted the statuses.
				if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.UNCORRELATED)) {
					setCorrelationStatus("Uncorrelated");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGCORRELATION)) {
					setCorrelationStatus("Pending Correlation");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.PENDINGUNCORRELATION)) {
					setCorrelationStatus("Pending Uncorrelation");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATED)) {
					setCorrelationStatus("Correlated");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.CORRELATIONINVALID)) {
					setCorrelationStatus("Correlation Invalid");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDCORRELATION)) {
					setCorrelationStatus("Failed Correlation");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.FAILEDUNCORRELATION)) {
					setCorrelationStatus("Failed Uncorrelation");
				} else if(patient.getCorrelationStatus() == PatientCorrelationStatus.getEnum(PatientCorrelationStatus.MVIDATAMATCH)) {
					setCorrelationStatus("Uncorrelated");
				}
			} else {
				setCorrelationStatus("");
			}

			if(patient.getCorrelatedDateTime() != null) {
				setCorrelationDateTime(new SimpleDateFormat(TIME_FORMAT).format(patient.getCorrelatedDateTime()));
			} else {
				setCorrelationDateTime("");
			}

			if(patient.getCorrelateRequestDateTime() != null) {
				setCorrelationRequestDateTime(new SimpleDateFormat(TIME_FORMAT).format(patient.getCorrelateRequestDateTime()));
			} else {
				setCorrelationRequestDateTime("");
			}

			if(patient.getCorrelatedBy() != null) {
				setCorrelationPeformedBy(patient.getCorrelatedBy());
			} else {
				setCorrelationPeformedBy("");
			}

			Boolean isPatientAuthenticated = false;
	    	InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();
    		isPatientAuthenticated = delegate.isPatientAuthenticated(patient.getId()).getBoolean();

			//MHV_CodeCR1919 - US12.4.x MVI Compliance Implementation - Adding Uncorrelate Button Field.
    		InPersonAuthentication ipa = delegate.getIPAPatientById(patient.getId()).getInPersonAuthentication();

    		//MHV_CodeCRTBD - US12.4.1 MVI Compliance Implementation - Make sure that the user that is correlated but not yet authenticated
    		//will have uncorrelate button.
    		if((isPatientAuthenticated == null || !isPatientAuthenticated) &&
    		   (ipa != null && (ipa.getMviAuthenticationStatus()==null||ipa.getMviAuthenticationStatus().equals("")||ipa.getMviAuthenticationStatus().equals("OK"))) &&
    		   (patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.CORRELATED)||
    			patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.PENDING_CORRELATION)||
    			//JAZZ 18076: Show Uncorrate button for failed uncorrelation status in Help Desk.
    			patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.FAILED_UNCORRELATION)||
    			patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.PENDING_UNCORRELATION)) &&
    		    selectedProfile.getDeactivationReason() == null) {
    			setDisplayUncorrelateButton(true);
    		} else {
    			setDisplayUncorrelateButton(false);
    		}

			mviAuthenticationStatus = "";
    		if(ipa != null && ipa.getMviAuthenticationStatus() != null) {
    			if(ipa.getMviAuthenticationStatus().equals("OK")) {
    				mviAuthenticationStatus = "Successful";
    			} else if(ipa.getMviAuthenticationStatus().equals("PENDING_AUTH")) {
    				mviAuthenticationStatus = "Authentication Unsuccessful";
    			} else if(ipa.getMviAuthenticationStatus().equals("PENDING_UNAUTH")) {
    				mviAuthenticationStatus = "Unauthentication Unsuccessful";
    			}
    		}

		}
    }

	//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields
    private Patient getPatient(UserProfile userProfile) {
        PatientServiceResponse pResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(userProfile);
	    return pResponse.getPatient();
    }

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="verifyUserAccountInfo.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "verifyUserAccountInfo.jsp")
    })
    protected Forward setupVerifyAccountInfo(UserProfileForm form)
    {
        form.copyFrom(selectedProfile);
        return determineForward();
    }

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="verifyUserAccountInfo.jsp"
	 * JAZZ#112876 - US#4 Admin Portal Enhancements - Force Deactivation
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "verifyUserProfileDeactivate.jsp")
    })
    protected Forward verifyUserProfileForceDeactivate(DeactivateUserForm form) {
        //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
        if(selectedProfile.getUserName() == null || selectedProfile.getUserName().length()==0) {
        	form.setUserProfilePasswordHintQuestion1("");
        	form.setUserProfilePasswordHintQuestion2("");
        	form.setUserProfilePasswordHintAnswer1("");
        	form.setUserProfilePasswordHintAnswer2("");
        }
        
    	PatientServiceResponse pResponse = new PatientServiceResponse();
    	pResponse.getMessages().addMessage(MessageUtils.createInformationalMessage(
        	"force.deactivate", null, null));
        handleMessages(pResponse);

    	return verifyUserProfileDeactivate(form);
    }

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="verifyUserAccountInfo.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "verifyUserProfileDeactivate.jsp")
    })
    protected Forward verifyUserProfileDeactivate(DeactivateUserForm form)
    {
        form.copyFrom(selectedProfile);
        form.setRelationshipToVA(determineRelationshipToVA());

	    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
		determineDeactivationFields();

        setDisplayDeactivateButton(true);
        return determineForward();
    }

    private String determineRelationshipToVA() {
		StringBuffer relationshipToVA = new StringBuffer("");
		if(selectedProfile.getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if(selectedProfile.getIsVeteran()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if(selectedProfile.getIsHealthCareProvider()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if(selectedProfile.getIsPatientAdvocate()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if(selectedProfile.getIsEmployee()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if(selectedProfile.getIsOther()) {
			if(relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}
    	return relationshipToVA.toString();
    }

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="verifyUserAccountInfo.jsp"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "verifyUserProfileReactivate.jsp")
    })
    protected Forward verifyUserProfileReactivate(ReactivateUserForm form)
    {
        //JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
        if(selectedProfile.getUserName() == null || selectedProfile.getUserName().length()==0) {
        	form.setUserProfilePasswordHintQuestion1("");
        	form.setUserProfilePasswordHintQuestion2("");
        	form.setUserProfilePasswordHintAnswer1("");
        	form.setUserProfilePasswordHintAnswer2("");
        }
        
        form.copyFrom(selectedProfile);
        form.setRelationshipToVA(determineRelationshipToVA());

	    //JAZZ: Task#20554 - Display reason and description for reactivation/deactivation in Help desk
		determineDeactivationFields();

        setDisplayReactivateButton(true);
        return determineForward();
    }

    /**
     * @jpf:action
	 * @jpf:forward name="success" path="sendPassword.jsp"
     * @jpf:validation-error-forward name="failure" return-to="currentPage"
     */
    @Jpf.Action(forwards = {
        @Jpf.Forward(name = "success",
                     path = "sendPassword.jsp")
    }, validationErrorForward = @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage))
    protected Forward verifyAccountInfo(UserProfileForm form)
    {
        form.copyFrom(selectedProfile);
        StringServiceResponse response = ServiceDelegateFactory.createUserServiceDelegate().generatePassword();
        generatedPassword = response.getString();

        String userName = selectedProfile.getUserName();

        VoidServiceResponse resetPWResponse = ServiceDelegateFactory.createUserServiceDelegate().resetPassword(
			userName, generatedPassword, generatedPassword, Boolean.TRUE);

        handleMessages(resetPWResponse);

        return determineForward();
    }

    /**
     * @jpf:action
	 * @jpf:validation-error-forward name="failure" return-to="currentPage"
	 * @jpf:forward name="success" path="confirmSentPassword.jsp"
     */
	@Jpf.Action(
		forwards = {
			@Jpf.Forward(name = "success", path = "confirmSentPassword.jsp")
		},
		validationErrorForward = @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)
	)
	protected Forward sendPassword(SendPasswordForm form) {
        // this code is also in ChangePasswordController.changePassword(ChangePasswordForm form)
        // This is supposed to be temporary and should be placed in UserServiceImpl as soon as user and usermgmt
        // are combined.  This cannot be added yet because it would cause a circular dependency between user and usermgmt.

        //send mail
        email = form.getTargetEmail();
        if( StringUtils.isBlank( email ) ) {
            email = ServiceDelegateFactory.createUserProfileServiceDelegate().getProfileForUser( selectedProfile.getUserName() ).getUserProfile().getContactInfoEmail();
        }

        // [TODO] Add the 9.2 equivalent of this logic
        /*
        EmailControlPropertiesDocument emailControlPropsDoc = emailControl.getProperties();
        EmailControlPropertiesDocument.EmailControlProperties emailControlProps = emailControlPropsDoc.getEmailControlProperties();
        String smtpHost = PROPS.getProperty("mail.smtp.host");
        emailControlProps.setSmtpAddress( smtpHost );
        emailControl.setProperties( emailControlPropsDoc );

        try {
            emailControl.sendEmail( email, null, null, SUBJECT, BODY + generatedPassword,  null );
        }
        catch (Exception e) {
        // TO-DO Handle more gracefully
            e.printStackTrace();
        }*/

		return determineForward();
	}

	// property accessors
	public Collection getUserProfiles() {
		return userProfiles;
	}

	public UserProfile getSelectedProfile() {
		return selectedProfile;
	}

	public String getGeneratedPassword() {
		return generatedPassword;
	}

    protected Class getFormClass()
    {
        return SendPasswordForm.class;
    }

    public Map getDayOptions() {
    	return CalendarUtils.getDays();
    }

    public Map getMonthOptions() {
    	return CalendarUtils.getMonths();
    }

    public List getYearOptions() {
    	List years = CalendarUtils.getYears();
    	if(!years.get(0).equals(CalendarUtils.getFirstYear()+"")){
    		Collections.reverse(years);
    	}
    	return years;
    }
}