package gov.va.med.mhv.usermgmt.portlet.ssooptout;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import gov.va.med.mhv.eauth.service.delegate.EAuthHashServiceDelegate;
import gov.va.med.mhv.eauth.transfer.EAuthHash;
import gov.va.med.mhv.usermgmt.service.EAuthHashCollectionServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.UserProfileServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.beehive.netui.pageflow.PageFlowController;
import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.beehive.netui.pageflow.scoping.ScopedServletUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.tigris.atlas.beehive.AbstractPageFlowController;
import org.tigris.atlas.beehive.EntityListMaintenancePageFlowController;
import org.tigris.atlas.service.EntityCollectionServiceResponse;
import org.tigris.atlas.service.EntityServiceResponse;
import org.tigris.atlas.service.ServiceFactory;
import org.tigris.atlas.service.StringServiceResponse;
import org.tigris.atlas.service.VoidServiceResponse;
import org.tigris.atlas.web.struts.InputForm;

import com.bea.portlet.PageURL;

// Substitute with this annotation if nested pageflow
// @Jpf.Controller( nested=true )

@Jpf.Controller()
public class SSOOptOutController extends EntityListMaintenancePageFlowController {
	
	private static Log LOG = LogFactory.getLog(SSOOptOutController.class);
	private static final long serialVersionUID = 1L;
	
	private UserProfile userProfile = null;
	
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", path = "disconnectAccount.jsp"),
							 @Jpf.Forward(name = "failure", path = "noGovtAccount.jsp")
				})
	public Forward begin() {
		getCurrentUserProfile();
		UserProfileServiceDelegate ufDelegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
 			// lookup userid in database
		EAuthHashCollectionServiceResponse eauthCollResp = ufDelegate.findEAuthByUserProfileId(userProfile.getId());
		Collection<gov.va.med.mhv.usermgmt.transfer.EAuthHash> eauthHashs = eauthCollResp.getEAuthHashs();
		if(eauthHashs.size() > 0) {
			return new Forward("success");
		}
		else {
			return new Forward("failure");
		}
        
	}

	@Jpf.Action(forwards = {
	        @Jpf.Forward(name = "success", path = "disconnectAccountConfirm.jsp"),
	        @Jpf.Forward(name = "failure", path = "disconnectAccountConfirm.jsp")
	    })
	public Forward removeGovtAccountConfirm() {
	return new Forward("success");
	}
	
	
	@Jpf.Action(forwards = {
		        @Jpf.Forward(name = "success", path = "successDiscAccount.jsp"),
		        @Jpf.Forward(name = "failure", path = "failedDiscAccount.jsp")
		    })
	public Forward removeGovtAccount() {
		getCurrentUserProfile();
		UserProfileServiceDelegate ufDelegate = ServiceDelegateFactory.createUserProfileServiceDelegate();
		ufDelegate.getProfileForUser(getCurrentUserName());
		VoidServiceResponse response = ufDelegate.deleteHashByUserProfileId(userProfile.getId());
		
		if(response.getMessages().hasErrorMessages()) {
			return new Forward("failure");
		}
		return new Forward("success");
//		return new Forward("failure");
	}

	protected final UserProfile getCurrentUserProfile() {
		if( userProfile == null ) {
			UserProfileServiceDelegate delegate = gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate();
			UserProfileServiceResponse response = delegate.getProfileForUser(getCurrentUserName());
			userProfile = response.getUserProfile();
		}
		return userProfile;
	}
	

	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.previousPage) })
    protected Forward cancelAction()
        throws Exception
    {
		PageURL url = PageURL.createPageURL(getRequest(), getResponse(), "personalInformation");
  	  	try{
	 	    this.getResponse().sendRedirect(url.toString());
		  }catch(Exception e){
	 	  	LOG.error("cancelAction in SSOOptOutController::Redirect URL failed");
		}
		  return null;
    }

	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.previousPage) })
    protected Forward cancelActionPrev()
        throws Exception
    {
		return new Forward("success");
    }	
	
	
	@Override
	protected String getTableSessionKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityCollectionServiceResponse lookupEntities() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityServiceResponse deleteEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected Long getCurrentUserId() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected String getEntityName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected Class getTransferObjectClass() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityServiceResponse lookupEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void populateEntity(InputForm arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void populateForm(InputForm arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected EntityServiceResponse saveEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setupNewEntity() {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected Class getFormClass() {
		// TODO Auto-generated method stub
		return null;
	}

}