package gov.va.med.mhv.usermgmt.portlet.termsAndConditions;


import javax.servlet.http.HttpSession;
import org.apache.beehive.netui.pageflow.annotations.Jpf;

import gov.va.med.mhv.usermgmt.util.Auditor;
import gov.va.med.mhv.usermgmt.util.DirectorUtil;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.form.LoginForm;
import gov.va.med.mhv.usermgmt.form.UserProfileForm;
import gov.va.med.mhv.usermgmt.service.delegate.UserProfileServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import javax.servlet.http.HttpSession;
import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.bea.p13n.security.Authentication;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;

import gov.va.med.mhv.usermgmt.portlet.constants.SessionAttributeConstants;
import gov.va.med.mhv.usermgmt.portlet.login.loginbase.LoginNavigateBaseController;



/**
 * @jpf:controller struts-merge="/WEB-INF/struts-override.xml"
 *  */

@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class TermsAndConditionsController extends LoginNavigateBaseController {
	
	private static final Log LOG = LogFactory.getLog(
		TermsAndConditionsController.class);
	
	private static final long serialVersionUID = -1P9O0R7T04L;
	private String lastModifiedTimeFormatted=null;
	private Timestamp lastModifiedTime;
	
	
	/*
	 * The first page in Terms and Conditions page flow portal where the user can view only the change in the terms and conditions.  
	 */
	
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "termsAndConditionsSummary.jsp")
	})
	public Forward begin()
	{
		lastModifiedTime=getTermsModifiedTime();
		if (getTermsModifiedTime()!=null){
			SimpleDateFormat auxFormatter = new SimpleDateFormat("MM/dd/yyyy");
			lastModifiedTimeFormatted=auxFormatter.format(this.lastModifiedTime);
		}
		return new Forward("success");

		 
	}
	
	
	//CR 1296 - Fixed Contact link
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "fullTermsAndConditions.jsp")
	})
	public Forward viewUpgradeMHVAccount()
	{
	   try{
	 	    this.getResponse().sendRedirect(this.getRequest().getContextPath()+"/anonymous.portal?_nfpb=true&_nfto=false&_pageLabel=newsHome&contentPage=ipa/ipa_instructions-anonymous.html");
	 	    	
	   }catch(Exception e){
	   }
	    
	   return null;

	}
	
	//CR 1296 - Fixed Contact link
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "fullTermsAndConditions.jsp")
	})
	public Forward viewContact()
	{
	   try{
	 	    this.getResponse().sendRedirect(this.getRequest().getContextPath()+"/anonymous.portal?_nfpb=true&_nfto=false&_pageLabel=contactMHVHome");
	 	    	
	   }catch(Exception e){
	   }
	   Forward forward = new Forward("success");
	   return forward;
	}
	
	
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "fullTermsAndConditions.jsp")
	})
	public Forward viewFullTermsAndConditions()
	{
		Forward forward = new Forward("success");

		return forward;
	}
	
	//this is a useless action, just a place holder
	//CR 1160 - Secured Message Terms and Conditions Implementation
	//Added userProfileForm as a parameter
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "index.jsp")
	})
	public Forward termsAndConditionsAction(UserProfileForm userProfileForm)
	{
		Forward forward = new Forward("success");

		return forward;
	}
	
	
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "termsAndConditionsRejectionWarning.jsp")
	})
	public Forward rejectFirstTime()
	{
		Forward forward = new Forward("success");

		return forward;
	}
	
	
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "index.jsp")
	})
	public Forward reject()
	{
		UserProfileServiceDelegate delegate=gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate();
		UserProfile profile=this.getCurrentUser();
		delegate.rejectTerms(profile,this.lastModifiedTime,new Timestamp(System.currentTimeMillis()));
		//	Audit the rejections of terms & conditions	
		Auditor.auditAcceptTermsEvent(profile.getId(),false,ActivityActorTypeEnumeration.SELF);
		Forward forward = new Forward("success");
		Authentication.logout( getRequest() );
        //switch desktops
	     
	    String path = DirectorUtil.getDefaultAnonymousPortalPage(getRequest(), getResponse());
	    if (path != null) {
	    	forward.setPath(path);
	    }

	    return forward ;

		
	}
	
	
	//this is a useless action, just a place holder
	//CR 1160 - Secured Message Terms and Conditions Implementation
	//Added userProfileForm as a parameter
	@Jpf.Action(forwards = {
			@Jpf.Forward(name = "success",
					path = "index.jsp")
	})
	public Forward accept(UserProfileForm userProfileForm)
	{
		UserProfileServiceDelegate delegate=gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate();
		UserProfile profile=this.getCurrentUser();
		
		//CR 1160 - Secured Message Terms and Conditions Implementation
		//Takes the user entry and save it in the userProfile
		profile.setAcceptSMTerms(new Boolean(userProfileForm.getUserProfileAcceptSMTerms()));
		profile.setAcceptTerms(new Boolean(true));
		
		delegate.acceptTerms(profile,this.lastModifiedTime,new Timestamp(System.currentTimeMillis()));
		Forward forward = new Forward("success");
		//Audit the acceptance of terms & conditions
		Auditor.auditAcceptTermsEvent(profile.getId(),true,ActivityActorTypeEnumeration.SELF);
		getRequest().getSession().setAttribute(SessionAttributeConstants.TERMS_ACCEPTED_FLAG,new Boolean(true));
		String redirectUrl = getRedirectUrl();
		
		if (LOG.isInfoEnabled()) {
			LOG.info("Redirecting to " + redirectUrl);
		}
		
		//CR 1160 - 2.12 setting the flag to show the T&C acceptance success message.
		getRequest().getSession().setAttribute("SHOW_TC_SUCCESS_MSG", new Boolean(true));
		forward.setPath(redirectUrl);
       	return forward;
	}
	
	
	/**
	 * Callback that is invoked when this controller instance is created.
	 */
	@Override
	protected void onCreate() {
	}
	
	/**
	 * Callback that is invoked when this controller instance is destroyed.
	 */
	@Override
	protected void onDestroy(HttpSession session) {
	}
	
	protected Class getFormClass() {
		return LoginForm.class;
	}
	
	
	public String getLastModifiedTimeFormatted() {
		return lastModifiedTimeFormatted;
	}
	
	
    
   
    
    
	
	
}