package gov.va.med.mhv.usermgmt.portlet.vetbenefithandbook;

import java.util.Date;
import java.util.Properties;
import java.net.HttpURLConnection;
import java.net.URL;
import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.tigris.atlas.beehive.EntityListMaintenancePageFlowController;
import org.tigris.atlas.service.EntityCollectionServiceResponse;
import org.tigris.atlas.service.EntityServiceResponse;
import org.tigris.atlas.web.struts.InputForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.InPersonAuthenticationServiceDelegate;
import org.apache.beehive.netui.pageflow.scoping.ScopedServletUtils;
import gov.va.med.mhv.eauth.EauthConstants;
import gov.va.med.mhv.eauth.service.delegate.EAuthHashServiceDelegate;
import gov.va.med.mhv.eauth.service.delegate.EAuthLogServiceDelegate;

import gov.va.med.mhv.usermgmt.enumeration.AccountStatusEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.AuthenticationStatus;

import gov.va.med.mhv.core.crypto.RSAEncrypt;
import gov.va.med.mhv.usermgmt.util.Auditor;
import org.tigris.atlas.config.ConfigurationManager;
import com.bea.portlet.PageURL;

// Substitute with this annotation if nested pageflow
// @Jpf.Controller( nested=true )

@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class VetBenefitHandbookController extends EntityListMaintenancePageFlowController {

    private static final Log LOG = LogFactory.getLog(VetBenefitHandbookController.class);

    public Boolean showErrorMesg 	= false;

    public boolean accountStatus 	= false;

    public String accountType = "";

	private static final long serialVersionUID = 1L;

	@Jpf.Action(forwards = {
	        @Jpf.Forward(name = "success",
	                     path = "vetBenefitHandbook.jsp")
	    })
	public Forward begin() {
		return new Forward("success");
	}

	/**
	 * @jpf:action
	 * @jpf:validation-error-forward name="failure" return-to="currentPage"
	 * @jpf:forward name="success" path="downloadReportResult.jsp"
	 */
	@Jpf.Action(
         forwards = {@Jpf.Forward(name = "success", path = "vetBenefitHandbook.jsp"),
                     @Jpf.Forward(name = "failure", path = "vetBenefitHandbook.jsp")
    }
     )
	public Forward gotoVBH()
	{

		boolean isPatientL2 = Boolean.FALSE;

		resetPHRRefreshStatuses();

		String loginType = (String)ScopedServletUtils.getOuterRequest(getRequest()).getSession().getAttribute(EauthConstants.LOGIN_TYPE);
		accountType = (String)ScopedServletUtils.getOuterRequest(getRequest()).getSession().getAttribute("account_status");
		Properties properties = ConfigurationManager.getConfiguration("/vbh.properties");
		System.out.println("Outer Request User Login Type " + loginType);

		if (loginType == null)
		{
			RSAEncrypt rSAEncrypt = new RSAEncrypt(properties.getProperty("vbh.pub.key.mod"),properties.getProperty("vbh.pub.key.exp"),properties.getProperty("vbh.pri.key.mod"),properties.getProperty("vbh.pri.key.exp"));

			String currentUserName = getRequest().getRemoteUser();
			Long currentId = ServiceDelegateFactory.createUserProfileServiceDelegate().getProfileForUser(currentUserName).getUserProfile().getId();

			String longTime = String.valueOf(System.currentTimeMillis());
			String mhvHeader = "MHV|"+Long.toString(currentId)+"|"+longTime;
			//String mhvHeader = "MHV|9981386|"+longTime;

			//HttpServletRequest request = ScopedServletUtils.getOuterRequest(getRequest());

			UserProfile uProfile = ServiceDelegateFactory.createUserProfileServiceDelegate().getProfileForUser(getRequest().getUserPrincipal().getName() ).getUserProfile();

			System.out.println("isPatientL2 is Initially set to::"+isPatientL2);

			PatientServiceResponse pResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(uProfile);
			InPersonAuthenticationServiceDelegate delegate = ServiceDelegateFactory.createInPersonAuthenticationServiceDelegate();

			Patient patient = pResponse.getPatient();

			/* Comment validation. check not needed.
			if (patient != null) {
				isPatientL2 = delegate.isPatientAuthenticated(patient.getId()).getBoolean();
			} else {

				isPatientL2 = Boolean.FALSE;
			}

			if (isPatientL2 == false) {
				accountStatus = true;
				LOG.error("The logged in user is not a MHV Level 2 user.");
				System.out.println("The logged in user is not a MHV Level 2 user.");
				return new Forward("failure");
			}



			showErrorMesg = false;
			if(!ping(properties.getProperty("vbh.dev.direct.url"),1000))
				showErrorMesg = true;

			*/

			System.out.println("29MHV Header is set to::"+mhvHeader);
			System.out.println("isPatientL2 is set to::"+isPatientL2);
			System.out.println("Encrypted data-mhv is::"+rSAEncrypt.encrypt(mhvHeader));
			//System.out.println("Is the Website Up::"+ping(properties.getProperty("vbh.dev.direct.url"),1000));
			System.out.println("Account Type is::"+accountType);

			Auditor.auditVBHHandbookEvent(uProfile.getId(),ActivityActorTypeEnumeration.SELF,true, ActivityActionTypeEnumeration.MY_VETERANS_BENEFITS_HANDBOOK_REQUESTED, ActivityTypeEnumeration.REQUEST_TO_VB_HANDBOOK);

			try{
					HttpServletResponse response = this.getResponse();
					//response.addHeader("data-mvh",mhvHeader);
					//response.sendRedirect(properties.getProperty("vbh.dev.direct.url")+"&data-mvh="+mhvHeader);
					response.sendRedirect(properties.getProperty("vbh.dev.direct.url")+"&data-mvh="+rSAEncrypt.encrypt(mhvHeader));
					//response.sendRedirect("https://serverserver1.srv.domain/ABC?src=MHV&data-mvh="+rSAEncrypt.encrypt(mhvHeader));
				  }catch(Exception e){
					System.out.println("gotoVBH Action in VetBenefitHandbookController::Redirect URL failed.");
					LOG.error("gotoVBH Action in VetBenefitHandbookController::Redirect URL failed.");
			}
		} else {
			try{
					HttpServletResponse response = this.getResponse();
					response.sendRedirect(properties.getProperty("vbh.dev.dslogon.url"));
				  }catch(Exception e){
					System.out.println("gotoVBH Action in VetBenefitHandbookController::Redirect for DSLogon URL failed.");
					LOG.error("gotoVBH Action in VetBenefitHandbookController::Redirect for DSLogon URL failed.");
				}
		}

		// If everything is OK forward the request OR else return new Failure ("failure")
		return new Forward("success");
	}

	// Uncomment this block if nested pageflow
	/**
	@Jpf.Action(
	    forwards={
	       @Jpf.Forward(name="done", returnAction="NestedTemplateDone")
	    }
	)
	protected Forward done()
	{
		return new Forward("done");
	}
	 **/


	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.previousPage) })
    protected Forward cancelAction()
        throws Exception
    {
		PageURL url = PageURL.createPageURL(getRequest(), getResponse(), "personalInformation");
  	  	try{
	 	    this.getResponse().sendRedirect(url.toString());
		  }catch(Exception e){
	 	  	LOG.error("cancelAction in VetBenefitHandbookController::Redirect URL failed");
		}
		  return null;
    }

	public boolean getShowErrorMesg() {
		return showErrorMesg;
	}


	/**
	 * Pings a HTTP URL. This effectively sends a HEAD request and returns <code>true</code> if the response code is in
	 * the 200-399 range.
	 * @param url The HTTP URL to be pinged.
	 * @param timeout The timeout in millis for both the connection timeout and the response read timeout. Note that
	 * the total timeout is effectively two times the given timeout.
	 * @return <code>true</code> if the given HTTP URL has returned response code 200-399 on a HEAD request within the
	 * given timeout, otherwise <code>false</code>.
	 */
	public static boolean ping(String url, int timeout) {

		System.out.println("URL is (Before)::"+url);

		url = url.replaceFirst("https", "http"); // Otherwise an exception may be thrown on invalid SSL certificates.

		System.out.println("URL is (After)::"+url);

		try {
			java.net.HttpURLConnection connection = (java.net.HttpURLConnection) new java.net.URL(url).openConnection();
			connection.setConnectTimeout(timeout);
			connection.setReadTimeout(timeout);
			connection.setRequestMethod("HEAD");
			int responseCode = connection.getResponseCode();
			System.out.println("Response code is::"+responseCode);
			return (200 <= responseCode && responseCode <= 399);
		} catch (IOException exception) {
			System.out.println("In the exception catch");
			System.out.println(exception);
			return false;
		}
	}


	private void resetPHRRefreshStatuses(){
		accountStatus 			= false;
	}

	@Override
	protected String getTableSessionKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityCollectionServiceResponse lookupEntities() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityServiceResponse deleteEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected Long getCurrentUserId() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected String getEntityName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected Class getTransferObjectClass() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected EntityServiceResponse lookupEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void populateEntity(InputForm arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	protected void populateForm(InputForm arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	protected EntityServiceResponse saveEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setupNewEntity() {
		// TODO Auto-generated method stub

	}

	@Override
	protected Class getFormClass() {
		// TODO Auto-generated method stub
		return null;
	}
}