package gov.va.med.mhv.usermgmt.register;
import gov.va.med.mhv.eauth.EauthConstants;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityActorTypeEnumeration;
import gov.va.med.mhv.usermgmt.enumeration.ActivityTypeEnumeration;
import gov.va.med.mhv.usermgmt.form.UserProfileForm;
import gov.va.med.mhv.usermgmt.portlet.UserProfilePageFlowController;
import gov.va.med.mhv.usermgmt.service.PatientServiceResponse;
import gov.va.med.mhv.usermgmt.service.UserProfileServiceResponse;
import gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory;
import gov.va.med.mhv.usermgmt.service.delegate.UserRegistrationServiceDelegate;
import gov.va.med.mhv.usermgmt.transfer.Patient;
import gov.va.med.mhv.usermgmt.transfer.UserProfile;
import gov.va.med.mhv.usermgmt.util.Auditor;
import gov.va.med.mhv.usermgmt.util.PatientCorrelationStatusUtils;

import java.net.URL;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.beehive.netui.pageflow.Forward;
import org.apache.beehive.netui.pageflow.annotations.Jpf;
import org.tigris.atlas.messages.Message;
import org.tigris.atlas.messages.Messages;
import org.tigris.atlas.service.BooleanServiceResponse;
import org.tigris.atlas.service.VoidServiceResponse;

import com.bea.content.ContentContext;
import com.bea.content.Node;
import com.bea.content.expression.Search;
import com.bea.content.federated.ContentManagerFactory;
import com.bea.content.federated.ISearchManager;
import com.bea.content.paging.ISortableFilterablePagedList;

/**
 * @jpf:controller struts-merge="/WEB-INF/struts-override.xml"
 *  */
@Jpf.Controller(strutsMerge = "/WEB-INF/struts-override.xml")
public class RegisterUserController extends UserProfilePageFlowController implements EauthConstants
{
    private String userName;
    private String password;
    private String mhvId;
    private boolean fccxReg;
    private boolean isPatient;
    private String fccxUrl;
    
    public boolean isPatient() {
    	return isPatient;
    }
    
    public boolean isReadOnlyMPIInfo() {
    	return fccxReg;
    }
    
    public boolean isFccxReg() {
    	return fccxReg;
    }
    
   /**
     * This method represents the point of entry into the pageflow
     * @jpf:action
     * @jpf:forward name="success" path="editUserProfile.jsp"
     */
    @Jpf.Action(forwards = { 
        @Jpf.Forward(name = "success",
                     path = "editUserProfile.jsp")
    })
    public Forward begin(UserProfileForm form)
    {
    	isPatient = false;
    	Object fccx = getSession().getAttribute("FCCX");
System.out.println("FCCX:" + fccx);
		if(fccx!=null && fccx.equals("true")) {
			fccxReg = true;
			Object firstName = getSession().getAttribute(EauthConstants.FIRST_NAME);
			if(firstName != null) {
				form.setUserProfileFirstName(firstName.toString());
			}
			
			Object middleName = getSession().getAttribute(EauthConstants.MIDDLE_NAME);
			if(middleName != null) {
				form.setUserProfileMiddleName(middleName.toString());
			}
			
			Object lastName = getSession().getAttribute(EauthConstants.LAST_NAME);
			if(lastName != null) {
				form.setUserProfileLastName(lastName.toString());
			}
			
			Object gender = getSession().getAttribute(EauthConstants.GENDER);
			if(gender != null) {
				form.setUserProfileGender(gender.toString());
			}
			
			Object birthDate = getSession().getAttribute(EauthConstants.BIRTH_DATE);
			if(birthDate != null) {
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
				Date dob = null;
				try {
					dob = sdf.parse(birthDate.toString().substring(0, 10));
				} catch (ParseException e) {
				}
				Calendar calendar = Calendar.getInstance();
				calendar.setTime(dob);
				form.setUserProfileBirthDateDay(""+calendar.get(Calendar.DAY_OF_MONTH));
				int month = calendar.get(Calendar.MONTH)+1;
				form.setUserProfileBirthDateMonth(""+month);
				int year = calendar.get(Calendar.YEAR) - 1900;
				form.setUserProfileBirthDateYear(""+year);
			}

			Object ssn = getSession().getAttribute(EauthConstants.ID);
			if(ssn != null) {
				form.setSsn1(ssn.toString().trim().substring(0, 3));
				form.setVerifySsn1(ssn.toString().trim().substring(0, 3));
				form.setSsn2(ssn.toString().trim().substring(3, 5));
				form.setVerifySsn2(ssn.toString().trim().substring(3, 5));
				form.setSsn3(ssn.toString().trim().substring(5, 9));
				form.setVerifySsn3(ssn.toString().trim().substring(5, 9));
			}
			
			Object address1 = getSession().getAttribute(EauthConstants.ADDRESS1);
			if(address1 != null) {
				form.setUserProfileAddressStreet1(address1.toString());
			}
			
			Object city = getSession().getAttribute(EauthConstants.CITY);
			if(city != null) {
				form.setUserProfileAddressStreet2(city.toString());
			}
			
			Object state = getSession().getAttribute(EauthConstants.STATE);
			if(state != null) {
				form.setUserProfileAddressState(state.toString());
			}
			
			Object postal = getSession().getAttribute(EauthConstants.POSTAL_CODE);
			if(postal != null) {
				form.setUserProfileAddressPostalCode(postal.toString());
			}
			
			Object country = getSession().getAttribute(EauthConstants.COUNTRY);
			if(postal != null) {
				form.setUserProfileAddressCountry(country.toString());
			}
			
			Object email = getSession().getAttribute(EauthConstants.EMAIL);
			if(email != null) {
				form.setUserProfileContactInfoEmail(email.toString());
			}
			
			Object phone = getSession().getAttribute(EauthConstants.PHONE);
			if(phone != null) {
				form.setUserProfileContactInfoHomePhone(phone.toString());
			}
			
			Object treatingFaciltiesExist = getSession().getAttribute("treatingFaciltiesExist");
			
			if(treatingFaciltiesExist != null && treatingFaciltiesExist.toString().equalsIgnoreCase("true")) {
				isPatient = true;
				form.setUserProfileIsPatient("true");
			}
			getSession().removeAttribute("FCCX");
		} else {
			fccxReg = false;
			form.setUserProfileFirstName("");
			form.setUserProfileMiddleName("");
			form.setUserProfileLastName("");
			form.setUserProfileGender("");
			form.setUserProfileBirthDateDay("");
			form.setUserProfileBirthDateMonth("");
			form.setUserProfileBirthDateYear("");
			form.setUserProfileAddressStreet1("");
			form.setUserProfileAddressCity("");
			form.setUserProfileAddressState("");
			form.setUserProfileAddressPostalCode("");
			form.setUserProfileContactInfoEmail("");
			form.setUserProfileContactInfoHomePhone("");
			form.setUserProfileIsPatient("");
		}
		
    	//MHV_CodeCR1514 - SSN fix - Turn these flags off as User might have not closed the 
    	//browser and the new user might have started the new registration.
    	//Also remove it from UserProfile in case the new user doesn't enter SSN.
    	getSession().removeAttribute("REGISTRATION_SSN");
		getSession().removeAttribute("REGISTRATION_VERIFY_SSN");
		if(getCurrentUserProfile()!=null) {
			getCurrentUserProfile().setSsn(null);
		}
        return super.newAction();
    }

    public String getUserName()
    {
        return userName;
    }

    public String getMhvId()
    {
        return mhvId;
    }
    
    
    /**
     * @jpf:action
     * @jpf:validation-error-forward name="failure" return-to="currentPage"
     * @jpf:forward name="success" path="success.jsp"
     * 
     * US8.13 - While middle Name is optional, if blank, validity check should confirm that user 
     * has a middle name or initial. 
     * This method is called when the user is confirmed that there is no middle name and proceed with updating the profile.

     */
    @Jpf.Action(forwards = { 
        @Jpf.Forward(name = "success",
                     path = "success.jsp")
    }, 
                validationErrorForward = @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage), preventDoubleSubmit=false
	)
    protected Forward saveNoMiddleNameAction(UserProfileForm form) {
    	
    	if(isTokenValid())
    		resetToken();
    	else
    		saveToken(getRequest());  
    	getRequest().setAttribute("CANCEL_INFO_MESSAGE",false);
    	getRequest().setAttribute("MIDDLE_NAME_INFO_MESSAGE",false);
        UserRegistrationServiceDelegate delegate = ServiceDelegateFactory.createUserRegistrationServiceDelegate();
        assembleSsn(form, getCurrentUserProfile());
        form.copyTo( getCurrentUserProfile() );
        
        userName = form.getUserName();
        password = form.getPassword();
        UserProfileServiceResponse response = delegate.registerUser( getCurrentUserProfile(), verifySsn, userName, password, form.getConfirmPassword(),getTermsModifiedTime() );
        UserProfile userProfile = response.getUserProfile();
        
        handleMessages( response, form );
        if(userProfile != null){
        	setCurrentEntity( response.getUserProfile() );
        	mhvId =  response.getUserProfile().getMhvId();
        	userName = response.getUserProfile().getUserName();
        }

      //Adding for Correlation
    	PatientServiceResponse patientResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(userProfile);
    	Patient patient = patientResponse.getPatient();
    	
    	if(patient != null && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.MVI_DATA_MATCH)) {
    		
    		Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,true, ActivityActionTypeEnumeration.ACCOUNT_CORRELATION_REQUESTED, ActivityTypeEnumeration.REGISTRATION);
    		ServiceDelegateFactory.createMviAsyncIntegrationServiceDelegate().addPersonForCorrelation(patient, userProfile, true);
    		/*BooleanServiceResponse corrResponse = ServiceDelegateFactory.createMviAsyncIntegrationServiceDelegate().addPersonForCorrelation(patient, userProfile);
    		if (corrResponse.getBoolean()) {
    			Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,true, ActivityActionTypeEnumeration.ACCOUNT_CORRELATED);
    		}
    		else
    			Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,false, ActivityActionTypeEnumeration.ACCOUNT_CORRELATED);
    		*/
    	}
    	
    	//US8.13 - make sure that the middle name check enabled again.
        if(!response.getMessages().hasErrorMessages()) {
        	//MHV_CodeCR1514 - SSN fix - Turn these flags off since all the field entries are correct... no error.
        	getSession().removeAttribute("REGISTRATION_SSN");
    		getSession().removeAttribute("REGISTRATION_VERIFY_SSN");
        }
        if (response.getMessages().hasErrorMessages()) {
        	getRequest().removeAttribute("InfoMessages");
        }
        return determineForward();
    }
    
    /**
     * @jpf:action
     * @jpf:validation-error-forward name="failure" return-to="currentPage"
     * @jpf:forward name="success" path="success.jsp"
     */
    @Jpf.Action(forwards = { 
        @Jpf.Forward(name = "success",
                     path = "success.jsp")
    }, 
                validationErrorForward = @Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage), preventDoubleSubmit=true
	)
    protected Forward saveAction(UserProfileForm form) {
    	if(isTokenValid())
    		resetToken();
    	else
    		saveToken(getRequest());
    	//US8.8 - MHV System shall provide the user with the option to  Save or Cancel profile information.
    	//Make sure that cancel message doesn't come up initially.
    	getRequest().setAttribute("CANCEL_INFO_MESSAGE",false);
        //US8.13 - While middle Name is optional, if blank, validity check should confirm that user 
        //has a middle name or initial.
    	//Make sure that middle name message doesn't come up initially.
    	getRequest().setAttribute("MIDDLE_NAME_INFO_MESSAGE",false);
        UserRegistrationServiceDelegate delegate = ServiceDelegateFactory.createUserRegistrationServiceDelegate();
        assembleSsn(form, getCurrentUserProfile());
        form.copyTo( getCurrentUserProfile() );
        
        userName = form.getUserName();
        password = form.getPassword();
        
        //CR1246/1250 - Needs to move this block up before calling register user; otherwise, the new user will be registered no matter if
        //there is a middle name or not.
        //Make sure that if middle name check is required and if the user is patient
        //or veteran, if the middle name is blank, show the error message.
        Boolean noMiddleNameCheck = (Boolean)getSession().getAttribute("NO_MIDDLE_NAME_CHECK");
        if(noMiddleNameCheck==null ||!noMiddleNameCheck){
        	if(form.getUserProfileMiddleName()==null ||form.getUserProfileMiddleName().length()==0) {
            	if(new Boolean(form.getUserProfileIsVeteran()) || new Boolean(form.getUserProfileIsPatient())) {
            		getRequest().setAttribute("MIDDLE_NAME_INFO_MESSAGE",true);
                	getSession().setAttribute("NO_MIDDLE_NAME_CHECK", true);
            		return new Forward("failure");
            	}
        	}
        }

        
        UserProfileServiceResponse response = delegate.registerUser( getCurrentUserProfile(), verifySsn, userName, password, form.getConfirmPassword(),getTermsModifiedTime() );
        UserProfile userProfile = response.getUserProfile();

        //US.8.2 The user shall be able click on the terms "Basic", "Advanced" and "Premium" on the 
        //"Relationship to VA" section and the system will display a separate window/tab with the definitions for the term
        //Adding the url for advaced, premium and basic
		Message message = getMessage(response.getMessages(), "ssn.required.for.patient");
		String contextPath= getRequest().getContextPath();

		if (message != null) {
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
			
		}
		
		message = getMessage(response.getMessages(), "ssn.required.for.veteran");
		if (message != null) {
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
			message.addInsert(contextPath + "/ShowBinary/BEA%20Repository/Registration/mhv_account_status.html");
		}
		
        handleMessages( response, form );
        if(userProfile != null){
        	setCurrentEntity( response.getUserProfile() );
        	mhvId =  response.getUserProfile().getMhvId();
        }
        
        //Adding for Correlation
    	PatientServiceResponse patientResponse = ServiceDelegateFactory.createPatientServiceDelegate().getPatientForUser(userProfile);
    	Patient patient = patientResponse.getPatient();

    	if(patient != null && patient.getCorrelationStatus().equals(PatientCorrelationStatusUtils.MVI_DATA_MATCH)) {
    		
    		Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,true, ActivityActionTypeEnumeration.ACCOUNT_CORRELATION_REQUESTED, ActivityTypeEnumeration.REGISTRATION);
    		ServiceDelegateFactory.createMviAsyncIntegrationServiceDelegate().addPersonForCorrelation(patient, userProfile, true);
    		/*BooleanServiceResponse corrResponse = ServiceDelegateFactory.createMviAsyncIntegrationServiceDelegate().addPersonForCorrelation(patient, userProfile);
    		if (corrResponse.getBoolean()) {
    			Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,true, ActivityActionTypeEnumeration.ACCOUNT_CORRELATED);
    		}
    		else
    			Auditor.auditMviEvent(userProfile.getId(),ActivityActorTypeEnumeration.SYSTEM,false, ActivityActionTypeEnumeration.ACCOUNT_CORRELATED);
    		*/
    	}
    	
    	//US8.13 - make sure that the middle name check enabled again.
        if(!response.getMessages().hasErrorMessages()) {
        	getSession().removeAttribute("NO_MIDDLE_NAME_CHECK");
    		
        	//MHV_CodeCR1514 - SSN fix - Turn these flags off since all the field entries are correct... no error.
        	getSession().removeAttribute("REGISTRATION_SSN");
    		getSession().removeAttribute("REGISTRATION_VERIFY_SSN");
        }
        
        if (response.getMessages().hasErrorMessages()) {
        	getRequest().removeAttribute("InfoMessages");
        }
        return determineForward();
    }

	//US8.8 - MHV System shall provide the user with the option to  Save or Cancel profile information.
	//This method is called when the cancel button is clicked.
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.currentPage) })
    protected Forward cancelAction(UserProfileForm form)
        throws Exception
    {
		getRequest().setAttribute("CANCEL_INFO_MESSAGE",true);
		VoidServiceResponse vsr = new VoidServiceResponse();
		//handleCancelMessages(vsr);
		return new Forward("success");
    }
	
	//US8.8 - MHV System shall provide the user with the option to  Save or Cancel profile information.
	//This method is called when the user cancel the cancel button action after reading 'are you sure' message.
	@Jpf.Action(forwards = { @Jpf.Forward(name = "success", navigateTo = Jpf.NavigateTo.currentPage) })
    protected Forward cancelCancelAction(UserProfileForm form)
        throws Exception
    {
		getRequest().removeAttribute("CANCEL_INFO_MESSAGE");
		getRequest().removeAttribute("MIDDLE_NAME_INFO_MESSAGE");
		//VoidServiceResponse vsr = new VoidServiceResponse();
		//handleCancelMessages(vsr);
		return new Forward("success");
    }
	
	//US8.8 - MHV System shall provide the user with the option to  Save or Cancel profile information.
	//This method is called when the user proceeds with the cancel button action after reading 'are you sure' message.
	@Jpf.Action(
	         forwards = {@Jpf.Forward(name = "success", path = "anonymous.portal")}
	     )
    protected Forward anonymCancelAction()
        throws Exception
    {
    	//MHV_CodeCR1514 - SSN fix - Turn these flags off since all the field entries are correct... no error.
    	getSession().removeAttribute("REGISTRATION_SSN");
		getSession().removeAttribute("REGISTRATION_VERIFY_SSN");
		if(getCurrentUserProfile()!=null) {
			getCurrentUserProfile().setSsn(null);
		}

		getRequest().removeAttribute("CANCEL_INFO_MESSAGE");
		String protocol = getRequest().getScheme();
		String serverName = getRequest().getServerName();
		String contextPath= getRequest().getContextPath();
		String urlFile1 = contextPath+ "/anonymous.portal?_nfpb=true&_nfto=false&_pageLabel=mhvHome";
		return new Forward(new URL(protocol, serverName, urlFile1));
    }
	
	private static Message getMessage(Messages messages, String key) {
		Message message = null;
		if (messages != null) {
			for (Iterator i = messages.getErrorMessages().iterator(); 
			     (message == null) && i.hasNext();)
			{
				message = (Message) i.next();
				if ((message != null) && !message.getKey().equals(key)) {
					message = null; // not found, keep looking
				}
			}
			for (Iterator i = messages.getInformationalMessages().iterator(); 
		     (message == null) && i.hasNext();)
			{
				message = (Message) i.next();
				if ((message != null) && !message.getKey().equals(key)) {
					message = null; // not found, keep looking
				}
			}
		}

		return message;
	}
	
    protected Class getFormClass()
    {
        return UserProfileForm.class;
    }

    protected Class getTransferObjectClass()
    {
        return UserProfile.class;
    }
    
    private Timestamp getTermsModifiedTime()  {
		
    	String query="cm_isContent = true && active_flag=true && keywords likeignorecase 'Terms and Conditions'";
   	 	try{
   	 		Search search = new Search(query);
   	 		//search.setUseCache(false);
   		    
   	 		// Do the search using the ISearchManager.
	   		 ISearchManager searchManager = ContentManagerFactory.getSearchManager();
	   		 ISortableFilterablePagedList <Node> resultList = searchManager.search(new ContentContext(), search);
	   		 Iterator iterator=resultList.iterator();
	   		 if(iterator.hasNext()){
	   			 Node temp=(Node)resultList.iterator().next();
	   			 long time=temp.getModifiedDate().getTimeInMillis();
	   			 System.out.println(time);
	   			 return new Timestamp(time);
   			   			 
	   		 }
   	 	
   		 else{
   			 return null;
   		 }
   	 }
   	 catch(Exception e){
   		 return null;
   	 }
   }
}
