package gov.va.med.mhv.usermgmt.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Comparator;
import java.util.Date;

/**
 * Compares two strings that are dates
 * 
 * @author rsimmering
 *
 */
public class DateComparator implements Comparator {
	static private SimpleDateFormat df = new SimpleDateFormat("M/d/yyyy h:mma");
	
	public int compare(Object o1, Object o2) {
		String sDate1 = (String)o1;
		String sDate2 = (String)o2;
		
		try{
			Date date1 = (Date)df.parse(sDate1);
			Date date2 = (Date)df.parse(sDate2);
			if(date1.before(date2)){
				return -1;
			}
			else if(date1.after(date2)){
				return 1;
			}
			else
				return 0;
		}
		catch(ParseException e){
			return 0;
		}
	}

}
