package gov.va.med.mhv.usermgmt.util;

import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
//import javax.servlet.http.HttpUtils;

import javax.naming.InitialContext;
import javax.portlet.PortletPreferences;
import javax.rmi.PortableRemoteObject;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.beehive.netui.pageflow.scoping.ScopedServletUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.bea.netuix.application.definition.DesktopDefinition;
import com.bea.netuix.application.identifier.DesktopDefinitionId;
import com.bea.netuix.application.identifier.DesktopPath;
import com.bea.netuix.application.manager.CustomizationContext;
import com.bea.netuix.application.manager.persistence.DesktopDefinitionManager;
import com.bea.netuix.application.manager.persistence.DesktopDefinitionManagerHome;
import com.bea.netuix.servlets.controls.portlet.backing.PortletBackingContext;
import com.bea.netuix.servlets.manager.AppContext;
import com.bea.portlet.GenericURL;
import com.bea.portlet.PageURL;
import com.bea.portlet.PostbackURL;
import com.bea.portlet.ResourceURL;

import gov.va.med.mhv.core.util.Precondition;
import gov.va.med.mhv.usermgmt.portlet.changepassword.ChangePasswordController;
import gov.va.med.mhv.usermgmt.portlet.constants.DefinitionLabelConstants;
import gov.va.med.mhv.usermgmt.portlet.employee.login.EmployeeLoginPageFlowController;
import gov.va.med.mhv.usermgmt.portlet.forgotpassword.ForgotPasswordController;
import gov.va.med.mhv.usermgmt.portlet.termsAndConditions.TermsAndConditionsController;

public class DirectorUtil {

	private static final Log LOG = LogFactory.getLog(DirectorUtil.class);

	private static final String REGISTER_PAGE = "register";

	public static final String ANONYMOUS_DESKTOP_URL = "ANON_DESKTOP_URL";

	public static final String T_AND_C_DESKTOP_URL = "T_AND_C_URL";

	public static final String AUTHENTICATED_DESKTOP_URL = "AUTH_DESKTOP_URL";

	public static String getLoginRedirectURL(HttpServletRequest request,
		HttpServletResponse response)
	{
		String username = request.getRemoteUser();
		//System.out.println("Backing Got the login stuff -- " + username);

		// Get the URL for the default postback
		// PostbackURL url = PostbackURL.createPostbackURL(request, response);
		ResourceURL desktopURL = null;
		ResourceURL defaultURL = null;
		ResourceURL selectURL = null;
		ArrayList defaultURLs = null;

		// authenticate the username and password
		if (username != null) {
			// If this is a dot portal file then return, doing nothing else
			AppContext ac = AppContext.getAppContext(request);

			if (ac.isDotPortal()) {
				//System.out.println("Backing Got the login stuff -- " + username
				//	+ "-- This is a dot portal ");
				PortletBackingContext ptCtx = PortletBackingContext
					.getPortletBackingContext(ScopedServletUtils
						.getOuterRequest(request));
				PortletPreferences prefs = ptCtx
					.getPortletPreferences(ScopedServletUtils
						.getOuterRequest(request));

				// this is just a quick hack to get the desktops working ....
				String val = prefs.getValue(AUTHENTICATED_DESKTOP_URL, null);
				if (val != null) {
					return getPath(request, val);
				}
				return null;
			}

			HttpSession session = request.getSession();

			// Store the default URL in the session
			defaultURL = ResourceURL.createResourceURL(request, response);
			session.setAttribute("_defaultURL", defaultURL.toString());

			defaultURLs = DirectorUtil.getNonDefaultDesktopURLs(request,
				response);
			if (defaultURLs.size() > 1) {
				desktopURL = DirectorUtil.getNonDefaultDesktopURL(request,
					response);
				selectURL = ResourceURL.createResourceURL(request, response);
				System.out
					.println("defaultURLs.size() > 1 - Got the login stuff");
			} else {
				// Get the desktop URL
				desktopURL = DirectorUtil.getNonDefaultDesktopURL(request,
					response);
				System.out
					.println(" defaultURLs.size() < 1 Got the login stuff"
						+ "desktopURL = " + desktopURL);
			}

			if (desktopURL == null) {
				// System.out.println(" desktopURL = null - Got the login
				// stuff");
				// url.addParameter(YahooLoginFilter.LOGIN_REQUEST_PARAM,
				// "true");
				/*
				 * url.addParameter(GenericURL.LOADSTATE_PARAM, "false");
				 * url.addParameter(GenericURL.PAGE_LABEL_PARAM, "login");
				 * JspContentContext context =
				 * JspContentContext.getJspContentContext(request);
				 * context.sendRedirect(url.toString());
				 */
			} else {
				if (selectURL == null) {
					// System.out.println("selectURL = null in - desktopURL = "+
					// desktopURL);
					// desktopURL.addParameter(YahooLoginFilter.LOGIN_REQUEST_PARAM,
					// "true");
					// desktopURL.addParameter(GenericURL.LOADSTATE_PARAM,
					// "false");
					desktopURL.addParameter(GenericURL.POSTBACK_PARAM, "true");

					// reset pageLabel
					desktopURL.removeParameter(GenericURL.PAGE_LABEL_PARAM);
					desktopURL.addParameter(GenericURL.PAGE_LABEL_PARAM,
						getPageLabel(request));

					// System.out.println("selectURL = null reconfigured -
					// desktopURL = "+ desktopURL);

					return desktopURL.toString();
				}
				// System.out.println("selectURL != null Got the login stuff");
				session.setAttribute("_defaultURLs", defaultURLs);
				selectURL.addParameter("_selectDesktop", "true");
				// JspContentContext context =
				// JspContentContext.getJspContentContext(request);
				// context.sendRedirect(url.toString());
			}

		}
		return "";
	}

	public static final String getDefaultSplashPage(HttpServletRequest request, 
									HttpServletResponse response) {
		String defaultProtocol = "";
		PostbackURL url = PostbackURL.createPostbackURL(request, response);
		URL splashURL = null;
		String protocol = request.getScheme();
		String serverName = request.getServerName();
		String webAppName = AppContext.getAppContext(request).getWebAppName();
		String urlFile = "/" +webAppName + "/logout-thankYou.jsp";
		//String serverName = "srv-serv.myhealth.domain"; //use hard coding for testing.
		try {
			//splashURL = new URL(protocol,serverName,"/logout-thankYou.html"); //"/logout" servlet mapped to "logout servlet"
			//splashURL = new URL(protocol,serverName,"/"); //"/logout" servlet mapped to "logout servlet"
			//splashURL = new URL(protocol,serverName,"/mhv-user-mgmt-portal-web/logout-thankYou2.jsp"); //use this unit testing
			//splashURL = new URL(protocol,serverName,""); //use this unit testing
			
			splashURL = new URL(protocol,serverName,urlFile); //"/logout" servlet mapped to "logout servlet"
			
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		if (!isSSL(request)){
			defaultProtocol = "https";
			url.setScheme(defaultProtocol);

			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
			//url.addParameter(GenericURL.PAGE_LABEL_PARAM, "mhvHome");
			//url.setPath("/" + AppContext.getAppContext(request).getWebAppName()+ "/anonymous.portal");
			if (LOG.isDebugEnabled()) {
				LOG.debug("In the getDefaultSplashPage method: The final secured URL in the backing file util class: " + url);
			}

			System.out.println("In anonymous portal::getDefaultAnonymousPortalPage method::" + url.toString());
			//return url.toString();
			splashURL.toString();
		}
		else{
			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
			//url.addParameter(GenericURL.PAGE_LABEL_PARAM, "mhvHome");
			//url.setPath("/" + AppContext.getAppContext(request).getWebAppName()+ "/anonymous.portal");
			//url.setPath("srv-serv.myhealth.domain");
		}
		return splashURL.toString();
		
	}
	
	// get redirect to T& C portal
	public static String getTermsAndConditionsRedirectURL(
		HttpServletRequest request)
	{
		return getPortletUrl(request, T_AND_C_DESKTOP_URL,
				DefinitionLabelConstants.TERMS_CONDITIONS_PAGE,
				DefinitionLabelConstants.TERMS_CONDITIONS_PORTLET,
				TermsAndConditionsController.class, null);
	}

	/**
	 * Modifies url according to value
	 */
	private static String getPath(HttpServletRequest request, String val) {

		/**
		 *  CR 3023: forcing each and every request to be https (secured protocol) instead of http
		 */
		String protocol = "https://";

		StringBuffer strBuf = new StringBuffer(protocol).append(request.getServerName());
		strBuf.append(":").append(request.getServerPort()).append(
			request.getContextPath()).append("/").append(val).append("?")
			.append(GenericURL.LOADSTATE_PARAM).append("=false&").append(
				GenericURL.POSTBACK_PARAM).append("=true&").append(
				GenericURL.TREE_OPTIMIZATION_PARAM).append("=true&").append(
				GenericURL.PAGE_LABEL_PARAM).append("=").append(
				getPageLabel(request));

		return strBuf.toString();
	}

	/**
	 * Modifies the unsecured url in order to make it secured with https protocol (CR 3023)
	 */
	public static final String getSecurePortalPage(HttpServletRequest request, HttpServletResponse response) {

        /*
        *  This gets the URL from the request, which doesnt contain query parameters
        */
		String unsecureURL = request.getRequestURL().toString();

		/*
		* This gets the query parameters from the string
		*/
		String queryString = request.getQueryString();
		//String httpsURL = HttpUtils.getRequestURL(request).toString();

		//Here, we replace http with https from the unsecured URL to make it secure
		String secureURL = StringUtils.replaceOnce(unsecureURL, "http", "https");
        
		// this is to get the port number from the URL
		String portNumber = StringUtils.substringBetween(secureURL.substring(6), ":", "/");

		// removing the port number from the URL as it goes to the default un-secured port
		String secureURLWithoutPort = StringUtils.replaceOnce(secureURL, ":" + portNumber,"");

		/*
		if (LOG.isDebugEnabled()) {
			LOG.debug("The queryString in the getSecurePortalPage method in the backing file util class: " + queryString);
		}

		if (LOG.isDebugEnabled()) {
			LOG.debug("The original URL in the getSecurePortalPage method in the backing file util class: " + unsecureURL);
		}
		 
		if (LOG.isDebugEnabled()) {
			LOG.debug("The port number in the getSecurePortalPage method in the backing file util class: " + portNumber);
		}		
		
		if (LOG.isDebugEnabled()) {
			LOG.debug("The secureURLWithoutPort in the getSecurePortalPage method in the backing file util class: " + secureURLWithoutPort);
		}
		*/

		/*
		 *  This builds the final secured URL which has getRquestURL() and getQueryString().
		 */
		if (queryString!=null || queryString==""){
			String finalURL = secureURLWithoutPort + "?" + queryString;

			if (LOG.isDebugEnabled()) {
				LOG.debug("The final ultimate secured URL without the port in the getSecurePortalPage method in the backing file util class: " + finalURL);
			}
        	return finalURL.toString();

	    }
		
		/*
		 *  This builds the final secured URL which has just getRquestURL() but not getQueryString() as it will be empty/null.
		 */		
	    else{
			if (LOG.isDebugEnabled()) {
				LOG.debug("The final ultimate secured URL without the port and without the query string in the getSecurePortalPage method in the backing file util class: " + secureURLWithoutPort);
			}
	    	
			return secureURLWithoutPort.toString();
		}

	}

	public static String getLogoutRedirectURL(HttpServletRequest request,
		HttpServletResponse response)
	{
		// If this is a dot portal file then return, doing nothing else
		AppContext ac = AppContext.getAppContext(request);

		if (ac.isDotPortal()) {
			PortletBackingContext ptCtx = PortletBackingContext
				.getPortletBackingContext(ScopedServletUtils
					.getOuterRequest(request));
			/*
			 * Deprecated in WLP 9.2
			 */
			// PortletPreferences prefs =
			// ptCtx.getPreferences(ScopedServletUtils.getOuterRequest(request));
			PortletPreferences prefs = ptCtx
				.getPortletPreferences(ScopedServletUtils
					.getOuterRequest(request));

			// this is just a quick hack to get the desktops working ....
			String val = prefs.getValue(ANONYMOUS_DESKTOP_URL, null);
			if (val != null) {

				return getPath(request, val);

			}
			return null;
		}

		// Get the URL for the default postback
		PostbackURL url = PostbackURL.createPostbackURL(request, response);

		HttpSession session = request.getSession();
		String defURL = (String) session.getAttribute("_defaultURL");

		if (defURL == null) {
			// Get the desktop URL
			ResourceURL desktopURL = null;
			desktopURL = DirectorUtil.getNonDefaultDesktopURL(request, response);

			if (desktopURL != null) {
				desktopURL.addParameter(GenericURL.POSTBACK_PARAM, "true");

				// reset pageLabel
				desktopURL.removeParameter(GenericURL.PAGE_LABEL_PARAM);
				desktopURL.addParameter(GenericURL.PAGE_LABEL_PARAM,
					getPageLabel(request));

				return desktopURL.toString();

			}
			url.addParameter(GenericURL.POSTBACK_PARAM, "true");

			// reset pageLabel
			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
			url
				.addParameter(GenericURL.PAGE_LABEL_PARAM,
					getPageLabel(request));

			return url.toString();
		}
		defURL += "?" + GenericURL.LOADSTATE_PARAM + "=false";
		defURL += "&" + GenericURL.PAGE_LABEL_PARAM + "="
			+ getPageLabel(request);

		// System.out.println("logout defURL = null reconfigured - desktopURL =
		// "+ defURL);

		return defURL;

	}


	public static boolean isSSL(HttpServletRequest request) {
		return request.getScheme().equalsIgnoreCase("https");
	}


	public static String getRegisterURL(HttpServletRequest request,
		HttpServletResponse response)
	{

		// Get the URL for the default postback
		PageURL url = PageURL.createPageURL(request, response);

		url.addParameter(GenericURL.POSTBACK_PARAM, "true");

		// reset pageLabel
		url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
		url.addParameter(GenericURL.PAGE_LABEL_PARAM, REGISTER_PAGE);

		return url.toString(); // ?_nfpb=true&_nfto=false&_pageLabel=registerHome
	}

	private static String getPageLabel(HttpServletRequest request) {
		/*
		 * /Get current label //String pageLabel = (String)
		 * (ScopedServletUtils.getOuterRequest(request)).getParameter("_pageLabel");
		 * String pageLabel = "mhvHome"; //System.out.print("page Label = " +
		 * pageLabel); //get the desktop backing context DesktopBackingContext
		 * desktopBacking =
		 * DesktopBackingContext.getDesktopBackingContext(
		 * ScopedServletUtils.getOuterRequest(request));
		 * PageBackingContext pageCtx =
		 * desktopBacking.getPageBackingContextRecursive(pageLabel);
		 * BookBackingContext bookCtx = pageCtx.getParentBookBackingContext();
		 * PageBackingContext parentCtx = bookCtx.getParentPageBackingContext();
		 * return ((parentCtx != null)? parentCtx.getDefinitionLabel() :
		 * pageLabel);
		 */
		return "mhvHome";
	}

	/**
	 * Creates the nonDefaultDesktopURL
	 */
	public static ResourceURL getNonDefaultDesktopURL(
		HttpServletRequest request, HttpServletResponse response)
	{
		AppContext ac = AppContext.getAppContext(request);
		DesktopPath defaultPath = DesktopPath.createDesktopPath(ac
			.getDesktopPath());
		HashMap desktopURLs = getDesktopURLs(request, response);
		Iterator it = desktopURLs.keySet().iterator();
		DesktopDefinition destktopDefinition = null;
		ResourceURL url = null;
		ResourceURL defaultURL = null;
		ResourceURL desktopURL = null;
		DesktopPath path = null;

		while (it.hasNext()) {
			destktopDefinition = (DesktopDefinition) it.next();
			path = destktopDefinition.getDesktopDefinitionId().getDesktopPath();
			url = (ResourceURL) desktopURLs.get(destktopDefinition);

			if (!path.equals(defaultPath)) {
				if (desktopURL == null)
					desktopURL = url;
			} else {
				defaultURL = url;
			}
		}

		return (desktopURL != null) ? desktopURL : defaultURL;
	}

	public static ArrayList getNonDefaultDesktopURLs(
		HttpServletRequest request, HttpServletResponse response)
	{
		ArrayList<ResourceURL> urls = new ArrayList<ResourceURL>();

		AppContext ac = AppContext.getAppContext(request);
		DesktopPath defaultPath = DesktopPath.createDesktopPath(ac.getDesktopPath());
		HashMap desktopURLs = getDesktopURLs(request, response);
		Iterator it = desktopURLs.keySet().iterator();
		DesktopDefinition dd = null;
		ResourceURL url = null;
		DesktopPath path = null;

		while (it.hasNext()) {
			dd = (DesktopDefinition) it.next();
			path = dd.getDesktopDefinitionId().getDesktopPath();
			url = (ResourceURL) desktopURLs.get(dd);

			if (!path.equals(defaultPath)) {
				urls.add(url);
			}
		}

		return urls;
	}

	public static ResourceURL getDefaultDesktopURL(HttpServletRequest request,
		HttpServletResponse response)
	{
		AppContext ac = AppContext.getAppContext(request);
		HashMap desktopURLs = getDesktopURLs(request, response);
		Iterator it = desktopURLs.keySet().iterator();
		DesktopDefinition dd = null;
		ResourceURL url = null;

		while (it.hasNext()) {
			dd = (DesktopDefinition) it.next();
			url = (ResourceURL) desktopURLs.get(dd);

			// Return first url that doesn't match, otherwise store default URL
			if (dd.getDesktopDefinitionId().getDesktopPath().equals(
				ac.getDesktopPath()))
				return url;
		}

		// Return null if default not found (shouldn't happen)
		return null;
	}

	public static HashMap getDesktopURLs(HttpServletRequest request,
		HttpServletResponse response)
	{
		HashMap<DesktopDefinition, ResourceURL> desktopURLs =
			new HashMap<DesktopDefinition, ResourceURL>();

		try {
			AppContext ac = AppContext.getAppContext(request);

			// If this is a .portal then there will be no desktops
			if (ac.isDotPortal())
				return null;

			InitialContext ic = new InitialContext();

			DesktopDefinitionManagerHome home = (DesktopDefinitionManagerHome)
				PortableRemoteObject.narrow(ic.lookup(
					"java:comp/env/ejb/DesktopDefinitionManager"),
					DesktopDefinitionManagerHome.class);
			DesktopDefinitionManager mgr = home.create();

			CustomizationContext cc = new CustomizationContext(request);
			cc.setVisitorMode(true);

			String currentPortalPath = ac.getPortalPath();

			DesktopDefinition[] dd = mgr.getDesktopDefinitions(cc, ac
				.getWebAppName());
			String contextPath = request.getContextPath();
			ArrayList<DesktopDefinition> pdd = new ArrayList<DesktopDefinition>();

			for (int i = 0; i < dd.length; i++) {
				DesktopDefinition desktopDefinition = dd[i];
				DesktopDefinitionId id = desktopDefinition
					.getDesktopDefinitionId();
				String portalPath = id.getPortalPath().getPath();

				if (portalPath.equals(currentPortalPath))
					pdd.add(dd[i]);
			}

			for (int i = 0; i < pdd.size(); i++) {
				DesktopDefinition desktopDefinition = pdd.get(i);
				ResourceURL url = ResourceURL.createResourceURL(request,
					response);
				DesktopDefinitionId id = desktopDefinition
					.getDesktopDefinitionId();
				String portalPath = id.getPortalPath().getPath();

				String desktopPath = id.getDesktopPath().getPath();
				String path = contextPath + "/appmanager/" + portalPath + "/"
					+ desktopPath;
				url.setPath(path);
				url.addParameter(GenericURL.LOADSTATE_PARAM, "false");
				desktopURLs.put(desktopDefinition, url);
			}
		}

		catch (Exception e) {
			// e.printStackTrace();
		}

		return desktopURLs;
	}

	/**
	 * Get the URL of the anonymous portal's default page. This can be used to
	 * redirect users to the 'home' page in the event that they are logged out
	 * or that their session has expired.
	 * @return The URL to the default anonymous portal page
	 */
	public static final String getDefaultAnonymousPortalPage(
		HttpServletRequest request, HttpServletResponse response)
	{
		String defaultProtocol = "";

		PostbackURL url = PostbackURL.createPostbackURL(request, response);

		if (!isSSL(request)){
			defaultProtocol = "https";
			url.setScheme(defaultProtocol);

			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
			url.addParameter(GenericURL.PAGE_LABEL_PARAM, "mhvHome");
			url.setPath("/" + AppContext.getAppContext(request).getWebAppName()
					+ "/anonymous.portal");

			if (LOG.isDebugEnabled()) {
				LOG.debug("In the getDefaultAnonymousPortalPage method: The final secured URL in the backing file util class: " + url);
			}

			//System.out.println("In anonymous portal::getDefaultAnonymousPortalPage method::" + url.toString());
			return url.toString();
		}
		else{
			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
			url.addParameter(GenericURL.PAGE_LABEL_PARAM, "mhvHome");
			url.setPath("/" + AppContext.getAppContext(request).getWebAppName()
				+ "/anonymous.portal");
			return url.toString();
		}
	}
	

	/**
	 * Creates the URL for the admin portal's default page.
	 * @param request The request to build the URL from.
	 * @param response The response used to build the URL from.
	 * @return The URL for the default admin portal page.
	 */
	public static final String getDefaultAdminPortalPage(
		HttpServletRequest request, HttpServletResponse response)
	{
		PostbackURL url = PostbackURL.createPostbackURL(request, response);
		url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
		url.addParameter(GenericURL.PAGE_LABEL_PARAM, "homeLoginPage");
		url.setPath("/" + AppContext.getAppContext(request).getWebAppName()
			+ "/mhvAdministration.portal");
		return url.toString();
	}


	/**
	 * Creates the URL for the Change Password portlet when changing a
	 * temporary password.
	 * Note that the URL will be redirecting to a separate (TandC) portal,
	 * to avoid allowing the user to porceed without changing the password.
	 * @param request The request to build the URL from.
	 * @return The URL for the Change Password.
	 */
	public static final String getChangeTemporaryPasswordURL(
		HttpServletRequest request)
	{
		return getPortletUrl(request, T_AND_C_DESKTOP_URL,
			DefinitionLabelConstants.CHANGE_PASSWORD_PAGE,
			DefinitionLabelConstants.CHANGE_PASSWORD_PORTLET,
			ChangePasswordController.class, null);
	}

	/**
	 * Creates the URL for the Contact MHV/Contact Us portlet.
	 * @param request The request to build the URL from.
	 * @return The URL for contact MHV.
	 */
	public static final String getContactUsURL(HttpServletRequest request) {
		return getPortletUrl(request, ANONYMOUS_DESKTOP_URL,
			DefinitionLabelConstants.CONTACT_US_PAGE,
			DefinitionLabelConstants.CONTACT_US_PORTLET,
			ChangePasswordController.class, null);
	}

	/**
	 * Creates the URL for the Forgot Password portlet.
	 * @param request The request to build the URL from.
	 * @return The URL for Forgot Password .
	 */
	public static final String getForgotPasswordURL(HttpServletRequest request) {
		return getPortletUrl(request, ANONYMOUS_DESKTOP_URL,
			DefinitionLabelConstants.FORGOT_PASSWORD_PAGE,
			DefinitionLabelConstants.FORGOT_PASSWORD_PORTLET,
			ForgotPasswordController.class, null);
	}

	private static final String getPortletUrl(HttpServletRequest request,
		String portalLabel, String pageLabel, String portletLabel,
		Class controllerClass, String actionName)
	{
		PortletBackingContext ptCtx = PortletBackingContext
			.getPortletBackingContext(ScopedServletUtils.getOuterRequest(
			request));
		Precondition.assertTrue(ptCtx != null,
			"No portlet backing context found. Cannot create URL for portal="
			+ portalLabel + ";page=" + pageLabel + ";portlet=" + portletLabel
			+ (StringUtils.isBlank(actionName) ? "" : ";action=" + actionName));

		PortletPreferences prefs = ptCtx.getPortletPreferences(
			ScopedServletUtils.getOuterRequest(request));
		if (StringUtils.isBlank(portalLabel)) {
			portalLabel = AUTHENTICATED_DESKTOP_URL;
		}

		// this is just a quick hack to get the desktops working ....
		String portalName = prefs.getValue(portalLabel, null);
		String url = null;
		if (portalName != null) {
			url = getActionPath(request, portalName, pageLabel, portletLabel,
				controllerClass, actionName);
		}
		return url;
	}

	private static String getActionPath(HttpServletRequest request,
		String portalName, String pageLabel, String portletLabel,
		Class controllerClass, String actionName)
	{
		Precondition.assertNotNull("request", request);
		Precondition.assertNotNull("portalName", portalName);
		Precondition.assertNotNull("pageLabel", pageLabel);
		Precondition.assertNotNull("portletLabel", portletLabel);
		Precondition.assertNotNull("controllerClass", controllerClass);

		/**
		 *  CR 3023: forcing each and every request to be https (secured protocol) instead of http
		 */
		String protocol = "https://";

		/*
		if (isSSL(request)) {
			protocol = "https://";
		} else {
			protocol = "http://";
		}
		*/


		StringBuffer actionOverride = new StringBuffer();
		if (!StringUtils.isBlank(actionName)) {
			String overrideName = urlEncode(portletLabel + "_actionOverride");
			String overrideValue = urlEncode("/" + controllerClass.getPackage().
				getName().replace('.', '/') + "/" + actionName);
			if ((overrideName != null) && (overrideValue != null)) {
				actionOverride.append("&").append(overrideName).append("=").
					append(overrideValue);
			} else {
				LOG.error("Failed to redirect controller "
					+ controllerClass.getName() + " to proper action '"
					+ actionName
					+ "'. Could not create _actionOverride parameter");
			}
		}

		StringBuffer strBuf = new StringBuffer(protocol).append(request
			.getServerName());
		strBuf.append(":").append(request.getServerPort()).append(
			request.getContextPath()).append("/").append(portalName)
			.append("?").append(GenericURL.LOADSTATE_PARAM).append("=false&")
			.append(GenericURL.POSTBACK_PARAM).append("=true&").append(
				GenericURL.TREE_OPTIMIZATION_PARAM).append("=true&").append(
				GenericURL.PAGE_LABEL_PARAM).append("=").append(pageLabel)
			.append(actionOverride.toString());

		// System.out.println("URL: -> "+ strBuf.toString());
		return strBuf.toString();
	}

	private static String urlEncode(String value) {
		final String ENCODING = "UTF-8";
		try {
			return URLEncoder.encode(value, ENCODING);
		} catch (UnsupportedEncodingException e) {
			LOG.error("Failed to encode part of URL " + value, e);
			return null;
		}
	}

	public static final String getLoggedOutVAAFIPage(HttpServletRequest request, 
			HttpServletResponse response) {
		String defaultProtocol = "";
		PostbackURL url = PostbackURL.createPostbackURL(request, response);
		URL vaafiURL = null;
		String protocol = request.getScheme();
		String serverName = request.getServerName();		
		String urlFile = "/" + "pkmslogout?filename=mhv-logout.html";

		try {
			vaafiURL = new URL(protocol, serverName, urlFile);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		if (!isSSL(request)){
			defaultProtocol = "https";
			url.setScheme(defaultProtocol);
			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);

			if (LOG.isDebugEnabled()) {
				LOG.debug("In the getLoggedOutVAAFIPage method: The final secured URL in the backing file util class: " + url.toString());
			}
		}
		else{
			url.removeParameter(GenericURL.PAGE_LABEL_PARAM);
		}
		if (LOG.isDebugEnabled()) {
			LOG.debug("In the getLoggedOutVAAFIPage method: The final VAAFI URL in the backing file util class: " + vaafiURL.toString());
		}		
		return vaafiURL.toString();
		
	}
}
