/**
 * 
 */
package gov.va.med.mhv.usermgmt.util;

import org.displaytag.decorator.TableDecorator;

import gov.va.med.mhv.core.web.displaytag.model.AbstractRowSorter;
import gov.va.med.mhv.usermgmt.transfer.EmergencyContact;

/**
 * @author Rob Proper
 *
 */
public class EmergencyContactSorter extends AbstractRowSorter {

    private static final String NAME_PROPERTY = "name";
    
    /**
     * @param arg0
     * @param arg1
     * @param arg2
     */
    public EmergencyContactSorter(String propertyName, 
        TableDecorator tableDecorator, boolean isAscending) 
    {
        super(propertyName, tableDecorator, isAscending);
    }

    @Override
    protected int compareValues(Object object1, Object object2) {
        EmergencyContact contact1 = (EmergencyContact) object1; 
        EmergencyContact contact2 = (EmergencyContact) object2;

        // Sort on primary first
        if ((contact1 != null) && contact1.getIsPrimary()) {
            return -1; 
        }
        if ((contact2 != null) && contact2.getIsPrimary()) {
            return 1;
        }
        // Sort on name second
        String name1 = (String) getDecoratedValue(contact1, NAME_PROPERTY);
        if (name1 == null) {
            return -1;
        }
        String name2 = (String) getDecoratedValue(contact2, NAME_PROPERTY);
        if (name2 == null) {
            return 1;
        }
        return name1.compareToIgnoreCase(name2);
    }
    

}
